<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: groups.php,v2.0 2017/09/30 advocat Exp $ */

/** include files */
include('./inc.php');

/** check access */
check_access('settings');

if (!isset($_GET['act'])) {
    $_GET['act'] = "";
} if (!isset($_GET['id'])) {
    $_GET['id'] = "";
}

/** DB table and module */
$tbl_name   = $system['prefix'].'_groups';
$module     = 'groups';

$sort_field_array 	= array('id','name','style_id','tpl_id');
$sort_field			= 'name';
$sort_order 		= 'asc';
$sort_page			= $_SERVER['PHP_SELF'].'?';

if (isset($_GET['sf']) && in_array($_GET['sf'], $sort_field_array)) $sort_field = $_GET['sf'];
if (isset($_GET['so']) && ($_GET['so'] == 'asc' || $_GET['so'] == 'desc')) $sort_order = $_GET['so'];

/** styles */
$styles = array();
$res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_styles` ORDER BY `name`");
while ($row = mysqli_fetch_assoc($res)) {
    $styles[$row['id']] = $row['name'];
}

/** templates */
$templates = array();
$res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_templates` ORDER BY `name`");
while ($row = mysqli_fetch_assoc($res)) {
    $templates[$row['id']] = $row['name'];
}

/** view groups */
if (!$_GET['act']) {
    /** print header */
    do_header($i18n['groups']['title'], 'search_groups');
    ?><table width="100%"  border="0" cellspacing="10" cellpadding="0">
<tr><td align="center"><a class=strong href="<?php echo $_SERVER['PHP_SELF'].'?act=add';?>"><?php echo $i18n['groups']['add'];?></a></td></tr></table>
<script language="javascript" type="text/javascript"><!--
function do_delete (id) {
    if (confirm('<?php echo addslashes($i18n['groups']['confirm_delete']); ?>')) document.location.href = '<?php echo $_SERVER['PHP_SELF'].'?act=delete&id='; ?>' + id;
} function do_delete_default (id) {
    alert ('<?php echo addslashes($i18n['groups']['delete_default']); ?>');
}
//--></script>
<table width="96%" border="0" align="center" cellpadding="4" cellspacing="0" bgcolor="#FFFFFF" class=tbl_res>
<thead><tr>
<td height="30" width="24">id<?php gui_sort('id');?></td>
<td><?php echo $i18n['groups']['name'];  gui_sort('name');?></td>
<td><?php echo $i18n['groups']['style']; gui_sort('style_id');?></td>
<td><?php echo $i18n['groups']['tpl'];  gui_sort('tpl_id');?></td>
<td width="61">&nbsp;</td>
<td width="53">&nbsp;</td>
<td width="43">&nbsp;</td>
</tr></thead>
<tbody><?php
    $res = mysqli_query($db_connect, "SELECT * FROM `{$tbl_name}` ORDER BY `{$sort_field}` {$sort_order}");
    $cnt = mysqli_num_rows($res);
    while ($row = mysqli_fetch_assoc($res)) {
        ?><tr><td class="bottomline"><?php echo $row['id']; ?></td>
<td class="bottomline"><b><?php echo $row['name']; ?></b></td>
<td class="bottomline"><?php if (isset($styles[$row['style_id']])) echo $styles[$row['style_id']]; else echo $i18n['groups']['unknown']; ?></td>
<td class="bottomline"><?php if (isset($templates[$row['tpl_id']])) echo $templates[$row['tpl_id']]; else echo $i18n['groups']['unknown']; ?></td>
<td class="bottomline"><a href="<?php echo $_SERVER['PHP_SELF'].'?act=edit&id='.$row['id']; ?>"><img src="../img/i18n/act_prop.gif" alt="<?php echo $i18n['groups']['act_prop']; ?>" width="57" height="14" border="0"></a></td>
<td class="bottomline"><a href="<?php echo $_SERVER['PHP_SELF']; ?>?act=code&id=<?php echo $row['id']; ?>"><img src="../img/i18n/act_code.gif" alt="<?php echo $i18n['groups']['act_get_code']; ?>" width="49" height="14" border="0"></a></td>
<td class="bottomline"><a href="javascript:do_delete<?php if ($cnt == 1) echo '_default'; ?>('<?php echo $row['id']; ?>');"><img src="../img/i18n/act_delete.gif" alt="<?php echo $i18n['groups']['act_delete']; ?>" width="39" height="14" border="0"></a></td>
</tr><?php
    }
    ?></tbody></table><?php
    /** print footer */
    do_footer(0,5,5);
}
/** elseif act add / edit */
elseif ($_GET['act'] == 'add' || $_GET['act'] == 'edit' && is_numeric($_GET['id'])) {
    $error = false;
    
    $res_cnt = mysqli_query($db_connect, "SELECT COUNT(*) FROM `{$tbl_name}`");
    // Get count
    $row = mysqli_fetch_row($res_cnt);
    $cnt = intval($row[0] ?? 0);
    
    if ($cnt == 1) {
        $enable = 1;
    } else {
        if (!isset($_POST['enable'])) $enable = 0;
        else $enable = 1;
    }
    
    /** add */
    if ($_GET['act'] == 'add') {
        $title_image = 'add_new_group';
        if (isset($_POST['submit'])) {
            if (!$_POST['name']) $error = true;
            if (!$error) {
                $sql = array('name'=>$_POST['name'], 'start_urls'=>addslashes(serialize(config_url2array($_POST['start_urls']))),'allow_urls'=>addslashes(serialize(config_url2array($_POST['allow_urls']))), 'style_id'=>$_POST['style_id'], 'tpl_id'=>$_POST['tpl_id'], 'enable'=>$enable);
                mysqli_query($db_connect, "INSERT INTO `{$tbl_name}` SET ".array2sql($sql));
                $id = mysqli_insert_id($db_connect);
                /** add log */
                a_logs($module, "add", "Add new group ".$sql['name'].", id: ".$id);
                header("Location: ".$_SERVER['PHP_SELF']);
                exit;
            } else {
                $prop = array('name'=>$_POST['name'], 'start_url'=>slashes($_POST['start_url'],1), 'style_id'=>$_POST['style_id'], 'tpl_id'=>$_POST['tpl_id'], 'enable'=>$enable);
            }
        } else {
            $prop = array('name'=>'', 'start_urls'=>addslashes(serialize(array())), 'allow_urls'=>addslashes(serialize(array())), 'style_id'=>0, 'tpl_id'=>0, 'enable'=>1);
        }
    }
    /** edit */
    else {
        $res = mysqli_query($db_connect, "SELECT * FROM `{$tbl_name}` WHERE `id`='{$_GET['id']}'");
        $row = mysqli_fetch_array($res);
        if (!isset($row['id'])) {
            header("Location: ".$_SERVER['PHP_SELF']);
            exit;
        }
        $title_image = 'group_properties';
        if (isset($_POST['submit'])) {
            $sql = array('name'=>$_POST['name'], 'start_urls'=>addslashes(serialize(config_url2array($_POST['start_urls']))),'allow_urls'=>addslashes(serialize(config_url2array($_POST['allow_urls']))), 'style_id'=>$_POST['style_id'], 'tpl_id'=>$_POST['tpl_id'], 'enable'=>$enable);
            mysqli_query($db_connect, "UPDATE `{$tbl_name}` SET ".array2sql($sql)." WHERE `id`='{$_GET['id']}'");
            $id = mysqli_insert_id($db_connect);
            /** add log */
            a_logs($module, "update", "Update group ".$sql['name'].", id: ".$id);
            header("Location: ".$_SERVER['PHP_SELF']);
            exit;
        } else {
            $prop = $row;
        }
    }
    /** print header */
    do_header($i18n['groups']['title'],$title_image);
    ?><p align="center"><br /><a class=strong href="<?php echo $_SERVER['PHP_SELF'];?>"><?php echo $i18n['groups']['list'];?></a></p>
    <form action="<?php echo $_SERVER['PHP_SELF'].'?act='.$_GET['act']; if ($_GET['id']) echo '&id='.$_GET['id']; ?>" method="post" name="frm_prop" id="frm_prop" onSubmit="return check_form('frm_prop');">
<script language="javascript" type="text/javascript"><!--
<?php if ($error) echo "alert('".$i18n['groups']['empty_name']."');"; ?>
function check_form (form_name) {
    var form = document.forms[form_name];
    var tmp = form.elements['name'];
    if (tmp.value == "" || tmp.value.length == 0) {
        alert('<?php echo $i18n['groups']['empty_name']; ?>');
        tmp.focus();
        return false;
    }
    return true;
}
//--></script>

<table width="100%" border="0" cellpadding="0" cellspacing="5">
<tr><td width="10%">&nbsp;</td>
<td><table width="100%" border="0" cellpadding="5" cellspacing="0">
<tr><td width="40%" class="bottomline"><?php echo $i18n['groups']['name']; ?> :</td>
<td class="bottomline"><input name="name" type="text" class="field" id="name" size="32" maxlength="64" value="<?php echo $prop['name']; ?>"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['groups']['start_urls']; ?> :</td>
<td class="bottomline"><textarea name="start_urls" rows="8" class="field" id="start_urls" style="width:100%;"><?php echo config_array2url(unserialize(stripslashes($prop['start_urls']))); ?></textarea></td></tr>
<tr><td class="bottomline"><?php echo $i18n['groups']['allow_urls']; ?> :</td>
<td class="bottomline"><textarea name="allow_urls" rows="8" class="field" id="allow_urls" style="width:100%;"><?php echo config_array2url(unserialize(stripslashes($prop['allow_urls']))); ?></textarea></td></tr>
<tr><td class="bottomline"><?php echo $i18n['groups']['style']; ?></td>
<td class="bottomline"><select name="style_id" id="style_id" class="field"><?php
    foreach ($styles as $key => $value) {
        print '<option value="'.$key.'"';
        if ($key == $prop['style_id']) print ' selected';
        print '>'.$value.'</option>';
    }
    ?></select></td></tr>
<tr><td class="bottomline"><?php echo $i18n['groups']['tpl']; ?></td>
<td class="bottomline"><select name="tpl_id" id="tpl_id" class="field"><?php
    foreach ($templates as $key => $value) {
        print '<option value="'.$key.'"';
        if ($key == $prop['tpl_id']) print ' selected';
        print '>'.$value.'</option>';
    }
    ?></select></td></tr>
<tr><td><?php echo $i18n['groups']['enable']; ?> :</td>
<td><input name="enable" type="checkbox" value="1" <?php if ($prop['enable']) echo 'checked'; ?>></td></tr>
</table></td></tr>
<tr><td class="topline">&nbsp;</td>
<td>&nbsp;</td></tr>
<tr><td colspan="2" class="commentBox"><span class="required">*</span> <span class="comment"><?php echo $i18n['groups']['comment'];?></span></td></tr>
<tr align="center"><td colspan="2"><input name="submit" type="submit" class="button" id="submit" value=":: <?php echo $i18n['button']['save']; ?> ::"></td>
</tr></table>
</form><?php
    /** print footer */
    do_footer(0,5,5);
}
/** get installation code */
elseif ($_GET['act'] == "code" && is_numeric($_GET['id'])) {
    $res = mysqli_query($db_connect, "SELECT * FROM `{$tbl_name}` WHERE `id`='{$_GET['id']}'");
    $row = mysqli_fetch_array($res);

    /** if exists style id */
    if (isset($row['id'])) {
        if (!isset($styles[$row['style_id']])) {
            reset($styles);
            $style_id = key($styles);
        } else {
            $style_id = $row['style_id'];
        }
        if (!isset($templates[$row['tpl_id']])) {
            reset($templates);
            $tpl_id = key($templates);
        } else {
            $tpl_id = $row['tpl_id'];
        }
        
        $group_id = $row['id'];
        
        do_header($i18n['code']['title'],"get_install_code");
        ?><table width="100%"  border="0" cellpadding="0" cellspacing="10">
<tr><td class="thead" style="padding:5px;"><?php echo $i18n['code']['code_1']; ?></td></tr>
<tr><td class="code"><?php
        ob_start();
        define   ('SSP_INC',     true);
        define('SSP_STYLEID', $style_id);
        define('SSP_TPLID',   $tpl_id);
        define('SSP_GROUPID', $group_id);
        @include("../form.php");
        $content = ob_get_contents();
        ob_end_clean();
        echo nl2br(htmlspecialchars($content));
        ?></td></tr>
<tr><td class="commentBox"><span class=required><?php echo $i18n['code']['description']; ?>:</span> <span class=comment><?php echo $i18n['code']['code_1_desc']; ?></span></td></tr>
<tr><td class="thead" style="padding:5px;"><?php echo $i18n['code']['code_2']; ?></td></tr>
<tr><td class="code">&lt;!-- Start of Site Search Pro code --&gt;<br>
&lt;script language="JavaScript"&gt;&lt;!--<br>
var remoteURL = '<?php echo $config['site_addr'];?>';<br>var sURL = remoteURL +'<?php echo (!empty($config['folder']) ? chr(47).$config['folder'] : '') ?>/form.php?mode=js&amp;g=<?php echo $group_id; ?>&amp;s=<?php echo $style_id; ?>&amp;t=<?php echo $tpl_id;?>';<br>document.write('&lt;script language=&quot;JavaScript&quot;' +<br>'src=&quot;' + sURL + '&quot;&gt;&lt;\/script&gt;');<br>//--&gt;&lt;/script&gt;<br>
&lt;!-- End of Site Search Pro code --&gt;</td></tr>
<tr><td class="commentBox"><span class=required><?php echo $i18n['code']['description']; ?>:</span> <span class=comment><?php echo $i18n['code']['code_2_desc']; ?></span></td></tr>
<tr><td class="thead" style="padding:5px;"><?php echo $i18n['code']['code_3']; ?></td></tr>
<tr><td class="code">&lt;!-- Start of Site Search Pro code --&gt;<br>
&lt;iframe align=top width=<b>200</b> height=<b>80</b> marginwidth=0 marginheight=0 hspace=0 vspace=0 frameborder=0 scrolling=no src=&quot;<?php echo $config['site_addr'] . (!empty($config['folder']) ? chr(47).$config['folder'] : '')?>/form.php?g=<?php echo $group_id; ?>&s=<?php echo $style_id; ?>&amp;t=<?php echo $tpl_id;?>&quot;&gt;&lt;/iframe&gt;<br>
&lt;!--
End of Site Search Pro code --&gt;</td></tr>
<tr><td class="commentBox"><span class=required><?php echo $i18n['code']['description']; ?>:</span> <span class=comment><?php echo $i18n['code']['code_3_desc']; ?></span></td></tr>
<tr><td class="thead" style="padding:5px;"><?php echo $i18n['code']['code_4']; ?></td></tr>
<tr><td class="code"><?php
        $code = '<?php
define(\'SSP_STYLEID\', '.$style_id.');
define(\'SSP_TPLID\',   '.$tpl_id.');
define(\'SSP_GROUPID\', '.$group_id.');
@include (\''.SSP_DIR.'/form.php\');
?>';
        echo highlight_string($code, true);
        ?></td></tr>
<tr><td class="commentBox"><span class=required><?php echo $i18n['code']['description']; ?>:</span> <span class=comment><?php echo $i18n['code']['code_4_desc']; ?></span></td></tr></table>
<?php
        /** print footer */
        do_footer(0,5,5);
    } else {
        header("Location: {$_SERVER['PHP_SELF']}");
        exit;
    }
}

/** act delete */
elseif ($_GET['act'] == "delete" && is_numeric($_GET['id'])) {
    $res = mysqli_query($db_connect, "SELECT * FROM `{$tbl_name}` WHERE `id`='{$_GET['id']}'");
    $row = mysqli_fetch_array($res);
    if (isset($row['id'])) {
        /** delete */
        mysqli_query($db_connect, "DELETE FROM `{$tbl_name}` WHERE `id`='{$row['id']}'");
        /** add log */
        a_logs($module,"delete","Delete group: {$row['name']}, id: {$row['id']}");
    }
    header("Location: {$_SERVER['PHP_SELF']}");
    exit;
}
/** else */
else {
    header("Location: {$_SERVER['PHP_SELF']}");
    exit;
}

?>