<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: inc.php,v2.0 2017/09/29 advocat Exp $ */

/** define path */
define('SSP_DIR', str_replace('\\','/',realpath('../')));

/** include fixer */
include_once (SSP_DIR.'/data/fixer.php');

/** session start */
session_start();

/** check installed */
if (!file_exists(SSP_DIR.'/data/db.php') || !file_exists(SSP_DIR.'/data/config.php')) {
    header("Location: ../install.php");
    exit;
}

/** destination vars */
$limit_on_page  = 10;
$loggon         = true;

/** include files */
include_once (SSP_DIR.'/data/db.php');
include_once (SSP_DIR.'/data/config.php');
include_once (SSP_DIR.'/data/system.php');
include_once (SSP_DIR.'/data/i18n.php');
include_once (SSP_DIR.'/data/functions.php');

/** connect to DB */
$db_connect = mysqli_connect($db['host'],$db['login'],$db['passwd']);
$db_select  = mysqli_select_db($db_connect, $db['name']);

/** if exists session admin */
if (!isset($_SESSION['admin'])) {
    $loggon = false;
} if (isset($_SESSION['admin']['username']) && isset($_SESSION['admin']['password'])) {
    $res = mysqli_query($db_connect, "SELECT COUNT(*) FROM `{$system['prefix']}_admins` WHERE BINARY `username`='{$_SESSION['admin']['username']}' and BINARY `password`='{$_SESSION['admin']['password']}'");
    // Get count
    $row = mysqli_fetch_row($res);
    $result = intval($row[0] ?? 0);
    if ($result < 1) {
        $loggon = false;
    }
} else {
    $loggon = false;
}

/** check loggon */
if ($loggon == false) {
    header("Location: ./login.php");
    exit();
}

/** ip address */
if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) $ip_addr = $_SERVER['REMOTE_ADDR'].":".$_SERVER['HTTP_X_FORWARDED_FOR'];
elseif (getHostByAddr($_SERVER['REMOTE_ADDR']) != $_SERVER['REMOTE_ADDR']) $ip_addr = $_SERVER['REMOTE_ADDR']."";
else $ip_addr = $_SERVER['REMOTE_ADDR'];

$welcome_prop['ip_addr'] = $ip_addr;

/** browser */
$u_agent = $_SERVER['HTTP_USER_AGENT'];
if (preg_match("/(opera) ([0-9]{1,2}.[0-9]{1,3}){0,1}/i",$u_agent,$st_regs) || preg_match("/(opera)([0-9]{1,2}.[0-9]{1,3}){0,1}/i",$u_agent,$st_regs)) {$st_brows = "Opera "; $st_ver = $st_regs[2];
} elseif(preg_match("%(konqueror/)/([0-9]{1,2}.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "KONQ"; $st_ver = $st_regs[2]; $st_sys = "Linux ";
} elseif(preg_match("%(lynx)/([0-9]{1,2}.[0-9]{1,2}.[0-9]{1,2})%i",$u_agent,$st_regs) ) {$st_brows = "Lynx "; $st_ver = $st_regs[2];
} elseif(preg_match("%(links) \(([0-9]{1,2}.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "Links "; $st_ver = $st_regs[2];
} elseif(preg_match("%(omniweb/)([0-9]{1,2}.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "OmniWeb "; $st_ver = $st_regs[2];
} elseif(preg_match("%(webtv/)([0-9]{1,2}.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "WebTV "; $st_ver = $st_regs[2];
} elseif(preg_match("%(msie) ([0-9]{1,2}.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "MS Internet Explorer "; $st_ver = $st_regs[2];
} elseif(preg_match("%(Firefox/)([0-9]{1,2}.[0-9]{1,2}.[0-9]{1,2})%i",$u_agent,$st_regs)) {$st_brows = "Mozzila Firefox "; $st_ver = $st_regs[2];
} elseif(preg_match("%(netscape6)/(6.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "Netscape Navigator "; $st_ver = $st_regs[2];
} elseif(preg_match("%(rv:)([0-9]{1,2}.[0-9]{1,2})(\))( ){0,1}(Gecko/)%i",$u_agent,$st_regs)) {$st_brows = "Mozzila "; $st_ver = $st_regs[2];
} elseif(preg_match("%(mozilla)/([0-9]{1,2}.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "Netscape Navigator ";      $st_ver = $st_regs[2];
} elseif(preg_match("%w3m/i",$u_agent)) {$st_brows = "w3m%i";
} elseif(preg_match("%(scooter)-([0-9]{1,2}.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "Scooter"; $st_ver = $st_regs[2];
} elseif(preg_match("%(w3c_validator)/([0-9]{1,2}.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "W3C"; $st_ver = $st_regs[2];
} elseif(preg_match("%(googlebot)/([0-9]{1,2}.[0-9]{1,3})%i",$u_agent,$st_regs)) {$st_brows = "Google"; $st_ver = $st_regs[2];
} else { $st_brows = $i18n['welcome']['unknown']; $st_ver = "";
}
$welcome_prop['browser'] = $st_brows.$st_ver;

/** os */
$u_agent = $_SERVER['HTTP_USER_AGENT'];
if (preg_match("%linux%i",$u_agent)) {$st_sys = "Linux";
} elseif(preg_match("%Win 9x 4.90%i",$u_agent)) {$st_sys = "MS Windows Me";
} elseif(preg_match("%win32%i",$u_agent)) {$st_sys = "Win 32";
} elseif(preg_match("%windows 2000%i",$u_agent)) {$st_sys = "MS Windows 2000";
} elseif((preg_match("%(win)([0-9]{2})%i",$u_agent,$st_regs)) || (preg_match("%(windows) ([0-9]{2})%i",$u_agent,$st_regs))) {$st_sys = "MS Windows ".$st_regs[2];
} elseif(preg_match("%(windows nt)( ){0,1}(5.0)%i",$u_agent,$st_regs)) {$st_sys = "MS Windows 2000";
} elseif(preg_match("%(windows nt)( ){0,1}(5.1)%i",$u_agent,$st_regs)) {$st_sys = "MS Windows XP";
} elseif(preg_match("%(winnt)([0-9]{1,2}.[0-9]{1,2}){0,1}%i",$u_agent,$st_regs)) {$st_sys = "MS Windows NT".$st_regs[2];
} elseif(preg_match("%(windows nt)( ){0,1}([0-9]{1,2}.[0-9]{1,2}){0,1}%i",$u_agent,$st_regs)) {$st_sys = "MS Windows NT".$st_regs[3];
} elseif(preg_match("%PPC%i",$u_agent) || preg_match("%Mac_PowerPC%i",$u_agent)) {$st_sys = "Mac PPC";
} elseif(preg_match("%mac%i",$u_agent)) {$st_sys = "Mac";
} elseif(preg_match("%(sunos) ([0-9]{1,2}.[0-9]{1,2}){0,1}%i",$u_agent,$st_regs)) {$st_sys = "SunOS"; $st_sysver = $st_regs[2];
} elseif(preg_match("%(beos) r([0-9]{1,2}.[0-9]{1,2}){0,1}%i",$u_agent,$st_regs)) {$st_sys = "BeOS"; $st_sysver = $st_regs[2];
} elseif(preg_match("%freebsd%i",$u_agent)) {$st_sys = "FreeBSD";
} elseif(preg_match("%openbsd%i",$u_agent)) {$st_sys = "OpenBSD";
} elseif(preg_match("%irix%i",$u_agent)) {$st_sys = "IRIX";
} elseif(preg_match("%os/2%i",$u_agent)) {$st_sys = "OS/2";
} elseif(preg_match("%plan%i9",$u_agent)) {$st_sys = "Plan9";
} elseif(preg_match("%unix%i",$u_agent) || preg_match("hp-ux",$u_agent) ) {$st_sys = "Unix";
} elseif(preg_match("%osf%i",$u_agent)) {$st_sys = "OSF";
} elseif(preg_match("%X11%i",$u_agent) && !isset($st_sys)) {$st_sys = "Unix";
} else { $st_sys = $i18n['welcome']['unknown'];
}
$welcome_prop['os'] = $st_sys;

/**
* design print header function
* @param string $title the page title
* @param string $image the page image
*/
function do_header ($title, $image)
{
    global $i18n, $welcome_prop, $system;
    ?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head>
<title><?php echo $system['name']; ?> :: <?php echo $title; ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="../styles.css" rel="stylesheet" type="text/css">
<script language="JavaScript"><!--
function tableruler(){if(document.getElementById&&document.createTextNode){var tables=document.getElementsByTagName('table');for(var i=0;i<tables.length;i++){if(tables[i].className=='tbl_res'){var trs=tables[i].getElementsByTagName('tr');for(var j=0;j<trs.length;j++){if(trs[j].parentNode.nodeName!='THEAD'){trs[j].onmouseover=function(){this.className='tbl_sel';return false};trs[j].onmouseout=function(){this.className='';return false}}}}}}}
//--></script>
</head><body>
<table width="778" border="0" align="center" cellpadding="5" cellspacing="10">
<tr valign="top">
<td style="border:1px solid #C0C0C0; background-color:#FFFFFF;"><table width="100%"  border="0" cellspacing="0" cellpadding="0">
<tr style="background-image:url(../img/bg-header.gif);">
<td width="209"><img src="../img/i18n/_adminzone.gif" alt="<?php echo $i18n['admin']['zone']; ?>" width="150" height="30"></td>
<td align="right"><img src="../img/cdcover-top.gif" alt="" width="115" height="30"></td></tr>
<tr><td><img src="../img/px.gif" alt="" width="209" height="5"></td>
<td align="right"><img src="../img/cdcover-back.gif" alt="" width="120" height="5"></td></tr>
<tr style="background-color:#EDEDED;" valign="top">
<td><a href="./"><img src="../img/logotype.gif" alt="" width="209" height="77" border="0"></a></td>
<td align="right"><img src="../img/cdcover.gif" alt="" width="270" height="105"></td></tr></table></td>
<td width="218" style="border:1px solid #C0C0C0; background-color:#FFFFFF;"><table width="100%"  border="0" cellspacing="0" cellpadding="0">
<tr><td bgcolor="#C75D60"><img src="../img/px.gif" alt="" width="100%" height="5"></td></tr>
<tr><td bgcolor="#AC1015"><img src="../img/i18n/_accountprofile.gif" alt="<?php echo $i18n['admin']['account_profile']; ?>" width="119" height="25"></td></tr>
<tr><td><table width="100%" border="0" align="center" cellpadding="0" cellspacing="3">
<tr><td nowrap><?php echo $i18n['welcome']['username'];?>:</td>
<td align="right"><strong><?php echo $_SESSION['admin']['username'];?></strong></td></tr>
<tr><td colspan="2"><img src="../img/px.gif" alt="" width="100%" height="3"></td></tr>
<tr><td nowrap><?php echo $i18n['welcome']['email'];?>:</td>
<td align="right"><a href="mailto:<?php echo $_SESSION['admin']['email'];?>"><?php echo $_SESSION['admin']['email'];?></a></td></tr>
<tr><td nowrap><?php echo $i18n['welcome']['fullname'];?>:</td>
<td align="right"><?php echo $_SESSION['admin']['fullname'];?></td></tr>
<tr><td nowrap><?php echo $i18n['welcome']['ip_addr'];?>:</td>
<td align="right"><?php echo $welcome_prop['ip_addr'];?></td></tr>
<tr><td nowrap><?php echo $i18n['welcome']['browser'];?>:</td>
<td align="right"><?php echo $welcome_prop['browser'];?></td></tr>
<tr><td nowrap><?php echo $i18n['welcome']['os'];?>:</td>
<td align="right"><?php echo $welcome_prop['os'];?></td></tr></table></td></tr></table></td></tr>
<tr valign="top">
<td style="border:1px solid #C0C0C0; background-color:#FFFFFF;"><table width="100%"  border="0" cellspacing="0" cellpadding="0">
<tr><td bgcolor="#5D7999"><img src="../img/px.gif" alt="" width="100%" height="5"></td></tr>
<tr><td bgcolor="#284465"><img src="../img/head_li.gif" alt="" width="29" height="25"><img src="../img/i18n/<?php echo $image; ?>.gif" alt="<?php echo $title; ?>" width="150" height="25"></td></tr>
<tr><td><!-- context --><?php
}

/**
 * design print footer function
 * @param int $system_summary the mode
 * @param int $menu_id        the menu id
 * @param int $var            the submenu id
 */

function do_footer($system_summary, $menu_id = 0, $var = "")
{
    global $i18n, $system, $db_connect;
    ?><!-- /context --></td></tr></table></td>
<td style="border:1px solid #C0C0C0; background-color:#FFFFFF;"><table width="100%"  border="0" cellspacing="0" cellpadding="0">
<tr><td bgcolor="#5D7999"><img src="../img/px.gif" alt="" width="100%" height="5"></td></tr>
<tr><td nowrap bgcolor="#284465"><img src="../img/head_li.gif" alt="" width="29" height="25"><?php
    if ($system_summary) {
        ?><img src="../img/i18n/system_summary.gif" alt="<?php echo $i18n['admin']['system_summary']; ?>" width="94" height="25"><?php
    } else {
        ?><img src="../img/i18n/navigation.gif" alt="<?php echo $i18n['admin']['navigation']; ?>" width="63" height="25"><?php
    }
    ?></td></tr>
<tr><td><?php
    if ($system_summary) {
        $res_query = mysqli_query($db_connect, "SELECT COUNT(`id`) FROM `{$system['prefix']}_search_query`");
        $row = mysqli_fetch_row($res_query);
        $query_count = intval($row[0] ?? 0);

        $res_admin = mysqli_query($db_connect, "SELECT COUNT(`id`) FROM `{$system['prefix']}_admins`");
        $row = mysqli_fetch_row($res_admin);
        $admins_count = intval($row[0] ?? 0);
        
        $res_cnt = mysqli_query($db_connect, "SELECT COUNT(*) AS `total_files`, SUM(`size`) AS `total_size` FROM `{$system['prefix']}_search_db`");
        $row_cnt = mysqli_fetch_assoc($res_cnt);
        $total_files = (int)$row_cnt['total_files'];
        $total_size  = (int)$row_cnt['total_size'];
        
        ?><!-- system symmary --><table width="100%"  border="0" cellspacing="3" cellpadding="0">
<tr><td><?php echo $i18n['system']['size']; ?>:</td>
<td align="right"><?php echo formatsize($total_size); ?></td></tr>
<tr><td><?php echo $i18n['system']['pages']; ?>:</td>
<td align="right"><?php echo $total_files; ?></td></tr>
<tr><td><?php echo $i18n['system']['query']; ?>:</td>
<td align="right"><?php echo $query_count; ?></td></tr>
<tr><td colspan="2"><img src="../img/px.gif" alt="" width="100%" height="3"></td></tr>
<tr><td><?php echo $i18n['system']['admins']; ?>:</td>
<td align="right"><?php echo $admins_count; ?></td></tr>
<tr><td><?php echo $i18n['system']['logged']; ?>:</td>
<td align="right"><?php echo $_SESSION['admin']['username']; ?></td></tr>
<tr><td colspan="2"><img src="../img/px.gif" alt="" width="100%" height="3"></td></tr>
<tr><td><?php echo $i18n['system']['version']; ?>:</td>
<td align="right"><?php echo $system['version']; ?></td></tr>
<tr><td><?php echo $i18n['system']['type']; ?>:</td>
<td align="right"><?php echo $system['type']; ?></td></tr>
<tr valign="bottom"><td height="40" colspan="2"><a href="http://www.site-search-pro.com/" target="_blank">Site Search Pro website</a></td></tr></table><!-- /system symmary --><?php
    } else {
        ?><!-- navigation -->
<table width="100%"  border="0" cellspacing="5" cellpadding="0">
<tr><td height="30" valign="top"><a href="./index.php"><strong><?php echo $i18n['admin']['back_to_menu']; ?></strong></a></td></tr>
<tr><td bgcolor="#EDEDED"><img src="../img/px.gif" alt="" width="100%" height="1"></td></tr>
<tr><td><img src="../img/px.gif" alt="" width="100%" height="15"></td></tr>
<tr><td><?php
        /** administrators */
        if ($menu_id != 1) {
            ?><a class="strong" href="./administrators.php">- <?php echo $i18n['menu']['admins']; ?></a><br><?php
        } else {
            ?><span class="strong">- <?php echo $i18n['menu']['admins']; ?></span><br><br><?php
            if ($var == 1) {
                echo "&nbsp;&nbsp;&nbsp;- {$i18n['admins']['list']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./administrators.php?act=add\">- {$i18n['admins']['add']}</a>";
            } elseif ($var == 2) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./administrators.php\">- {$i18n['admins']['list']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['admins']['add']}";
            } else {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./administrators.php\">- {$i18n['admins']['list']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./administrators.php?act=add\">- {$i18n['admins']['add']}</a>";
            }
            echo '<br /><br />';
        }
        /** settings  */
        if ($menu_id != 2) {
            ?><a class="strong" href="./settings.php">- <?php echo $i18n['menu']['settings']; ?></a><br><?php
        } else {
            ?><span class="strong">- <?php echo $i18n['menu']['settings']; ?></span><br><br><?php
            if ($var == 1) {
                echo "&nbsp;&nbsp;&nbsp;- {$i18n['settings']['title']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./rules.php\">- {$i18n['rules']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./stop_words.php\">- {$i18n['sw']['title']}</a>";
            } elseif ($var == 2) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./settings.php\">- {$i18n['settings']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./rules.php\">- {$i18n['rules']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['sw']['title']}</a>";
            } elseif ($var == 3) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./settings.php\">- {$i18n['settings']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['rules']['title']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./stop_words.php\">- {$i18n['sw']['title']}</a>";
            }
            echo '<br /><br />';
        }
        /** design */
        if ($menu_id != 3) {
            ?><a class="strong" href="./styles.php">- <?php echo $i18n['menu']['design']; ?></a><br><?php
        } else {
            ?><span class="strong">- <?php echo $i18n['menu']['design']; ?></span><br><br><?php
            if ($var == 1) {
                echo "&nbsp;&nbsp;&nbsp;- {$i18n['style']['title']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./imgbtns.php\">- {$i18n['imgbtns']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./templates.php\">- {$i18n['tpl']['title']}</a>";
            } elseif ($var == 2) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./styles.php\">- {$i18n['style']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['imgbtns']['title']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./templates.php\">- {$i18n['tpl']['title']}</a>";
            } elseif ($var == 3) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./styles.php\">- {$i18n['style']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./imgbtns.php\">- {$i18n['imgbtns']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['tpl']['title']}";
            }
            echo '<br /><br />';
        }
        /** statistics */
        if ($menu_id != 4) {
            ?><a class="strong" href="./stat_brief.php">- <?php echo $i18n['menu']['statistic']; ?></a><br><?php
        } else {
            ?><span class="strong">- <?php echo $i18n['menu']['statistic']; ?></span><br><br><?php
            if ($var == 1) {
                echo "&nbsp;&nbsp;&nbsp;- {$i18n['stat']['brief']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./stat_advanced.php\">- {$i18n['stat']['advanced']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./logs.php\">- {$i18n['logs']['title']}</a>";
            } elseif ($var == 2) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./stat_brief.php\">- {$i18n['stat']['brief']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['stat']['advanced']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./logs.php\">- {$i18n['logs']['title']}</a>";
            } elseif ($var == 3) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./stat_brief.php\">- {$i18n['stat']['brief']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./stat_advanced.php\">- {$i18n['stat']['advanced']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['logs']['title']}";
            }
            echo '<br /><br />';
        } if ($menu_id != 5) {
            ?><a class="strong" href="./indexing.php">- <?php echo $i18n['menu']['indexing']; ?></a><br><?php
        } else {
            ?><span class="strong">- <?php echo $i18n['menu']['indexing']; ?></span><br><br><?php
            if ($var == 1) {
                echo "&nbsp;&nbsp;&nbsp;- {$i18n['ind']['title']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./groups.php\">- {$i18n['groups']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./import_export.php\">- {$i18n['imex']['title']}</a><br />\n&nbsp;&nbsp;&nbsp;<a href=\"./indexed_pages.php\">- {$i18n['ind_list']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./schedule.php\">- {$i18n['schedule']['title']}</a>";
            } elseif ($var == 2) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./indexing.php\">- {$i18n['ind']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./groups.php\">- {$i18n['groups']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./import_export.php\">- {$i18n['imex']['title']}</a><br />\n&nbsp;&nbsp;&nbsp;- {$i18n['ind_list']['title']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./schedule.php\">- {$i18n['schedule']['title']}</a>";
            } elseif ($var == 3) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./indexing.php\">- {$i18n['ind']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./groups.php\">- {$i18n['groups']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./import_export.php\">- {$i18n['imex']['title']}</a><br />\n&nbsp;&nbsp;&nbsp;<a href=\"./indexed_pages.php\">- {$i18n['ind_list']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['schedule']['title']}";
            } elseif ($var == 4) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./indexing.php\">- {$i18n['ind']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./groups.php\">- {$i18n['groups']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['imex']['title']}<br />\n&nbsp;&nbsp;&nbsp;<a href=\"./indexed_pages.php\">- {$i18n['ind_list']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./schedule.php\">- {$i18n['schedule']['title']}</a>";
            } elseif ($var == 5) {
                echo "&nbsp;&nbsp;&nbsp;<a href=\"./indexing.php\">- {$i18n['ind']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;- {$i18n['groups']['title']}<br>\n&nbsp;&nbsp;&nbsp;<a href=\"./import_export.php\">- {$i18n['imex']['title']}</a><br />\n&nbsp;&nbsp;&nbsp;<a href=\"./indexed_pages.php\">- {$i18n['ind_list']['title']}</a><br>\n&nbsp;&nbsp;&nbsp;<a href=\"./schedule.php\">- {$i18n['schedule']['title']}</a>";
            }
            echo '<br /><br />';
        } if ($menu_id != 6) {
            ?><a class="strong" href="./get_install_code.php">- <?php echo $i18n['menu']['get_install_code']; ?></a><br><?php
        } else {
            ?><span class="strong">- <?php echo $i18n['menu']['get_install_code']; ?></span><br><?php
        } ?>
<a class="strong" href="../">- <?php echo $i18n['menu']['search']; ?></a><br>
<a class="strong" href="./logout.php">- <?php echo $i18n['menu']['logout']; ?></a>
</td></tr></table>
<!-- /navigation --><?php
    }
    ?></td></tr></table></td></tr></table>
<p align="center">Copyright &copy; 2022 Site Search Pro 2.1 &#8482;</p>
<script language="JavaScript"><!--
tableruler();
//--></script>
</body></html><?php
}

/**
 * Print sort image and link
 * @param string $field the field
**/
function gui_sort ($field) {
    global $sort_field, $sort_order, $sort_page;
    $sf = $field;
    $so = $sort_order;
    $image = 'select';
    if ($sort_field == $field) {
        if ($sort_order == 'asc') {
            $so = 'desc';
            $image = 'asc';
        } else {
            $so = 'asc';
            $image = 'desc';
        }
    }
    print '&nbsp;<a href="'.$sort_page.'&sf='.$sf.'&so='.$so.'"><img src="../img/sort_'.$image.'.gif" alt="" width="11" height="11" border="0"></a>';
}
?>
