<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: schedule.php,v2.0 2017/09/30 advocat Exp $ */

include('./inc.php');

/** check access */
check_access("settings");

if (!isset($_GET['act'])) {
    $_GET['act'] = "";
}
if (!isset($_GET['id'])) {
    $_GET['id'] = "";
}

$sort_field_array 	= array('id','groups','date');
$sort_field			= 'id';
$sort_order 		= 'asc';
$sort_page			= $_SERVER['PHP_SELF'].'?';

if (isset($_GET['sf']) && in_array($_GET['sf'], $sort_field_array)) $sort_field = $_GET['sf'];
if (isset($_GET['so']) && ($_GET['so'] == 'asc' || $_GET['so'] == 'desc')) $sort_order = $_GET['so'];

/** configure */
$tbl_name = "{$system['prefix']}_schedule";
$module = "schedule";

/** groups */
$groups = array();
$res = mysqli_query($db_connect, "SELECT `id`,`name` FROM `{$system['prefix']}_groups` ORDER BY `name`");
while ($row = mysqli_fetch_assoc($res)) {
	$groups[$row['id']] = $row['name'];
}

if (!$_GET['act']) {
    /** print header */
    do_header($i18n['schedule']['title'], 'schedule');
    ?><table width="100%" border="0" cellspacing="10" cellpadding="0">
<tr><td height="25" align="center"><a class=strong href="<?php echo $_SERVER['PHP_SELF'].'?act=add';?>"><?php echo $i18n['schedule']['add'];?></a></td></tr></table>
<script language="javascript" type="text/javascript"><!--
function do_delete (id){
    if (confirm('<?php echo addslashes($i18n['schedule']['confirm_delete']); ?>')) document.location.href = '<?php echo $_SERVER['PHP_SELF'].'?act=delete&id='; ?>' + id;
}
//--></script>
<table width="96%" border="0" align="center" cellpadding="4" cellspacing="0" bgcolor="#FFFFFF" class=tbl_res>
<thead><tr>
<td height="30">id<?php gui_sort('id'); ?></td>
<td><?php echo $i18n['schedule']['groups']; gui_sort('groups'); ?></td>
<td><?php echo $i18n['schedule']['last_index']; gui_sort('date'); ?></td>
<td width="61">&nbsp;</td>
<td width="43">&nbsp;</td>
</tr></thead>
<tbody><?php
    $res = mysqli_query($db_connect, "SELECT * FROM `{$tbl_name}` ORDER BY `{$sort_field}` {$sort_order}");
    $cnt = mysqli_num_rows($res);
    while ($row = mysqli_fetch_assoc($res)) {
        ?><tr><td class="bottomline"><?php echo $row['id']; ?></td>
<td class="bottomline"><b><?php
	if ($row['groups'] == 0) {
		echo $i18n['schedule']['all_groups'];
	} else {
		$group = explode(',', $row['groups']);
		$groups_sel = array();
		foreach ($group as $group_id) {
			if (isset($groups[$group_id])) {
				$groups_sel[] = $groups[$group_id];
			}
		}
		echo join(', ', $groups_sel);
	}
?></b></td>
<td class="bottomline"><?php echo $row['date']; ?>&nbsp;</td>
<td class="bottomline"><a href="<?php echo $_SERVER['PHP_SELF'].'?act=edit&id='.$row['id']; ?>"><img src="../img/i18n/act_prop.gif" alt="<?php echo $i18n['schedule']['act_prop']; ?>" width="57" height="14" border="0"></a></td>
<td class="bottomline"><a href="javascript:do_delete<?php if ($cnt == 1) echo '_default'; ?>('<?php echo $row['id']; ?>');"><img src="../img/i18n/act_delete.gif" alt="<?php echo $i18n['schedule']['act_delete']; ?>" width="39" height="14" border="0"></a></td>

</tr><?php
    }
    ?></tbody></table>
<?php
    /** print footer */
    do_footer(0,5,3);
}
/** elseif act add / edit */
elseif ($_GET['act'] == 'add' || $_GET['act'] == 'edit' && is_numeric($_GET['id'])) {
    $error = false;
    
    if (!isset($_POST['groups'])) {
    	$groups4db = '0';
    } else {
    	if (sizeof($_POST['groups']) == sizeof($groups)) {
    		$groups4db = '0';
    	} else {
    		$groups_sel = array();
    		foreach ($_POST['groups'] as $group_id) {
    			if (isset($groups[$group_id])) {
    				$groups_sel[] = $group_id;
    			}
    		}
    		if (sizeof($groups_sel) > 0) {
    			$groups4db = join(',', $groups_sel);
    		} else {
    			$groups4db = 0;
    		}
    	}
    }
    if (!isset($_POST['enable'])) $enable = 0;
    else $enable = 1;
    
    if ($groups4db == 0) {
    	$groups4log = $i18n['schedule']['all_groups'];
    } else {
    	$groups4log = array();
    	$groups_sel = explode(',', $groups4db);
    	foreach ($groups_sel as $group_id) {
    		$groups4log[] = $groups[$group_id];
    	}
    	$groups4log = join(', ', $groups4log);
    }
    
    /** add */
    if ($_GET['act'] == 'add') {
        $title_image = 'add_new_task';
        if (isset($_POST['submit'])) {
            $sql = array('groups'=>$groups4db, 'days'=>$_POST['days'], 'hours'=>$_POST['hours'], 'minutes'=>$_POST['minutes'], 'enable'=>$enable);
            mysqli_query($db_connect, "INSERT INTO `{$tbl_name}` SET ".array2sql($sql));
            $id = mysqli_insert_id($db_connect);
            /** add log */
            a_logs($module, 'add', "{$i18n['schedule']['log_add']} ".$groups4log.", id: ".$id);
            header("Location: ".$_SERVER['PHP_SELF']);
            exit;
        } else {
            $prop = array('groups'=>'0', 'days'=>7, 'hours'=>0, 'minutes'=>0, 'enable'=>1);
        }
    }
    /** edit */
    else {
        $res = mysqli_query($db_connect, "SELECT * FROM `{$tbl_name}` WHERE `id`='{$_GET['id']}'");
        $row = mysqli_fetch_array($res);
        if (!isset($row['id'])) {
            header("Location: ".$_SERVER['PHP_SELF']);
            exit;
        }
        $title_image = 'task_properties';
        if (isset($_POST['submit'])) {
            $sql = array('groups'=>$groups4db, 'days'=>$_POST['days'], 'hours'=>$_POST['hours'], 'minutes'=>$_POST['minutes'], 'enable'=>$enable);
            mysqli_query($db_connect, "UPDATE `{$tbl_name}` SET ".array2sql($sql)." WHERE `id`='{$_GET['id']}'");
            $id = mysqli_insert_id($db_connect);
            /** add log */
            a_logs($module, 'update', "{$i18n['schedule']['log_update']} ".$groups4log.", id: ".$id);
            header("Location: ".$_SERVER['PHP_SELF']);
            exit;
        } else {
            $prop = $row;
        }
    }
    do_header($i18n['schedule']['title'],$title_image);
    ?><table width="100%"  border="0" cellspacing="10" cellpadding="0">
<tr><td height="25" align="center"><a class=strong href="<?php echo $_SERVER['PHP_SELF'];?>"><?php echo $i18n['schedule']['list'];?></a></td></tr></table>
	<form action="<?php echo $_SERVER['PHP_SELF'].'?act='.$_GET['act']; if ($_GET['id']) echo '&id='.$_GET['id']; ?>" method="post" name="frm_prop" id="frm_prop">
<table width="100%" border="0" cellpadding="0" cellspacing="5">
<tr><td width="10%">&nbsp;</td>
<td><table width="100%" border="0" cellpadding="5" cellspacing="0">
<tr><td width="40%" class="bottomline"><?php echo $i18n['schedule']['groups']; ?> :</td>
<td class="bottomline"><?php
	if ($prop['groups'] == 0) {
		$groups_sel = array();
	} else {
		$groups_sel = explode(',', $prop['groups']);
	}
    foreach ($groups as $key => $var) {
        print '<input name="groups['.$key.']" type="checkbox" id="groups['.$key.']" value="'.$key.'"';
        if ($prop['groups'] == 0 || in_array($key, $groups_sel)) print ' checked';
        print '> <label for="groups['.$key.']">'.$var.'</label><br />';
    }
    ?></td></tr>
<tr><td colspan="2" class=thead><?php echo $i18n['schedule']['every']; ?></td></tr>
<tr><td class="bottomline"><?php echo $i18n['schedule']['days']; ?> :</td>
<td class="bottomline"><input name="days" type="text" class="field" id="days" style="width:10%;" value="<?php echo $prop['days']; ?>" maxlength="2"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['schedule']['hours']; ?> :</td>
<td class="bottomline"><input name="hours" type="text" class="field" id="hours" style="width:10%;" value="<?php echo $prop['hours']; ?>" maxlength="2"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['schedule']['minutes']; ?> :</td>
<td class="bottomline"><input name="minutes" type="text" class="field" id="minutes" style="width:10%;" value="<?php echo $prop['minutes']; ?>" maxlength="2"></td></tr>
<tr><td><?php echo $i18n['schedule']['enable']; ?> :</td>
<td><input name="enable" type="checkbox" value="1" <?php if ($prop['enable']) echo 'checked'; ?>></td></tr>
</table></td></tr>
<tr><td class="topline">&nbsp;</td>
<td>&nbsp;</td></tr>
<tr align="center"><td colspan="2"><input name="submit" type="submit" class="button" id="submit" value=":: <?php echo $i18n['button']['save']; ?> ::"></td>
</tr></table>
</form><?php
    do_footer(0,5,4);
}
/** act delete */
elseif ($_GET['act'] == "delete" && is_numeric($_GET['id'])) {
    $res = mysqli_query($db_connect, "SELECT * FROM `{$tbl_name}` WHERE `id`='{$_GET['id']}'");
    $row = mysqli_fetch_array($res);
    if (isset($row['id'])) {
        /** delete */
        mysqli_query($db_connect, "DELETE FROM `{$tbl_name}` WHERE `id`='{$row['id']}'");
        /** add log */
        $groups4db = $row['groups'];
        if ($groups4db == 0) {
        	$groups4log = $i18n['schedule']['all_groups'];
        } else {
        	$groups4log = array();
        	$groups_sel = explode(',', $groups4db);
    		foreach ($groups_sel as $group_id) {
        		$groups4log[] = $groups[$group_id];
        	}
        	$groups4log = join(', ', $groups4log);
        }
    
        a_logs($module,'delete',"{$i18n['schedule']['log_delete']} {$groups4log}, id: {$row['id']}");
    }
    header("Location: {$_SERVER['PHP_SELF']}");
    exit;
}
/** else */
else {
    header("Location: {$_SERVER['PHP_SELF']}");
    exit;
}

?>