<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: advanced_search.php,v2.0 2017/09/30 advocat Exp $ */

/** define path*/
define('SSP_DIR', str_replace('\\','/',dirname(__FILE__)));

/** include fixer*/
include_once (SSP_DIR.'/data/fixer.php');

/** session start */
session_start();

/** include files */
include_once (SSP_DIR.'/data/config.php');
include_once (SSP_DIR.'/data/db.php');
include_once (SSP_DIR.'/data/functions.php');
include_once (SSP_DIR.'/data/system.php');
include_once (SSP_DIR.'/data/stop_words.php');
include_once (SSP_DIR.'/data/i18n.php');

$db_connect = mysqli_connect($db['host'],$db['login'],$db['passwd']);
$db_select  = mysqli_select_db($db_connect, $db['name']);

/** groups */
$groups_array = array();
$groups_array[0] = array('name'=>$config['label_all_groups']);
$res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_groups`");
while ($row = mysqli_fetch_assoc($res)) {
    $groups_array[$row['id']]['name']      = $row['name'];
    $groups_array[$row['id']]['tpl_id']    = $row['tpl_id'];
    $groups_array[$row['id']]['style_id']  = $row['style_id'];
}
/** templates */
$templates_array    = array();
$template_default   = 0;
$res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_templates`");
while ($row = mysqli_fetch_assoc($res)) {
    if ($row['default']) {
        $template_default = $row['id'];
    }
    $templates_array[$row['id']]['header'] = stripslashes($row['header']);
    $templates_array[$row['id']]['footer'] = stripslashes($row['footer']);
}
/** styles */
$styles_array   = array();
$style_default  = 0;
$res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_styles`");
while ($row = mysqli_fetch_assoc($res)) {
    if ($row['default']) {
        $style_default = $row['id'];
    }
    $styles_array[$row['id']]['data'] = unserialize(stripslashes($row['data']));
}

if (isset($_GET['g']) && isset($groups_array[$_GET['g']])) {
    $_SESSION['ssp_groupid'] = (int)$_GET['g'];
} elseif (!isset($_SESSION['ssp_groupid'])) {
    $_SESSION['ssp_groupid'] = 0;
}

if ($_SESSION['ssp_groupid'] > 0) {
    $_SESSION['ssp_tplid']      = $groups_array[$_SESSION['ssp_groupid']]['tpl_id'];
    $_SESSION['ssp_styleid']    = $groups_array[$_SESSION['ssp_groupid']]['style_id'];
    $style_data                 = $styles_array[$_SESSION['ssp_styleid']]['data'];
} else {
    if (defined('SSP_STYLEID')) {
        $_SESSION['ssp_styleid'] = SSP_STYLEID;
    } elseif (isset($_GET['s']) && isset($styles_array[$_GET['s']])) {
        $_SESSION['ssp_styleid'] = (int)$_GET['s'];
    } else {
        $_SESSION['ssp_styleid'] = $style_default;
    }
    $style_data = $styles_array[$_SESSION['ssp_styleid']]['data'];

    if (defined('SSP_TPLID')) {
        $_SESSION['ssp_tplid'] = SSP_TPLID;
    } elseif (isset($_GET['t']) && isset($templates_array[$_GET['t']])) {
        $_SESSION['ssp_tplid'] = (int)$_GET['t'];
    } else {
        $_SESSION['ssp_tplid'] = $template_default;
    }
}

$header_tpl = $templates_array[$_SESSION['ssp_tplid']]['header'];
$footer_tpl = $templates_array[$_SESSION['ssp_tplid']]['footer'];

/** advanced search */
$as_epq = $as_oq = $as_eq = $as_q = "";
$epq = $oq = $eq = $rq = $q  = array();

if (isset($_GET['q'])) {
    $query_str = $_GET['q'];
} else {
    $query_str = "";
}

if (strlen($query_str) > $config['min_chr_word']) {
    if (get_magic_quotes_gpc()) {
        $query_str = stripslashes(urldecode(urlencode($query_str)));
    } else {
        $query_str = urldecode(urlencode($query_str));
    }
    $query_str = str_replace("\\"," ",$query_str);
    $query_str = str_replace("/"," ",$query_str);
    $query_str = str_replace("'","\'", $query_str);

    $query_array = preg_split("/\s+/", $query_str);
    
    $epq_mode = $oq_mode = $epq_key = 0;
    
    foreach ($query_array as $key => $word) {
        $word = trim($word);
        
        if (!$epq_mode && !preg_match("/^\+/",$word) && !preg_match("/^OR$/i", $word) && strlen($word) < $config['min_chr_word']) {
            continue;
        }
        if (!$epq_mode) {
            if (preg_match("/^\"/", $word)) {
                if (!preg_match("/\"$/", $word)) {
                    $epq[$epq_key] = pattern_escape(substr($word,1));
                    $epq_mode = 1;
                    continue;
                }
                else {
                    $epq[$epq_key] = pattern_escape(substr($word,1,-2));
                    $epq_key++;
                    continue;
                }
            }
        } else {
            if (preg_match("/\"$/", $word)) {
                $epq[$epq_key] .= ' '.pattern_escape(substr($word,0, -1));
                $epq_key++;
                $epq_mode = 0;
                continue;
            } else {
                $epq[$epq_key] .= ' '.pattern_escape($word);
                continue;
            }
        }
        if (!$oq_mode) {
            if (isset($query_array[($key+1)]) && preg_match("/^OR$/i",$query_array[($key+1)])) {
                if (!in_array($word, $stop_words)) {
                    $oq[] = pattern_escape($word);
                }
                $oq_mode = 1;
                continue;
            }
        } else {
            if (preg_match("/^OR$/i",$word)) {
                continue;
            } else {
                if (!in_array($word, $stop_words)) {
                    $oq[] = pattern_escape($word);
                }
                if (isset($query_array[($key+1)]) && preg_match("/^OR$/i",$query_array[($key+1)])) {
                    continue;
                } else {
                    $oq_mode = 0;
                    continue;
                }
            }
        }
        if (preg_match("/^\+/", $word)) {
            $rq[] = pattern_escape(substr($word,1));
            continue;
        }
        if (preg_match("/^\-/", $word)) {
            $eq[] = pattern_escape(substr($word,1));
            continue;
        }
        if (!in_array($word, $stop_words)) {
            $q[] = pattern_escape($word);
        }
    }
}

$as_q   = join(" ", array_merge($q, $rq));
$as_epq = join(" ", $epq);
$as_oq  = join(" ", $oq);
$as_eq  = join(" ", $eq);

$url_search = $config['site_addr'].(!empty($config['folder']) ? chr(47).$config['folder'] : '').'/index.php';

ob_start();

print $header_tpl;

print stl2style($style_data);

?><form action="<?php echo $url_search;?>" method="get" enctype="application/x-www-form-urlencoded" name="as" id="as">
<table border="0" align="center" cellpadding="2" cellspacing="0">
<tr valign="top"><td><table border="0" cellspacing="0" cellpadding="2">
<tr><td nowrap class=sp2_result><?php echo $i18n['search']['as_q']; ?> :</td>
<td><input class="sp2_field" name="q" type="text" id="q" value="<?php echo $as_q?>" size="25"></td></tr>
<tr><td nowrap class=sp2_result><?php echo $i18n['search']['as_epq']; ?> :</td>
<td><input class="sp2_field" name="epq" type="text" id="epq" value="<?php echo stripslashes($as_epq)?>" size="25"></td></tr>
<tr><td nowrap class=sp2_result><?php echo $i18n['search']['as_oq']; ?> :</td>
<td><input class="sp2_field" name="oq" type="text" id="oq" value="<?php echo $as_oq?>" size="25"></td></tr>
<tr><td nowrap class=sp2_result><?php echo $i18n['search']['as_eq']; ?> :</td>
<td><input class="sp2_field" name="eq" type="text" id="eq" value="<?php echo $as_eq?>" size="25"></td></tr></table></td>
<td nowrap><table border="0" cellspacing="0" cellpadding="2">
<tr><td><select name="num" size="1" id="num" class=sp2_i_select>
<option value="10">10 <?php echo $i18n['search']['num']; ?></option>
<option value="20">20 <?php echo $i18n['search']['num']; ?></option>
<option value="30">30 <?php echo $i18n['search']['num']; ?></option>
<option value="50">50 <?php echo $i18n['search']['num']; ?></option>
</select></td>
<td>
<?php


    if ($style_data['imgbtns'] > 0) {
        $res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_imgbtns` WHERE `id`='{$style_data['imgbtns']}'");
        $row = mysqli_fetch_assoc($res);
        $style_data['imgbtn_tag'] = '<input name="search" type="image" id="search" src="'.$url_folder.'img/buttons/'.$row['image'].'" '.$row['image_tag'].' border="0" align="middle">';
    }


if ($style_data['imgbtns'] == 0) {
 print "<input class=\"sp2_btn\" name=\"btn\" type=\"submit\" id=\"btn\" value=\"".$config['label_button']."\">";
}else{
 print $style_data['imgbtn_tag']."\n";
}
?>

</td></tr><?php

if ($style_data['result_groups']) {
    echo '<tr><td><select name="g" id="g" class=sp2_i_select>';
    foreach ($groups_array as $key => $vals) {
        echo '<option value="'.$key.'"';
        if ($key == $_SESSION['ssp_groupid']) echo ' selected';
        echo '>'.htmlspecialchars($vals['name']).'</option>';
    }
    echo '</select></td><td>&nbsp;</td></tr>';
} else {
    if ($_SESSION['ssp_groupid'] > 0) $write .= '<input type=hidden name="g" value="'.$_SESSION['group_id'].'">';
}
?></table></td></tr></table></form><?php
print $footer_tpl;

$content_advanced_search = ob_get_contents();
ob_end_clean();

print convert_from_utf($config['encoding'],$content_advanced_search);

?>