<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0
**/
/** $Id: check.php,v2.1 2017/09/29 advocat Exp $ */

/** set error_reporting */
error_reporting(E_ALL);

/** session start */
session_start();
$session_name = session_name();
if (!isset($_GET[$session_name]) || !preg_match("/^[a-f0-9]{32}$/", $_GET[$session_name])) {
    $_SESSION['check'] = true;
    header("Location: ".$_SERVER['PHP_SELF'].'?'.$session_name.'='.session_id());
    exit;
} else {
    if (!isset($_SESSION['check'])) {
        $_SESSION['check'] = false;
    }
}

/** define path */
define('SSP_DIR', str_replace('\\', '/', dirname(__FILE__)));

/** include files */
include_once (SSP_DIR.'/data/system.php');

$php_version    = phpversion();
$match          = explode('.', $php_version);
if (!isset($match[0])) {
    $match[0] = 4;
} if (!isset($match[1])) {
    $match[1] = 03;
} if (!isset($match[2])) {
    $match[2] = 02;
}
$php_int_version = (int)sprintf('%d%02d%02d', $match[0], $match[1], intval($match[2]));

$print_value_true   = '<span class="true">true</span>';
$print_value_false  = '<span class="false"><b>false</b></span>';
$print_value_impact = '---&nbsp;';

$ini_all = ini_get_all();

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head>
<title><?php echo $system['name'].' :: '.$system['type'].' :: '; ?>Server check</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="./styles.css" rel="stylesheet" type="text/css">
<script language="JavaScript"><!--
function tableruler(){if(document.getElementById&&document.createTextNode){var tables=document.getElementsByTagName('table');for(var i=0;i<tables.length;i++){if(tables[i].className=='tbl_res'){var trs=tables[i].getElementsByTagName('tr');for(var j=0;j<trs.length;j++){if(trs[j].parentNode.nodeName!='THEAD'){trs[j].onmouseover=function(){this.className='tbl_sel';return false};trs[j].onmouseout=function(){this.className='';return false}}}}}}}//-->
</script>
</head><body>
<table width="778"  border="0" align="center" cellpadding="5" cellspacing="10">
<tr><td style="border:1px solid #C0C0C0; background-color:#FFFFFF;"><table width="100%"  border="0" cellspacing="0" cellpadding="0">
<tr style="background-image:url(img/bg-header.gif);">
<td width="209"><img src="img/i18n/_tools.gif" alt="<?php echo $i18n['install']['title']; ?>" width="150" height="30"></td>
<td align="right"><img src="img/cdcover-top.gif" alt="" width="115" height="30"></td></tr>
<tr><td><img src="img/px.gif" alt="" width="209" height="5"></td>
<td align="right"><img src="img/cdcover-back.gif" alt="" width="120" height="5"></td></tr>
<tr style="background-color:#EDEDED;" valign="top">
<td><img src="img/logotype.gif" alt="" width="209" height="77"></td>
<td align="right"><img src="img/cdcover.gif" alt="" width="270" height="105"></td></tr></table></td></tr>
<tr><td style="border:1px solid #C0C0C0; background-color:#FFFFFF;">
<table width="100%"  border="0" cellspacing="0" cellpadding="0">
<tr><td bgcolor="#5D7999"><img src="img/px.gif" alt="" width="100%" height="5"></td></tr>
<tr><td bgcolor="#284465"><img src="img/head_li.gif" alt="" width="29" height="25"><img src="img/i18n/server_check.gif" alt="server check" width="150" height="25"></td></tr>
<tr><td><!-- content -->
<table width="100%" border="0" cellpadding="5" cellspacing="0" class="tbl_res" align="center">
<thead><tr><td width="40%">Option</td>
<td width="30%">Value</td>
<td width="30%">Result</td>
</tr></thead>
<tbody>

<tr><td class="bottomline">PHP string vesion</td>
<td class="bottomline"><?php echo $php_version; ?></td>
<td class="bottomline"><?php
if ($php_int_version >= 40302) {
    echo $print_value_true;
} else {
    echo $print_value_false;
}
?></td></tr>

<tr><td class="bottomline">PHP int version</td>
<td class="bottomline"><?php echo $php_int_version;?></td>
<td class="bottomline"><?php
if ($php_int_version >= 40302) {
    echo $print_value_true;
} else {
    echo $print_value_false;
}
?></td></tr>

<tr><td class="bottomline">PHP iconv support</td>
<td class="bottomline"><?php
if (extension_loaded('iconv')) {
    if (defined('ICONV_VERSION')) {
        echo ICONV_VERSION;
    } else {
        echo "Yes";
    }
} else {
    echo "No";
}
?></td>
<td class="bottomline"><?php
if (extension_loaded('iconv')) {
    echo $print_value_true;
} else {
    echo $print_value_false;
}
?></td></tr>

<tr><td class="bottomline">PHP allow_url_fopen</td>
<td class="bottomline"><?php echo ini_get('allow_url_fopen'); ?></td>
<td class="bottomline"><?php
if (ini_get('allow_url_fopen')) {
    echo $print_value_true;
} else {
    echo $print_value_false;
}
?></td></tr>

<tr>
  <td class="bottomline">PHP sessions support</td>
  <td class="bottomline"><?php
if ($_SESSION['check']) {
    echo "Yes";
} else {
    echo "No";
}
?></td>
<td class="bottomline"><?php
if ($_SESSION['check']) {
    echo $print_value_true;
} else {
    echo $print_value_false;
}
?></td></tr>

<tr><td class="bottomline">PHP session value</td>
<td class="bottomline"><?php echo session_id(); ?></td>
<td class="bottomline"><?php echo $print_value_impact; ?></td></tr>

<tr><td class="bottomline">PHP session save path </td>
<td class="bottomline"><?php echo session_save_path(); ?></td>
<td class="bottomline"><?php
if (session_save_path()) {
    echo $print_value_true;
} else {
    echo $print_value_false;
}
?></td></tr>

<tr><td class="bottomline">PHP writeable sessions folder </td>
<td class="bottomline"><?php
if (is_writeable(session_save_path())) {
    echo "Yes";
} else {
    echo "No";
}
?></td>
<td class="bottomline"><?php
if (is_writeable(session_save_path())) {
    echo $print_value_true;
} else {
    echo $print_value_false;
}
?></td></tr>

<tr><td class="bottomline">PHP safe_mode</td>
<td class="bottomline"><?php echo intval(ini_get('safe_mode')); ?></td>
<td class="bottomline"><?php echo $print_value_impact; ?></td></tr>

<tr><td class="bottomline">PHP safe_mode_exec_dir</td>
<td class="bottomline"><?php echo ini_get('safe_mode_exec_dir'); ?>&nbsp;</td>
<td class="bottomline"><?php echo $print_value_impact; ?></td></tr>

<tr><td class="bottomline">PHP max_execution_time</td>
<td class="bottomline"><?php echo ini_get('max_execution_time'); ?></td>
<td class="bottomline"><?php echo $print_value_impact; ?></td>
</tr>
<tr><td class="bottomline">PHP magic_quotes_gpc</td>
<td class="bottomline"><?php echo ini_get('magic_quotes_gpc'); ?></td>
<td class="bottomline"><?php echo $print_value_impact; ?></td>
</tr>
<tr><td class="bottomline">PHP writeable data folder</td>
<td class="bottomline"><?php
if (is_writeable(SSP_DIR.'/data')) {
    echo "Yes";
} else {
    echo "No";
}
?></td>
<td class="bottomline"><?php
if (is_writeable(SSP_DIR.'/data')) {
    echo $print_value_true;
} else {
    echo $print_value_false;
}
?></td></tr>

<tr><td class="bottomline">PHP create test file</td>
<td class="bottomline"><?php
$file = SSP_DIR.'/data/'.session_id().'.tmp';
umask(0777);
$fp = @fopen($file, "w+");
if ($fp) {
    $create = true;
    fclose($fp);
    chmod($file, 0777);
    @unlink($file);
    clearstatcache();
    echo "Yes";
} else {
    $create = false;
    echo "No";
}
?></td>
<td class="bottomline"><?php
if ($create) {
    echo $print_value_true;
} else {
    $print_value_false;
}
?></td></tr>

<tr><td class="bottomline">&nbsp;</td>
<td class="bottomline">&nbsp;</td>
<td class="bottomline">&nbsp;</td></tr>

<tr><td class="bottomline">MySQL Client version</td>
<td class="bottomline"><?php echo mysqli_get_client_info($db_connect); ?></td>
<td class="bottomline"><?php echo $print_value_impact; ?></td></tr>

<tr><td class="bottomline">MySQL Server version</td>
<td class="bottomline"><?php
if (file_exists(SSP_DIR.'/data/db.php')) {
    include_once (SSP_DIR.'/data/db.php');
    $db_connect = mysqli_connect($db['host'],$db['login'],$db['passwd']);
    echo mysqli_get_server_info($db_connect);
} else {
    echo "not installed";
} ?></td>
<td class="bottomline"><?php echo $print_value_impact; ?></td></tr>
</tbody></table>
<!-- /content --></td></tr></table></td></tr></table>
<script language="JavaScript">tableruler();</script>
<p align="center">Copyright &copy; 2022 Site Search Pro 2.1 &#8482;</p>
</body></html>