<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: convert.php,v2.0 2017/10/28 advocat Exp $ */

/** define convert class and convert tmp dir path */
define('CONVERT_PATH', str_replace('\\', '/', dirname(__FILE__)));


/**
 * @return string
 * @param  string $data      the .PDF content
 * @param  string $path2xpdf the pligin path
 * @desc   Convert PDF file to plain text
**/
function convert_pdf2text($data, $path2xpdf = null,$use_internal = 0)
{
include_once(CONVERT_PATH.'/pdf.php');
 
 if($use_internal){
 // Use internal PDF parsing module
    $tmpname = time();
    umask(0755);
    $fp = @fopen(CONVERT_PATH.'/'.$tmpname.'.pdf', "w+");
    if (!$fp) {
        return '';
    } else {
        fwrite($fp, $data);
        fclose($fp);
        chmod(CONVERT_PATH.'/'.$tmpname.'.pdf', 0755);

        $text = pdf2text(CONVERT_PATH.'/'.$tmpname.'.pdf');

        @unlink(CONVERT_PATH.'/'.$tmpname.'.pdf');
        clearstatcache();
        return $text;
    }
 }else{   
    if (!$path2xpdf) {
        return '';
    }
    $tmpname = time();
    umask(0755);
    $fp = @fopen(CONVERT_PATH.'/'.$tmpname.'.pdf', "w+");
    if (!$fp) {
        return '';
    } else {
        fwrite($fp, $data);
        fclose($fp);
        chmod(CONVERT_PATH.'/'.$tmpname.'.pdf', 0755);
        
        exec($path2xpdf.' '.CONVERT_PATH.'/'.$tmpname.'.pdf '.CONVERT_PATH.'/'.$tmpname.'.txt');
        
        if (file_exists(CONVERT_PATH.'/'.$tmpname.'.txt')) {
            chmod(CONVERT_PATH.'/'.$tmpname.'.txt', 0755);
            $text = @file_get_contents(CONVERT_PATH.'/'.$tmpname.'.txt');
            @unlink(CONVERT_PATH.'/'.$tmpname.'.pdf');
            @unlink(CONVERT_PATH.'/'.$tmpname.'.txt');
            clearstatcache();
            return $text;
        } else {
            @unlink(CONVERT_PATH.'/'.$tmpname.'.pdf');
            @unlink(CONVERT_PATH.'/'.$tmpname.'.txt');
            clearstatcache();
            return '';
        }
    }
 }
}

/**
 * @return string
 * @param  string $data the .RTF content
 * @desc   Convert RTF file to plain text
**/
function convert_rtf2text($data)
{
    include_once(CONVERT_PATH.'/rtf2html.class.php');
    $rtf2html = new Rtf2Html();
    if ($rtf2html->read_data(addslashes($data))) {
        return $rtf2html->get_text();
    } else {
        return '';
    }
}

/**
 * @return string
 * @param  string $data    the .doc content
 * @param  string $path2aw the plugin path
 * @desc   Convert MS Doc file to palin text
**/
function convert_doc2text($data, $path2aw, $use_internal = 0, $exten)
{
    include_once(CONVERT_PATH.'/doc2txt.php');
   
   if($use_internal){
 // Use internal DOC parsing module
    $tmpname = time();
    umask(0755);
    $fp = @fopen(CONVERT_PATH.'/'.$tmpname.$exten, "w+");
    if (!$fp) {
        return '';
    } else {
        fwrite($fp, $data);
        fclose($fp);
        chmod(CONVERT_PATH.'/'.$tmpname.$exten, 0755);

    if($exten ==".doc"){
     $text = code2Utf8(doc2text(CONVERT_PATH.'/'.$tmpname.$exten));
    }else{
     $text = docx2text(CONVERT_PATH.'/'.$tmpname.$exten);
    };

        
//        $text = doc2text(CONVERT_PATH.'/'.$tmpname.$exten);

        @unlink(CONVERT_PATH.'/'.$tmpname.$exten);
        clearstatcache();
        return $text;
    }
   }else{ 
    if (!$path2aw) {
        return '';
    }
    $tmpname = time();
    umask(0755);
    $fp = @fopen(CONVERT_PATH.'/'.$tmpname.'.doc', "w+");
    if (!$fp) {
        return '';
    } else {
        fwrite($fp, $data);
        fclose($fp);
        chmod(CONVERT_PATH.'/'.$tmpname.'.doc', 0755);
        
        exec($path2aw.' '.CONVERT_PATH.'/'.$tmpname.'.doc > '.CONVERT_PATH.'/'.$tmpname.'.txt');
        
        if (file_exists(CONVERT_PATH.'/'.$tmpname.'.txt')) {
            chmod(CONVERT_PATH.'/'.$tmpname.'.txt', 0755);
            $text = @file_get_contents(CONVERT_PATH.'/'.$tmpname.'.txt');
            @unlink(CONVERT_PATH.'/'.$tmpname.'.doc');
            @unlink(CONVERT_PATH.'/'.$tmpname.'.txt');
            clearstatcache();
            return $text;
        } else {
            @unlink(CONVERT_PATH.'/'.$tmpname.'.doc');
            @unlink(CONVERT_PATH.'/'.$tmpname.'.txt');
            clearstatcache();
            return '';
        }
    }
  }
}

/**
 * @return string
 * @param  string $data the .xls content
 * @desc   Convert MS Excel file to plain text
**/
function convert_xls2text($data)
{
    include_once(CONVERT_PATH.'/excelreader.class.php');
    $xlsread = new Excel_Reader();
    if ($xlsread->read_data($data)) {
        $text = '';
        for ($i=1; $i<=$xlsread->sheets[0]['numRows']; $i++) {
            for ($j=1; $j<=$xlsread->sheets[0]['numCols']; $j++) {
                if (isset($xlsread->sheets[0]['cells'][$i][$j])) {
                    $text .= $xlsread->sheets[0]['cells'][$i][$j].' ';
                }
            }
        }
        return $text;
    } else {
        return '';
    }
}

?>
