<?php

require_once(dirname(__FILE__).'/pclzip.lib.php');
require_once(dirname(__FILE__).'/doc.php');

$document = "multi_site.doc";

function doc2text($filename) {
    $doc = new doc;
    $doc->read($filename);
    return $doc->parse();
}


function docx2text($filename) {
    return getTextFromZippedXML($filename, "word/document.xml");
}

function code2Utf8($string) { // Parse russian language
 $p[0] = 'ё';   $r[65] = '&#x0451;';
 $p[1] = 'а';   $r[64] = '&#x0430;';
 $p[2] = 'б';   $r[63] = '&#x0431;';
 $p[3] = 'в';   $r[62] = '&#x0432;';
 $p[4] = 'г';   $r[61] = '&#x0433;';
 $p[5] = 'д';   $r[60] = '&#x0434;';
 $p[6] = 'е';   $r[59] = '&#x0435;';
 $p[7] = 'ж';   $r[58] = '&#x0436;';
 $p[8] = 'з';   $r[57] = '&#x0437;';
 $p[9] = 'и';   $r[56] = '&#x0438;';
 $p[10] = 'й';  $r[55] = '&#x0439;';
 $p[11] = 'к';  $r[54] = '&#x043a;';
 $p[12] = 'л';  $r[53] = '&#x043b;';
 $p[13] = 'м';  $r[52] = '&#x043c;';
 $p[14] = 'н';  $r[51] = '&#x043d;';
 $p[15] = 'о';  $r[50] = '&#x043e;';
 $p[16] = 'п';  $r[49] = '&#x043f;';
 $p[17] = 'р';  $r[48] = '&#x0440;';
 $p[18] = 'с';  $r[47] = '&#x0441;';
 $p[19] = 'т';  $r[46] = '&#x0442;';
 $p[20] = 'у';  $r[45] = '&#x0443;';
 $p[21] = 'ф';  $r[44] = '&#x0444;';
 $p[22] = 'х';  $r[43] = '&#x0445;';
 $p[23] = 'ц';  $r[42] = '&#x0446;';
 $p[24] = 'ч';  $r[41] = '&#x0447;';
 $p[25] = 'ш';  $r[40] = '&#x0448;';
 $p[26] = 'щ';  $r[39] = '&#x0449;';
 $p[27] = 'ъ';  $r[38] = '&#x044a;';
 $p[28] = 'ы';  $r[37] = '&#x044b;';
 $p[29] = 'ь';  $r[36] = '&#x044c;';
 $p[30] = 'э';  $r[35] = '&#x044d;';
 $p[31] = 'ю';  $r[34] = '&#x044e;';
 $p[32] = 'я';  $r[33] = '&#x044f;';
 $p[33] = 'Ё';  $r[32] = '&#x0401;';
 $p[34] = 'А';  $r[31] = '&#x0410;';
 $p[35] = 'Б';  $r[30] = '&#x0411;';
 $p[36] = 'В';  $r[29] = '&#x0412;';
 $p[37] = 'Г';  $r[28] = '&#x0413;';
 $p[38] = 'Д';  $r[27] = '&#x0414;';
 $p[39] = 'Е';  $r[26] = '&#x0415;';
 $p[40] = 'Ж';  $r[25] = '&#x0416;';
 $p[41] = 'З';  $r[24] = '&#x0417;';
 $p[42] = 'И';  $r[23] = '&#x0418;';
 $p[43] = 'Й';  $r[22] = '&#x0419;';
 $p[44] = 'К';  $r[21] = '&#x041a;';
 $p[45] = 'Л';  $r[20] = '&#x041b;';
 $p[46] = 'М';  $r[19] = '&#x041c;';
 $p[47] = 'Н';  $r[18] = '&#x041d;';
 $p[48] = 'О';  $r[17] = '&#x041e;';
 $p[49] = 'П';  $r[16] = '&#x041f;';
 $p[50] = 'Р';  $r[15] = '&#x0420;';
 $p[51] = 'С';  $r[14] = '&#x0421;';
 $p[52] = 'Т';  $r[13] = '&#x0422;';
 $p[53] = 'У';  $r[12] = '&#x0423;';
 $p[54] = 'Ф';  $r[11] = '&#x0424;';
 $p[55] = 'Х';  $r[10] = '&#x0425;';
 $p[56] = 'Ц';  $r[9] = '&#x0426;';
 $p[57] = 'Ч';  $r[8] = '&#x0427;';
 $p[58] = 'Ш';  $r[7] = '&#x0428;';
 $p[59] = 'Щ';  $r[6] = '&#x0429;';
 $p[60] = 'Ъ';  $r[5] = '&#x042a;';
 $p[61] = 'Ы';  $r[4] = '&#x042b;';
 $p[62] = 'Ь';  $r[3] = '&#x042c;';
 $p[63] = 'Э';  $r[2] = '&#x042d;';
 $p[64] = 'Ю';  $r[1] = '&#x042e;';
 $p[65] = 'Я';  $r[0] = '&#x042f;';

 return str_replace($r,$p,$string);

};


function getTextFromZippedXML($archiveFile, $contentFile) {

       $zip = new PclZip($archiveFile);
       $content = $zip->extract(PCLZIP_OPT_BY_NAME, $contentFile, PCLZIP_OPT_EXTRACT_AS_STRING);
       if($content !=0){
        $content = $content[0]['content'];
        $xml = DOMDocument::loadXML($content, LIBXML_NOENT | LIBXML_XINCLUDE | LIBXML_NOERROR | LIBXML_NOWARNING);
        return strip_tags($xml->saveXML());
       };
    return "";
}

// preg_match("/(\.\S+)$/",$document,$ext);

// if($ext[0] ==".doc"){
//  $plaintext = code2Utf8(doc2text($document));
// }else{
//  $plaintext = docx2text($document);
// };


// print $plaintext;

?>