<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: function.php,v2.0 2017/09/29 advocat Exp $ */

/**
 * Check access
 * @param string $access the access id
 */
function check_access($access)
{
    if (!in_array($access,explode(',', $_SESSION['admin']['access']))) {
        header("Location: ./access_denied.php");
        exit;
    }
}

/**
 * Convert array to SQL
 * @param array $sql_array the sql array
 * @return string the SQL
 */
function array2sql ($sql_array)
{
    if (!is_array($sql_array)) return null;

    $sql_query = "";
    $count = sizeof($sql_array);
    $i = 0;

    foreach ($sql_array as $key => $var) {
        $i++;
        if ($var == "" && $var != "0") $item = "NULL";
        elseif (preg_match("/'/", $var)) $item = "'".addslashes($var)."'";
        else $item = "'{$var}'";

        $sql_query .= "`{$key}`={$item}";
        if ($count > $i) $sql_query .= ",";
    }

    return $sql_query;
}

/**
 * @return string
 * @param  string $string the string
 * @param  bool   $mode   the mode (1-add | 0-strip)
 * @desc Add (1) and strip (0) slashes
**/
function slashes($string, $mode = 1)
{
    if ($mode) {
        if (get_magic_quotes_gpc()) return addslashes(stripslashes($string));
        else return addslashes($string);
    } else {
        if (get_magic_quotes_gpc()) return stripslashes(stripslashes($string));
        else return stripslashes($string);
    }
}

/**
 * Write administrators logs
 * @param string $module the module name
 * @param string $act    the administrator action
 * @param string $detail the log detail
 * @return bool
 */
function a_logs($module, $act, $detail)
{
    global $system, $db_connect;
    if (mysqli_query($db_connect, "INSERT INTO `{$system['prefix']}_logs` VALUES(null,{$_SESSION['admin']['id']},'{$module}','{$act}','{$detail}',NOW())")) {
        return true;
    } else {
        return false;
    }
}

/**
 * @desc   Calculate records on page
 * @param  int $cnt_rows     the count rows
 * @param  int $rows_on_page the limit rows on page
 * @param  int $page         the current page
 * @return array
**/
function record_on_page($cnt_rows, $rows_on_page, $page = 1)
{
    $cnt_pages = ceil($cnt_rows / $rows_on_page);
    if (!is_numeric($page) || $page < 2) {
        $page = 1;
    } elseif ($page > $cnt_pages) {
        $page = $cnt_pages;
    } else {
        $page = (int)$page;
    }
    $finish = $page * $rows_on_page;
    $start  = $finish - $rows_on_page;
    
    return array(
    'cnt_rows'      => $cnt_rows,
    'cnt_pages'     => $cnt_pages,
    'rows_on_page'  => $rows_on_page,
    'page'          => $page,
    'start'         => $start,
    'limit'         => $rows_on_page,
    'finish'        => $finish,
    );
}

/**
 * Print pages on admin
 * @param array  $rec the calculation array
 * @param string $url the prefix url
**/
function echo_on_page_admin($rec, $url)
{
    global $i18n;
    
    $style_class['page1'] = "page_act";
    $style_class['page2'] = "page_disable";
    $style_class['page3'] = "page";
    $style_class['delimiter'] = "|";
    $style_class['delimiter_start'] = "[";
    $style_class['delimiter_finish'] = "]";
    $style_class['align'] = "center";
    
    $max_print_page = "10";
    $position_print_page = "5";
    
    $i = 0;
    $w = $rec['cnt_pages'];

    $echo = "<p align=\"".$style_class['align']."\">".$style_class['delimiter_start'];
    if ($rec['page'] > 1) {
        $echo .= "<a class=\"".$style_class['page3']."\" href=\"".$url.($rec['page']-1)."\">{$i18n['pages']['prev']}</a> ".$style_class['delimiter']." ";
    } else {
        $echo .= "<span class=\"".$style_class['page2']."\">{$i18n['pages']['prev']}</span> ".$style_class['delimiter']." ";
    }
    if ($rec['cnt_pages'] > $max_print_page) {
        if ($rec['page'] > $position_print_page) $i = $rec['page'] - $position_print_page;
        if ($rec['page'] > $position_print_page && ($rec['cnt_pages'] - $rec['page']) < $position_print_page) $i = $rec['cnt_pages'] - $max_print_page;
        $w = $i + $max_print_page;
    } else {
        $count = $rec['cnt_pages'];
    }
    while($i < $w) {
        $i ++;
        if ($i == $rec['page']) {
            $echo .= "<span class=\"".$style_class['page1']."\"> ".$i." </span> ".$style_class['delimiter']." ";
        } else {
            $echo .= "<a href=\"".$url.$i."\" class=\"".$style_class['page3']."\">".$i."</a> ".$style_class['delimiter']." ";
        }
    }
    if ($rec['page'] < $rec['cnt_pages']) {
        $echo .= "<a class=\"".$style_class['page3']."\" href=\"".$url.($rec['page']+1)."\">{$i18n['pages']['next']}</a>".$style_class['delimiter_finish'];
    } else {
        $echo .= "<span class=\"".$style_class['page2']."\">{$i18n['pages']['next']}</span>".$style_class['delimiter_finish'];
    }
    $echo .= "</p>";
    return $echo;
}

/**
 * Print pages in script
 * @param array  $rec the calculation array
 * @param string $url the prefix url
**/
function echo_on_page($rec, $url)
{
    $style_class['page1']               = "sp2_nowpage";
    $style_class['page2']               = "sp2_page";
    $style_class['page3']               = "sp2_page";
    $style_class['delimiter']           = " | ";
    $style_class['delimiter_start']     = "Result Page: ";
    $style_class['delimiter_finish']    = "";
    $style_class['align']               = "center";

    $max_print_page = "10";
    $position_print_page = "5";

    $i = 0;
    $w = $rec['cnt_pages'];

    $echo = "<p class=sp2_page align=\"".$style_class['align']."\">".$style_class['delimiter_start'];
    if ($rec['page'] > 1) {
        $echo .= "<a class=\"".$style_class['page3']."\" href=\"".$url.($rec['page']-1)."\"><strong>Previous</strong></a> ".$style_class['delimiter']." ";
    }
    if ($rec['cnt_pages'] > $max_print_page) {
        if ($rec['page'] > $position_print_page) $i = $rec['page'] - $position_print_page;
        if ($rec['page'] > $position_print_page && ($rec['cnt_pages'] - $rec['page']) < $position_print_page) $i = $rec['cnt_pages'] - $max_print_page;
        $w = $i + $max_print_page;
    } else {
        $count = $rec['cnt_pages'];
    }
    while($i < $w) {
        $i ++;
        if ($i == $rec['page']) {
            $echo .= "<span class=\"".$style_class['page1']."\"> ".$i." </span> ";
        } else {
            $echo .= "<a href=\"".$url.$i."\" class=\"".$style_class['page3']."\">".$i."</a> ";
        }
        if ($i != $w || $rec['page'] != $i) $echo .= $style_class['delimiter'];

    }
    if ($rec['page'] < $rec['cnt_pages']) {
        $echo .= "<a class=\"".$style_class['page3']."\" href=\"".$url.($rec['page']+1)."\"><strong>Next</strong></a>".$style_class['delimiter_finish'];
    }
    $echo .= "</p>";
    return $echo;
}

/**
 * Print style
 * @param array $vars the stylea array
 * @return string the css style
 */
function stl2style($vars)
{
    $styles_vars = array(
    array(1,1,1,1,1,1,0,1,1,1,"field",              ".sp2_field"),
    array(1,1,1,1,1,1,0,1,1,1,"button",             ".sp2_btn"),
    array(1,1,1,1,1,1,0,1,1,1,"input_select",       ".sp2_i_select"),
    array(0,0,0,0,1,1,1,1,1,1,"advanced",           "a.sp2_advanced:link,a.sp2_advanced:active,a.sp2_advanced:visited"),
    array(0,0,0,0,1,1,1,1,1,1,"advanced_hover",     "a.sp2_advanced:hover"),
    array(0,0,0,0,1,1,1,1,1,1,"info_msg",           ".sp2_info"),
    array(0,0,0,0,1,1,1,1,1,1,"title",              "a.sp2_title:link,a.sp2_title:active,a.sp2_title:visited"),
    array(0,0,0,0,1,1,1,1,1,1,"title_hover",        "a.sp2_title:hover"),
    array(0,0,0,0,1,1,1,1,1,1,"result",             ".sp2_result"),
    array(0,0,0,0,1,1,1,1,1,1,"select",             ".sp2_select"),
    array(0,0,0,0,1,1,1,1,1,1,"address",            ".sp2_address"),
    array(0,0,0,0,1,1,1,1,1,1,"pages",              ".sp2_page"),
    array(0,0,0,0,1,1,1,1,1,1,"pages_link",         "a.sp2_page:link,a.sp2_page:active,a.sp2_page:visited"),
    array(0,0,0,0,1,1,1,1,1,1,"pages_link_hover",   "a.sp2_page:hover"),
    array(0,0,0,0,1,1,1,1,1,1,"pages_now",          ".sp2_nowpage")
    );

    $styles_stl = array('border_width','border_style','border_color','background_color','font_family','font_style','text_decoration','text_color','font_size','font_weight');

    $style = "<style type=\"text/css\">";

    reset($styles_vars);
    foreach ($styles_vars as $i) {

        $style .= $i[11].' {';

        if ($i[0] == 1 && $i[1] == 1 && $i[2] == 1) {
            if ($vars["{$i[10]}_{$styles_stl[0]}"] && $vars["{$i[10]}_{$styles_stl[1]}"] && $vars["{$i[10]}_{$styles_stl[2]}"]) {
                $style .= "border:{$vars["{$i[10]}_{$styles_stl[0]}"]}px {$vars["{$i[10]}_{$styles_stl[1]}"]} #{$vars["{$i[10]}_{$styles_stl[2]}"]}; ";
            }
        }
        if ($i[3] == 1 && $vars["{$i[10]}_{$styles_stl[3]}"]) {
            $style .= "background-color:#{$vars["{$i[10]}_{$styles_stl[3]}"]}; ";
        }
        if ($i[4] == 1 && $vars["{$i[10]}_{$styles_stl[4]}"]) {
            $style .= "font-family:{$vars["{$i[10]}_{$styles_stl[4]}"]}; ";
        }
        if ($i[5] == 1 && $vars["{$i[10]}_{$styles_stl[5]}"]) {
            $style .= "font-style:{$vars["{$i[10]}_{$styles_stl[5]}"]}; ";
        }
        if ($i[6] == 1 && $vars["{$i[10]}_{$styles_stl[6]}"]) {
            $style .= "text-decoration:{$vars["{$i[10]}_{$styles_stl[6]}"]}; ";
        }
        if ($i[7] == 1 && $vars["{$i[10]}_{$styles_stl[7]}"]) {
            $style .= "color:#{$vars["{$i[10]}_{$styles_stl[7]}"]}; ";
        }
        if ($i[8] == 1 && $vars["{$i[10]}_{$styles_stl[8]}"]) {
            $style .= "font-size:{$vars["{$i[10]}_{$styles_stl[8]}"]}px; ";
        }
        if ($i[9] == 1 && $vars["{$i[10]}_{$styles_stl[9]}"]) {
            $style .= "font-weight:{$vars["{$i[10]}_{$styles_stl[9]}"]}; ";
        }

        $style .= "\n".'}';
    }

    $style .= "</style>";

    return $style;
}

/**
 * Convert string to utf functions
 * @param string $encoding the string encoding
 * @param string $string   the string
 * @return string
 */
function convert_to_utf($encoding, $string)
{
    if (!extension_loaded("iconv")) {
        return $string;
    } else {
        return iconv($encoding,"UTF-8",$string);
    }
}

/**
 * Convert string from utf functions
 * @param string $encoding the string encoding
 * @param string $string   the string
 * @return string
 */
function convert_from_utf($encoding,$string)
{
    if (!extension_loaded("iconv")) {
        return $string;
    } else {
        return iconv("UTF-8",$encoding,$string);
    }
}

/**
 * @param string $vars
 * @return array
 */
function config_vars2array($vars)
{
    $return = explode("\n",trim($vars));
    $return = array_unique($return);
    sort($return);
    
    $vars_array = array();
    
    foreach ($return as $var) {
        if (!empty($var)) {
            $vars_array[] = trim($var);
        }
    }
    
    return $vars_array;
}

/**
 * @param string $array
 * @return mixed
 */
function config_array2vars($array)
{
    $array = array_unique($array);
    sort($array);
    $vars_array = array();
    
    foreach ($array as $var) {
        if (!empty($var)) {
            $vars_array[] = trim($var);
        }
    }
    
    return join("\n",$vars_array);
}

/**
 * @param string $urls
 * @return array
 */
function config_url2array($urls)
{
    $return = explode("\n",trim($urls));
    $return = array_unique($return);
    sort($return);
    
    $urls_array = array();
    
    foreach ($return as $url) {
        if (!empty($url) && (preg_match("'http://'i", $url) || preg_match("'https://'i", $url))) {
            $urls_array[] = trim($url);
        }
    }
    
    return $urls_array;
}

/**
 * @param string $urls
 * @return array
 */
function config_array2url($array)
{
    $array = array_unique($array);
    sort($array);
    $urls_array = array();
    
    foreach ($array as $url) {
        if (!empty($url) && (preg_match("'http://'i", $url) || preg_match("'https://'i", $url))) {
            $urls_array[] = trim($url);
        }
    }
    
    return join("\n",$urls_array);
}

/**
 * @return string
 * @param string $string
 * @desc Escape special symblols
**/
function pattern_escape($string) {
    $string = addslashes(stripslashes($string));
    $string = quotemeta($string);
    $string = str_replace("\\\'","\'", $string); //AP BUG6
    $string = str_replace("\*","*", $string);
    $string = str_replace("-","\-", $string);
    $string = str_replace("|","\|", $string);
    $string = str_replace("{","\{", $string);
    $string = str_replace("}","\}", $string);
    return $string;
}

/**
 * @return string
 * @param int $size
 * @desc Convert format size
**/
function formatsize($size)
{
    if ($size < 1024) {
        return $size.' bytes';
    } elseif ($size >= 1024 && $size < 1024*1024) {
        return sprintf('%.3f',$size/1024).' Kb';
    } elseif ($size >= 1024*1024 && $size < 1024*1024*1024) {
        return sprintf('%.3f',$size/(1024*1024)).' Mb';
    } else {
        return sprintf('%.3f',$size/(1024*1024*1024)).' Gb';
    }
}

function mem2bytes($memory){
 if(preg_match("/k$/",$memory)){return str_replace("k","",$memory)*1024;}
 if(preg_match("/K$/",$memory)){return str_replace("K","",$memory)*1024;}
 if(preg_match("/m$/",$memory)){return str_replace("m","",$memory)*1024*1024;}
 if(preg_match("/M$/",$memory)){return str_replace("M","",$memory)*1024*1024;}
 if(preg_match("/M$/",$memory)){return str_replace("M","",$memory)*1024*1024;}
 if(preg_match("/g$/",$memory)){return str_replace("g","",$memory)*1024*1024*1024;}
 if(preg_match("/G$/",$memory)){return str_replace("G","",$memory)*1024*1024*1024;}
}



?>