<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: form.php,v2.0 2017/09/30 advocat Exp $ */

if (!defined('SSP_INC')) {
    /** define path */
    define('SSP_DIR', str_replace('\\','/',dirname(__FILE__)));
    /** check installed */
    if (!file_exists(SSP_DIR.'/data/db.php') || !file_exists(SSP_DIR.'/data/config.php')) {
        header("Location: install.php");
        exit;
    }
    /** include files */
    include_once(SSP_DIR.'/data/fixer.php');
    include_once(SSP_DIR.'/data/db.php');
    include_once(SSP_DIR.'/data/config.php');
    include_once(SSP_DIR.'/data/functions.php');
    include_once(SSP_DIR.'/data/system.php');
    
    /** session start */
    session_start();
    
    /** connect to db */
    $db_connect = mysqli_connect($db['host'], $db['login'], $db['passwd']);
    $db_select  = mysqli_select_db($db_connect, $db['name']);
}

/** define urls */
$url_search = $config['site_addr'].(!empty($config['folder']) ? chr(47).$config['folder'] : '').'/index.php';
$url_folder = $config['site_addr'].(!empty($config['folder']) ? chr(47).$config['folder'] : '').chr(47);

if (!defined('SSP_INDEX')) {
    /** groups */
    $groups_array = array();
    $groups_array[0] = array('name'=>$config['label_all_groups']);
    $res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_groups`");
    while ($row = mysqli_fetch_assoc($res)) {
        $groups_array[$row['id']]['name']      = $row['name'];
        $groups_array[$row['id']]['tpl_id']    = $row['tpl_id'];
        $groups_array[$row['id']]['style_id']  = $row['style_id'];
    }
    /** templates */
    $templates_array    = array();
    $template_default   = 0;
    $res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_templates`");
    while ($row = mysqli_fetch_assoc($res)) {
        if ($row['default']) {
            $template_default = $row['id'];
        }
        $templates_array[$row['id']]['header'] = stripslashes($row['header']);
        $templates_array[$row['id']]['footer'] = stripslashes($row['footer']);
    }
    /** styles */
    $styles_array   = array();
    $style_default  = 0;
    $res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_styles`");
    while ($row = mysqli_fetch_assoc($res)) {
        if ($row['default']) {
            $style_default = $row['id'];
        }
        $styles_array[$row['id']]['data'] = unserialize(stripslashes($row['data']));
    }
    
    if (defined('SSP_GROUPID')) {
        $_SESSION['ssp_groupid'] = SSP_GROUPID;
    } elseif (isset($_GET['g']) && isset($groups_array[$_GET['g']])) {
        $_SESSION['ssp_groupid'] = (int)$_GET['g'];
    } else {
        $_SESSION['ssp_groupid'] = 0;
    }
    
    if ($_SESSION['ssp_groupid'] > 0) {
        $_SESSION['ssp_tplid']      = $groups_array[$_SESSION['ssp_groupid']]['tpl_id'];
        $_SESSION['ssp_styleid']    = $groups_array[$_SESSION['ssp_groupid']]['style_id'];
        $style_data                 = $styles_array[$_SESSION['ssp_styleid']]['data'];
    } else {
        if (defined('SSP_STYLEID')) {
            $_SESSION['ssp_styleid'] = SSP_STYLEID;
        } elseif (isset($_GET['s']) && isset($styles_array[$_GET['s']])) {
            $_SESSION['ssp_styleid'] = (int)$_GET['s'];
        } else {
            $_SESSION['ssp_styleid'] = $style_default;
        }
        $style_data = $styles_array[$_SESSION['ssp_styleid']]['data'];
        
        if (defined('SSP_TPLID')) {
            $_SESSION['ssp_tplid'] = SSP_TPLID;
        } elseif (isset($_GET['t']) && isset($templates_array[$_GET['t']])) {
            $_SESSION['ssp_tplid'] = (int)$_GET['t'];
        } else {
            $_SESSION['ssp_tplid'] = $template_default;
        }
    }
    
    if ($style_data['imgbtns'] > 0) {
        $res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_imgbtns` WHERE `id`='{$style_data['imgbtns']}'");
        $row = mysqli_fetch_assoc($res);
        $style_data['imgbtn_tag'] = '<input name="search" type="image" id="search" src="'.$url_folder.'img/buttons/'.$row['image'].'" '.$row['image_tag'].' border="0" align="middle">';
    }
}


if($config["usebooleanexpression"]){
 $formquery_str = isset($_GET['q']) ? convert_to_utf($config['encoding'], $q_str) : "";
}else{
 $formquery_str = isset($query_str) ? convert_to_utf($config['encoding'], $query_str) : "";
};


$write = "<!-- Start of Site Search Pro code -->";
$write .= stl2style($style_data);
$write .= "\n<form action=\"{$url_search}\" method=\"get\" enctype=\"application/x-www-form-urlencoded\" name=\"qs\" id=\"qs\">\n";

$write .= "<div align=\"".$style_data['s_form_alignment']."\">
            <table border=0><tr><td align=\"left\" nowrap><input class=\"sp2_field\" name=\"q\" type=\"text\" id=\"q\" value=\"".htmlspecialchars(stripslashes($formquery_str))."\" maxlength=\"255\" size=\"{$style_data['q_chr_width']}\"> ";

if($style_data['show_dropdown_result_menu'] == "enable"){

 if($_GET['num'] == 10){$selected_10="selected";}else{$selected_10="";};
 if($_GET['num'] == 20){$selected_20="selected";}else{$selected_20="";};
 if($_GET['num'] == 30){$selected_30="selected";}else{$selected_30="";};
 if($_GET['num'] == 50){$selected_50="selected";}else{$selected_50="";};
 if($_GET['num'] == 100){$selected_100="selected";}else{$selected_100="";};

 $write .="<select name=\"num\">\n";
 $write .=" <option value=\"10\" $selected_10>".$i18n['style']['10_results']."</option>\n";
 $write .=" <option value=\"20\" $selected_20>".$i18n['style']['20_results']."</option>\n";
 $write .=" <option value=\"30\" $selected_30>".$i18n['style']['30_results']."</option>\n";
 $write .=" <option value=\"50\" $selected_50>".$i18n['style']['50_results']."</option>\n";
 $write .=" <option value=\"100\" $selected_100>".$i18n['style']['100_results']."</option>\n";
 $write .="</select>\n";
}

if ($style_data['result_groups'] && $style_data['show_search_group']=='dropdownbox') {
    $write .= '<select name="g" id="g" class=sp2_i_select>';
    foreach ($groups_array as $key => $vals) {
        $write .= '<option value="'.$key.'"';
        if ($key == $_SESSION['ssp_groupid']) $write .= ' selected';
        $write .= '>'.htmlspecialchars($vals['name']).'</option>';
    }
    $write .= '</select> ';
} else {
    if ($_SESSION['ssp_groupid'] > 0 && !$style_data['result_groups']) {
        $write .= '<input type=hidden name="g" value="'.$_SESSION['group_id'].'">';
    }
}

if ($style_data['imgbtns'] == 0) {
    $write .= "<input class=\"sp2_btn\" name=\"search\" type=\"submit\" id=\"search\" value=\"{$config['label_button']}\">\n";
} else {
    $write .= $style_data['imgbtn_tag']."\n";
} if ($style_data['print_advanced'] == 1) {
   if($style_data['result_groups'] && $style_data['show_search_group']=='dropdownbox'){
    $write .= "<a class=\"sp2_advanced\" href=\"{$url_folder}advanced_search.php?g={$_SESSION['ssp_groupid']}".($formquery_str ? "&q=".urlencode($formquery_str) : "")."\">{$config['label_advanced']}</a>\n";
   }else{
    $write .= "<a class=\"sp2_advanced\" href=\"{$url_folder}advanced_search.php?g={$_SESSION['ssp_groupid']}".($formquery_str ? "&q=".urlencode($formquery_str) : "")."\">{$config['label_advanced']}</a>\n";   
   }
}
   $write .="</td></tr><tr><td align=\"left\" class=\"sp2_page\">";

if ($style_data['search_in_result_box'] == "enable"){
    $write .="";
    if(isset($_GET['search_in_result'])){
     $write .="<input type=\"checkbox\" name=\"search_in_result\" checked> ".$i18n['style']['search_in_results'];
    }else{
     $write .="<input type=\"checkbox\" name=\"search_in_result\"> ".$i18n['style']['search_in_results'];    
    }
}


if ($style_data['result_groups'] && $style_data['show_search_group']=='checkboxes') {
    $write .="<br />";
    $cnt_g = 0;
    foreach ($groups_array as $key => $vals) {
     if($vals['name'] == "All groups"){continue;};
     $cnt_g++;
     if(isset($_GET['g_'.$key])){
      $write .= "<input type=\"checkbox\" name=\"g_".$key."\" checked> ".$vals['name']." ";
     }else{
      $write .= "<input type=\"checkbox\" name=\"g_".$key."\" > ".$vals['name']." ";     
     }
     if($cnt_g == 3){
      $write .="<br>";
      $cnt_g = 0;
     };
    }
}

if ($style_data['result_groups'] && $style_data['show_search_group']=='radiobuttons') {
    $write .="<br />";
    $cnt_g = 0;
    foreach ($groups_array as $key => $vals) {
     $cnt_g++;
     if($_GET['g'] == $key){
      $write .= "<input type=\"radio\" name=\"g\" value=\"".$key."\" checked> ".$vals['name']." ";
     }else{
      $write .= "<input type=\"radio\" name=\"g\" value=\"".$key."\"> ".$vals['name']." ";     
     }

     if($cnt_g == 3){
      $write .="<br>";
      $cnt_g = 0;
     };

    }
}


$write .= "</td></tr></table></div></form>";
$write .= "\n<!-- End of Site Search Pro code -->";

if (isset($_GET['mode']) && $_GET['mode'] == "js" && !defined('SSP_INC')) {
    $js_code = "document.write(\"".str_replace("\n","\"+\n               \"",addslashes($write))."\");";
    echo convert_from_utf($config['encoding'], $js_code);
} else {
    echo convert_from_utf($config['encoding'], $write);
}

?>