<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: index.php,v2.0 2017/10/29 advocat Exp $ */

/** define path */
define('SSP_DIR', str_replace('\\', '/', dirname(__FILE__)));

/** check installed */
if (!file_exists(SSP_DIR.'/data/db.php') || !file_exists(SSP_DIR.'/data/config.php')) {
    header("Location: install.php");
    exit;
}



/** include fixer */
//include(SSP_DIR.'/data/fixer.php');
/** session start */
session_start();
/** set time limit */
@set_time_limit(0);

/** include files */
include_once (SSP_DIR.'/data/config.php');
include_once (SSP_DIR.'/data/db.php');
include_once (SSP_DIR.'/data/system.php');
include_once (SSP_DIR.'/data/functions.php');
include_once (SSP_DIR.'/data/stop_words.php');
include_once (SSP_DIR.'/data/i18n.php');
include_once (SSP_DIR.'/data/boolean.php');

/** Check executed time */
    $mtime = microtime();
    $mtime = explode(" ",$mtime);
    $mtime = $mtime[1] + $mtime[0];
    $tstart = $mtime;


/** connect to db */
$db_connect = mysqli_connect($db['host'], $db['login'], $db['passwd']);
$db_select  = mysqli_select_db($db_connect, $db['name']);

//print simple_query($_GET['q'])."<br>";
//print complex_query($_GET['q'])."<br>";

/** define inc */
define('SSP_INC', true);
define('SSP_INDEX', true);

/** page */
if (!isset($_GET['p'])) {
    $p = 1;
} else {
    $p = (int)$_GET['p'];
}

/** result on page */
$num_array = array(10,20,30,50,100);
if (isset($_GET['num']) && in_array($_GET['num'], $num_array)) {
    $result_on_page = (int)$_GET['num'];
} else {
    $result_on_page = $config['result_on_page'];
}

/** result status */
$print_result       = false;
$print_not_found    = false;
$print_min_chr      = false;
$print_boolean      = false;

/** groups */
$groups_array = array();
$groups_array[0] = array('name'=>$config['label_all_groups']);
$res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_groups`");
while ($row = mysqli_fetch_assoc($res)) {
    $groups_array[$row['id']]['name']      = $row['name'];
    $groups_array[$row['id']]['tpl_id']    = $row['tpl_id'];
    $groups_array[$row['id']]['style_id']  = $row['style_id'];
}
/** templates */
$templates_array    = array();
$template_default   = 0;
$res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_templates`");
while ($row = mysqli_fetch_assoc($res)) {
    if ($row['default']) {
        $template_default = $row['id'];
    }
    $templates_array[$row['id']]['header'] = stripslashes($row['header']);
    $templates_array[$row['id']]['footer'] = stripslashes($row['footer']);
}
/** styles */
$styles_array   = array();
$style_default  = 0;
$res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_styles`");
while ($row = mysqli_fetch_assoc($res)) {
    if ($row['default']) {
        $style_default = $row['id'];
    }
    $styles_array[$row['id']]['data'] = unserialize(stripslashes($row['data']));
}

if (isset($_GET['g']) && isset($groups_array[$_GET['g']])) {
    $_SESSION['ssp_groupid'] = (int)$_GET['g'];
} elseif (!isset($_SESSION['ssp_groupid'])) {
    $_SESSION['ssp_groupid'] = 0;
}

if ($_SESSION['ssp_groupid'] > 0) {
    $_SESSION['ssp_tplid']      = $groups_array[$_SESSION['ssp_groupid']]['tpl_id'];
    $_SESSION['ssp_styleid']    = $groups_array[$_SESSION['ssp_groupid']]['style_id'];
    $style_data                 = $styles_array[$_SESSION['ssp_styleid']]['data'];
} else {
    if (defined('SSP_STYLEID')) {
        $_SESSION['ssp_styleid'] = SSP_STYLEID;
    } elseif (isset($_GET['s']) && isset($styles_array[$_GET['s']])) {
        $_SESSION['ssp_styleid'] = (int)$_GET['s'];
    } else {
        $_SESSION['ssp_styleid'] = $style_default;
    }
    $style_data = $styles_array[$_SESSION['ssp_styleid']]['data'];

    if (defined('SSP_TPLID')) {
        $_SESSION['ssp_tplid'] = SSP_TPLID;
    } elseif (isset($_GET['t']) && isset($templates_array[$_GET['t']])) {
        $_SESSION['ssp_tplid'] = (int)$_GET['t'];
    } else {
        $_SESSION['ssp_tplid'] = $template_default;
    }
}

$header_tpl = $templates_array[$_SESSION['ssp_tplid']]['header'];
$footer_tpl = $templates_array[$_SESSION['ssp_tplid']]['footer'];

if ($style_data['imgbtns'] > 0) {
    $url_folder = $config['site_addr'].(!empty($config['folder']) ? chr(47).$config['folder'] : '').chr(47);
    $res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_imgbtns` WHERE `id`='{$style_data['imgbtns']}'");
    $row = mysqli_fetch_assoc($res);
    $style_data['imgbtn_tag'] = '<input name="search" type="image" id="search" src="'.$url_folder.'img/buttons/'.$row['image'].'" '.$row['image_tag'].' border="0" align="middle">';
}

/** rules */
$rules = array();
$res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_rules` WHERE `enable`='1' ORDER BY `term`");
while ($row = mysqli_fetch_assoc($res)) {
    $rules[trim($row['term'])] = $row['url'];
}

/** advanced search */
$as_epq = $as_oq = $as_eq = $as_q = "";
$cnt = 0;

if (isset($_GET['epq']) && $_GET['epq']) {
    if($config["ignorespecialsymbols"]){
       $_GET['epq'] = preg_replace("/[^\w\x7F-\xFF\s]/", "", $_GET['epq']);    
    }
    $as_epq = '"'.trim($_GET['epq']).'"';
} if (isset($_GET['oq'])) {
    if($config["ignorespecialsymbols"]){
       $_GET['oq'] = preg_replace("/[^\w\x7F-\xFF\s]/", "", $_GET['oq']);    
    }
    $as_oq = preg_split("/\s+/", trim($_GET['oq']));
    $as_oq = join(" OR ", $as_oq);
} if (isset($_GET['eq']) && $_GET['eq']) {
    if($config["ignorespecialsymbols"]){
       $_GET['eq'] = preg_replace("/[^\w\x7F-\xFF\s]/", "", $_GET['eq']);    
    }
    $as_eq = preg_split("/\s+/", $_GET['eq']);
    $as_eq = '-'.trim(join(" -", $as_eq));
} if (isset($_GET['q'])) {
    if($config["ignorespecialsymbols"]){
       $_GET['q'] = preg_replace("/[^\w\x7F-\xFF\s]/", "", $_GET['q']);    
    }
    $as_q = trim($_GET['q']);
}

$query_str = trim($as_epq.' '.$as_oq.' '.$as_eq.' '.$as_q);
$epq = $oq = $eq = $rq = $q  = array();

$stop_word = false;

if (strlen($query_str) > $config['min_chr_word']) {
    if (get_magic_quotes_gpc()) {
        $query_str = stripslashes(urldecode(urlencode($query_str)));
    } else {
        $query_str = urldecode(urlencode($query_str));
    }
    $query_str = str_replace("\\"," ",$query_str);
    $query_str = str_replace("/"," ",$query_str);
    $query_str = str_replace("'","\'", $query_str);

    reset ($stop_words);
    foreach ($stop_words as $v) {
        if (preg_match("'{$v}'i", $query_str)) {
            preg_replace("'{$v}'i", "", $query_str);
            $stop_word = true;
        }
    }

    $query_array = preg_split("/\s+/", $query_str);
    
    $epq_mode = $oq_mode = $epq_key = 0;
    
    foreach ($query_array as $key => $word) {
        $word = trim($word);
        

        if (isset($rules[$word])) {
            header("Location: ".$rules[$word]);
            exit;
        }
        
        if (!$epq_mode && !preg_match("/^\+/",$word) && !preg_match("/^OR$/i", $word) && strlen($word) < $config['min_chr_word']) {
            continue;
        }
        if (!$epq_mode) {
            if (preg_match("/^\"/", $word)) {
                if (!preg_match("/\"$/", $word)) {
                    $epq[$epq_key] = pattern_escape(substr($word,1));
                    $epq_mode = 1;
                    continue;
                }
                else {
                    $epq[$epq_key] = pattern_escape(substr($word,1,-2));
                    $epq_key++;
                    continue;
                }
            }
        } else {
            if (preg_match("/\"$/", $word)) {
                $epq[$epq_key] .= ' '.pattern_escape(substr($word,0, -1));
                $epq_key++;
                $epq_mode = 0;
                continue;
            } else {
                $epq[$epq_key] .= ' '.pattern_escape($word);
                continue;
            }
        }
        if (!$oq_mode) {
            if (isset($query_array[($key+1)]) && preg_match("/^OR$/i",$query_array[($key+1)])) {
                if (!in_array($word, $stop_words)) {
                    $oq[] = pattern_escape($word);
                } else {
                    $stop_word = true;
                }
                $oq_mode = 1;
                continue;
            }
        } else {
            if (preg_match("/^OR$/i",$word)) {
                continue;
            } else {
                if (!in_array($word, $stop_words)) {
                    $oq[] = pattern_escape($word);
                } else {
                    $stop_word = true;
                }
                if (isset($query_array[($key+1)]) && preg_match("/^OR$/i",$query_array[($key+1)])) {
                    continue;
                } else {
                    $oq_mode = 0;
                    continue;
                }
            }
        }
        if (preg_match("/^\+/", $word)) {
            $rq[] = pattern_escape(substr($word,1));
            continue;
        }
        if (preg_match("/^\-/", $word)) {
            $eq[] = pattern_escape(substr($word,1));
            continue;
        }
        if (!in_array($word, $stop_words)) {
            $q[] = pattern_escape($word);
        } else {
            $stop_word = true;
        }
    }
} else {
    if (strlen($query_str) > 0) {
        $print_min_chr = true;
    }
}

$count_epq  = sizeof($epq);
$count_oq   = sizeof($oq);
$count_eq   = sizeof($eq);
$count_rq   = sizeof($rq);
$count_q    = sizeof($q);

$count_all  = $count_epq + $count_oq + $count_eq + $count_rq + $count_q;

if ($count_all == $count_eq && $count_all > 0) {
    $print_not_found = true;
} elseif ($count_all > 0) {
    $mysqli_version = mysqli_get_server_info($db_connect);
    if (!$mysqli_version) {
        $mysqli_version = '3.23.32';
    }
    $match = explode('.', $mysqli_version);
    if (!isset($match[0])) {
        $match[0] = 3;
    }
    if (!isset($match[1])) {
        $match[1] = 23;
    }
    if (!isset($match[2])) {
        $match[2] = 32;
    }
    $mysqli_int_version = (int)sprintf('%d%02d%02d', $match[0], $match[1], intval($match[2]));
    if ($mysqli_int_version >= 40001) {
        $IN_BOOLEAN_MODE = ' IN BOOLEAN MODE';
    } else {
        $IN_BOOLEAN_MODE = '';
    }
    
    $print_result = true;
    
    $sql_where = 'WHERE `ignore`=\'0\'';
    $sql_where_boolean = 'WHERE `ignore`=\'0\'';
    
    /** groups */
    // Multiple groups selections
    $SQL = "SELECT id FROM `{$system['prefix']}_groups`";
    $res = mysqli_query($db_connect, $SQL);
    $group_ids = "";
    while($row = mysqli_fetch_row($res)){
     if(isset($_GET['g_'.$row[0]])){
      if($group_ids == ""){$group_ids = $row[0];}else{$group_ids .= "|".$row[0];};
     };
    };
    if($group_ids != ""){
        $sql_where          .= ' AND `groups` REGEXP \'(^('.$group_ids.'),|^('.$group_ids.')$|,('.$group_ids.'),|,('.$group_ids.')$)\'';
        $sql_where_boolean  .= ' AND `groups` REGEXP \'(^('.$group_ids.'),|^('.$group_ids.')$|,('.$group_ids.'),|,('.$group_ids.')$)\'';
    }
    
    if ($_SESSION['ssp_groupid'] > 0 && $group_ids == "") {
        $sql_where          .= ' AND `groups` REGEXP \'(^'.$_SESSION['ssp_groupid'].',|^'.$_SESSION['ssp_groupid'].'$|,'.$_SESSION['ssp_groupid'].',|,'.$_SESSION['ssp_groupid'].'$)\'';
        $sql_where_boolean  .= ' AND `groups` REGEXP \'(^'.$_SESSION['ssp_groupid'].',|^'.$_SESSION['ssp_groupid'].'$|,'.$_SESSION['ssp_groupid'].',|,'.$_SESSION['ssp_groupid'].'$)\'';
    }


//AP Enable boolean search
    if($config["usebooleanexpression"]){

     if ($count_q > 0) {
        $sql_where_bool_q   = ' MATCH(`text`) AGAINST (\' +'.join(' +', $q).'\' '.$IN_BOOLEAN_MODE.')'; //AP BUG4
     }
         
         
         // Agregate all query strings to singe line
         $q_str = $_GET["q"]." ";

         if(isset($_GET["epq"]) && strlen($_GET["epq"])>0){
          $q_str .='"'.$_GET["epq"].'" ';
         }
         
         if(isset($_GET["oq"]) && strlen($_GET["oq"])>0){
          $q_str .="OR ".str_replace(" "," OR ",$_GET["oq"])." ";
         }

         if(isset($_GET["eq"]) && strlen($_GET["eq"])>0){
          $q_str .="NOT ".str_replace(" "," NOT ",$_GET["eq"]);
         }

//         print $q_str."<br>";
         // Parse search query
         $sql_where .= simple_query($q_str);
         $sql_where_boolean .= complex_query($q_str);       

         $sql_where = str_replace("'WHERE","' AND",$sql_where);
         $sql_where_boolean = str_replace("'WHERE","' AND",$sql_where_boolean);

         $sql_where = str_replace("ANDOR","AND",$sql_where);
         $sql_where_boolean = str_replace("ANDOR","OR",$sql_where_boolean);
         $sql_where = str_replace("ANDAND","AND",$sql_where);
         $sql_where_boolean = str_replace("ANDAND","AND",$sql_where_boolean);
         $sql_where = str_replace("ANDNOT","AND NOT",$sql_where);
         $sql_where_boolean = str_replace("ANDNOT","AND NOT",$sql_where_boolean);


         
//         print $sql_where."<br>";
//         print $sql_where_boolean."<br>";
    }else{



    /** EPQ */
    if ($count_epq > 0) {
        foreach ($epq as $word) {
            $sql_where          .= ' AND `text` LIKE \'%'.$word.'%\'';
            $sql_where_boolean  .= ' AND `text` LIKE \'%'.$word.'%\'';
        }
    }
    /** OQ */
    if ($count_oq > 0) {
        $sql_where          .= ' AND `text` REGEXP \' '.join(' | ', $oq).' \'';
        $sql_where_boolean  .= ' AND `text` REGEXP \' '.join(' | ', $oq).' \'';

    }
    /** EQ */
    if ($count_eq > 0) {
        $sql_where          .= ' AND `text` NOT REGEXP \' '.join(' | ', $eq).' \' ';
        $sql_where_boolean  .= ' AND `text` NOT REGEXP \' '.join(' | ', $eq).' \' ';

    }
    /** RQ */
    if ($count_rq > 0) {
        foreach ($rq as $word) {
            $sql_where          .= ' AND `text` LIKE \'% '.$word.' %\'';
            $sql_where_boolean  .= ' AND `text` LIKE \'% '.$word.' %\'';
        }
    }

    /** Q */
    if ($count_q > 0) {
//AP        $sql_where          .= ' AND `text` REGEXP \' '.join(' | ', $q).' \'';
        foreach($q as $q_text){                                 //AP BUG4
         $sql_where .= ' AND `text` LIKE \'% '.$q_text.' %\'';  //AP BUG4
        };                                                      //AP BUG4
        $sql_where_bool_q   = ' MATCH(`text`) AGAINST (\' +'.join(' +', $q).'\' '.$IN_BOOLEAN_MODE.')'; //AP BUG4
        $sql_where_boolean  .= ' AND'.$sql_where_bool_q;
    }
   }
  } else {
    if (strlen($query_str) > 0) {
        if ($stop_word) {
            $print_not_found = true;
        } else {
            $print_min_chr  = true;
        }
    }
  }
 



//    print $sql_where."<br>";
//    print $sql_where_boolean;

if($style_data['search_in_result_box'] == "enable"){
 if(!isset($_GET['search_in_result'])){
  $_SESSION['sql_where'] = $sql_where;
  $_SESSION['sql_where_boolean'] = $sql_where_boolean;
 }
}

if(isset($_SESSION['sql_where']) && $style_data['search_in_result_box'] == "enable" && isset($_GET['search_in_result'])){
// print "Prev_where: ".$_SESSION['sql_where']."<br>";
// print "New_where: ".$sql_where."<br>";
// print "Combine: ".str_replace("WHERE ","WHERE (",$_SESSION['sql_where']).") AND (".str_replace("WHERE ","",$sql_where).")<br><br>";
   $sql_where = str_replace("WHERE ","WHERE (",$_SESSION['sql_where']).") AND (".str_replace("WHERE ","",$sql_where).")";

// print "Prev_where_b: ".$_SESSION['sql_where_boolean']."<br>";
// print "New_where_b: ".$sql_where_boolean."<br>";
// print "Combine: ".str_replace("WHERE ","WHERE (",$_SESSION['sql_where_boolean']).") AND (".str_replace("WHERE ","",$sql_where_boolean).")<br><br>";
   $sql_where_boolean = str_replace("WHERE ","WHERE (",$_SESSION['sql_where_boolean']).") AND (".str_replace("WHERE ","",$sql_where_boolean).")";

}

if ($print_result) {
    $sortdb = false;
    $sql = '';
    $cnt = 0;
    if ($count_q > 0) {
    
        $SQL = "SELECT COUNT(*) FROM `{$system['prefix']}_search_db` {$sql_where_boolean}";
//        print $SQL;
        if (function_exists('mysqli_set_charset')){
         mysqli_set_charset($db_connect, 'utf8');
        }else{
         mysqli_query($db_connect, "set names utf8");
        }
        $res_cnt_bool   = mysqli_query($db_connect, $SQL);
        $row = mysqli_fetch_row($res_cnt_bool);
        $row_cnt_bool   = intval($row[0] ?? 0);
        if ($row_cnt_bool == 0) {
            $SQL2 = "SELECT COUNT(*) FROM `{$system['prefix']}_search_db` {$sql_where}";
//          print $SQL2;
            if (function_exists('mysqli_set_charset')){
             mysqli_set_charset($db_connect,'utf8');
            }else{
             mysqli_query($db_connect,"set names utf8");
            }
            $res_cnt    = mysqli_query($db_connect, $SQL2);
            $row = mysqli_fetch_row($res_cnt);
            $row_cnt    = intval($row[0] ?? 0);
            if ($config['boolean_only'] && $row_cnt > 0) {
                $print_boolean  = true;
                $print_result   = false;
            } elseif (!$config['boolean_only'] && $row_cnt > 0) {
                $sql = "SELECT * FROM `{$system['prefix']}_search_db` {$sql_where}";
                $cnt = $row_cnt;
            } else {
                $print_not_found    = true;
                $print_result       = false;
            }
            $sortdb = false;
        } else {
            $sortdb = true;
//            $sql = "SELECT `id`,`url`,`title`,`size`,`date`,`text` FROM `{$system['prefix']}_search_db` {$sql_where_boolean}";
            $sql = "SELECT `id`,`url`,`title`,`size`,`date`,`text`, {$sql_where_bool_q} AS `scope` FROM `{$system['prefix']}_search_db` {$sql_where_boolean}";
            $cnt = $row_cnt_bool;
        }
    } else {
        $sortdb  = false;
        $SQL = "SELECT COUNT(*) FROM `{$system['prefix']}_search_db` {$sql_where}";
//        print $SQL."<br>";
        if (function_exists('mysqli_set_charset')){
         mysqli_set_charset($db_connect,'utf8');
        }else{
         mysqli_query($db_connect,"set names utf8");
        }
        $res_cnt = mysqli_query($db_connect, $SQL);
        $row = mysqli_fetch_row($res_cnt);
        $row_cnt = intval($row[0] ?? 0);
        if ($row_cnt > 0) {
            $sql = "SELECT * FROM `{$system['prefix']}_search_db` {$sql_where}";
            $cnt = $row_cnt;
        } else {
            $print_not_found    = true;
            $print_result       = false;
        }
    }    

    if ($print_result) {
        $rec = record_on_page($cnt, $result_on_page, $p);
        $relevance = true;
        //AP Do search query

        if ($config['sortby'] != "relevance") {
            $relevance = false;
            $sql_sort = array('title'=>'title','filename'=>'url','date'=>'date');
            $res = mysqli_query($sql.' ORDER BY `'.$sql_sort[$config['sortby']].'` LIMIT '.$rec['start'].','.$rec['limit']);
        } else {
            if ($sortdb) {
                $relevance = false;
                $res = mysqli_query($db_connect, $sql.' ORDER BY `scope` DESC LIMIT '.$rec['start'].','.$rec['limit']);
            } else {
                $res = mysqli_query($db_connect, $sql);
            }
        }

//        print $sql;

        while ($row = mysqli_fetch_assoc($res)) {
            $results_array[$row['id']] = $row;
        }
        
        $pattern = array();
        if ($count_epq > 0) {
            foreach ($epq as $epq_word) {
                $pattern[] = pattern_escape($epq_word);
            }
        }
        if ($count_oq > 0) {
            foreach ($oq as $oq_word) {
                $pattern[] = pattern_escape($oq_word);
            }
        } if ($count_rq > 0) {
            foreach ($rq as $rq_word) {
                $pattern[] = pattern_escape($rq_word);
            }
        } if ($count_q > 0) {
            foreach ($q as $q_word) {
                $pattern[] = pattern_escape($q_word);
            }
        }
//        $pattern = '/( '.join(' ?| ?', $pattern).' )/siU';

        if($config["usebooleanexpression"]){
         if(array_search('AND',$pattern,true)){unset($pattern[array_search('AND',$pattern,true)]);}
         if(array_search('and',$pattern,true)){unset($pattern[array_search('and',$pattern,true)]);}
         if(array_search('OR',$pattern,true)){unset($pattern[array_search('OR',$pattern,true)]);}
         if(array_search('or',$pattern,true)){unset($pattern[array_search('or',$pattern,true)]);}
         if(array_search('NOT',$pattern,true)){unset($pattern[array_search('NOT',$pattern,true)]);}
         if(array_search('not',$pattern,true)){unset($pattern[array_search('not',$pattern,true)]);}
        };

        $pattern = '/('.join('|', $pattern).')/siU';
//        print $pattern;
        foreach ($results_array as $id => $row) {
    

            preg_match_all($pattern, stripslashes($row['text']), $match);
            $results[$id]['relevance']      = sizeof($match[0]);
            $results[$id]['title']          = stripslashes($row['title']);
            $results[$id]['description']    = '';
            $results[$id]['url']            = $row['url'];
            $results[$id]['url_print']      = preg_replace("/^(http[s]?\:\/\/)(.*)/siU","\\2", $row['url']);
            $results[$id]['size']           = $row['size'];
            $results[$id]['date']           = $row['date'];
            
            if ($style_data['result_description'] == "1") {
                if ($style_data['result_show_meta'] == "1") {
                    $description = stripslashes($row['description']);
                    $description = wordwrap($description, 100, '|');
                    // Correcting BUG1 by AP
                    // Add whitespaces for correct preg_replace executing
                    $description = str_replace("|"," | ",$description);


                    $description = explode('|', $description);
                    foreach ($description as $string) {
                        $results[$id]['description'] .= " ".preg_replace($pattern, "<span class=\"sp2_select\">\\1</span>", $string)." ";
                    }   
     
                } else {
                    $text_array = wordwrap(stripslashes($row['text']), 100, '|');
                    $text_array = str_replace("|"," | ",$text_array); //AP - BUG1
                    $text_array = explode("|", $text_array);
                    $w = 0;
                    foreach ($text_array as $string) {
                        if (preg_match($pattern, $string)) {
                            $w ++;
                            if ($w > $config['concordances']) {
                                break;
                            }
                            $results[$id]['description'] .= " ".preg_replace($pattern, "<span class=\"sp2_select\">\\1</span>", $string)." ";
                        }
                    }
                    $results[$id]['description'] = trim($results[$id]['description']);
                }
            }
        }
        if ($relevance) {
            $results4sort = $results;
            function cmp($a, $b) {
                if ($a['relevance'] == $b['relevance']) {
                    return 0;
                }
                return ($a['relevance'] > $b['relevance']) ? -1 : 1;

            }
            usort($results4sort, "cmp");
            $results = array();
            $i = 0;
            foreach ($results4sort as $row) {
                $i++;
                if ($i < $rec['start'] || $i > $rec['finish']) {
                    continue;
                }
                $results[] = $row;
            }
        }
    }
}

/** client ip address */
if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
    $ip_addr = $_SERVER['REMOTE_ADDR'].":".$_SERVER['HTTP_X_FORWARDED_FOR'];
} elseif (getHostByAddr($_SERVER['REMOTE_ADDR']) != $_SERVER['REMOTE_ADDR']) {
    $ip_addr = $_SERVER['REMOTE_ADDR']." (".getHostByAddr($_SERVER['REMOTE_ADDR']).")";
} else {
    $ip_addr = $_SERVER['REMOTE_ADDR'];
}

if (!isset($_SESSION['ssp_qs'])) {
    $_SESSION['ssp_qs'] = '';
} if ($_SESSION['ssp_qs'] != $query_str) {
    if ($query_str) {
        mysqli_query($db_connect, "INSERT INTO `{$system['prefix']}_search_query` VALUES(null, '{$query_str}',{$_SESSION['ssp_groupid']},{$cnt},{$_SESSION['ssp_styleid']},{$_SESSION['ssp_tplid']},'".(isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : "")."','{$ip_addr}',NOW())");
        $_SESSION['ssp_qs'] = $query_str;
    }
}

/** print header */
echo $header_tpl;

/** include form */
include (SSP_DIR.'/form.php');

print "<div align=\"".$style_data['s_result_alignment']."\">\n";

/** bolean */
if ($print_boolean) {
    echo '<p class="sp2_info" align="'.$style_data['info_msg_align'].'">'.str_replace('[query_string]', htmlspecialchars(stripslashes($query_str)), stripslashes($config['label_boolean'])).'</p>';
    if($style_data["show_suggestions"] == "1"){
     echo $i18n['search']['suggestions'];
    }
}
/** min char */
elseif ($print_min_chr) {
    echo '<p class="sp2_info" align="'.$style_data['info_msg_align'].'">'.str_replace('[min_symbols]', $config['min_chr_word'], stripslashes($config['label_error_min'])).'</p>';
}
/** not found */
elseif ($print_not_found) {
    echo '<p class="sp2_info" align="'.$style_data['info_msg_align'].'">'.str_replace('[query_string]', htmlspecialchars(stripslashes($query_str)), stripslashes($config['label_error_found'])).'</p>';
    if($style_data["show_suggestions"] == "1"){
     echo $i18n['search']['suggestions'];
    }
}
/** print result */
elseif ($print_result) {
//    echo '<p class="sp2_info" align="'.$style_data['info_msg_align'].'">'.str_replace('[query_string]', htmlspecialchars(stripslashes($query_str)), str_replace('[cnt_result]', $cnt, stripslashes($config['label_search_res']))).'</p>';

if($rec['start']+$rec['limit']>$cnt){$endpage = $cnt;}else{$endpage = $rec['start']+$rec['limit'];};

print "<table class=\"t\" style=\"BORDER-TOP: #".$style_data['search_result_header_top_border_color']." 1px solid\" cellSpacing=\"0\" cellPadding=\"2\" width=\"100%\" border=\"0\" id=\"table8\" bgcolor=\"#".$style_data['search_result_header_background']."\">
    <tr>
        <td noWrap style=\"color: #000; font-family: arial,sans-serif\">
        <font >&nbsp;<b>Search Results</b></font>&nbsp;</td>
        <td noWrap align=\"right\" style=\"color: #000; font-family: arial,sans-serif\">
        <font size=\"-1\">Results ".($rec['start']+1)." - ".$endpage." of ".$cnt." 
        for <b>";

        if($config["usebooleanexpression"]){
         $s_string = str_replace(" AND "," ",$q_str);
         $s_string = str_replace(" and "," ",$s_string);
         $s_string = str_replace(" && "," ",$s_string);
         $s_string = str_replace(" NOT "," ",$s_string);
         $s_string = str_replace(" not "," ",$s_string);
         $s_string = str_replace(" OR "," ",$s_string);
         $s_string = str_replace(" or "," ",$s_string);
         $s_string = str_replace(" || "," ",$s_string);
         $s_string = str_replace("\"","",$s_string);
         $s_string = str_replace("*","",$s_string);
        }else{
         $s_string = $query_str;
        };
        $s_words = explode(" " ,$s_string);
        foreach($s_words as $s_word){
        print "<a href=\"".$_SERVER['PHP_SELF'].'?q='.urlencode($s_word).'&g='.$_SESSION['ssp_groupid'].'&num='.$result_on_page."\" style=\"color: #000; font-family: arial,sans-serif\">".$s_word."</a> ";
        }
//        <a href=\"#\" style=\"color: #000; font-family: arial,sans-serif\">pink</a> 
//        <a href=\"#1\" style=\"color: #000; font-family: arial,sans-serif\">floyd</a> 

    $mtime = microtime();   
    $mtime = explode(" ",$mtime); 
    $mtime = $mtime[1] + $mtime[0]; 
    $tend = $mtime; 
    $total = ($tend - $tstart);

print " - </b>".sprintf("%0.2f",$total)." sec</font></td>
    </tr>
</table>";

    
    $allow_ext2 = explode(',', $config['allow_ext']);
    foreach ($allow_ext2 as $ext) {
        $pattern_ext[] = pattern_escape($ext);
    }
    $pattern_ext = "/(".join("|", $pattern_ext).")$/si";

    $i=0; //AP
    foreach ($results as $id => $vals) {
        echo '<p>';
        
        // Check icon or file description         //AP
        $icon = "";

        if(preg_match("/pdf$/i",$vals['url'])){   //PDF File
         switch($style_data['highlight_pdf']){
          case 'icon': 
            $icon = '<img border="0" src="img/pdf.gif" width="16" height="16"> ';
            break;
          case 'text':
            $icon = '[PDF] ';
            break;
          case 'none':
            $icon = '';
            break;
         };
        };

        if(preg_match("/doc$/i",$vals['url']) || preg_match("/docx$/i",$vals['url'])){   //DOC File
         switch($style_data['highlight_doc']){
          case 'icon': 
            $icon = '<img border="0" src="img/doc.gif" width="16" height="16"> ';
            break;
          case 'text':
            $icon = '[DOC] ';
            break;
          case 'none':
            $icon = '';
            break;
         };
        };

        if(preg_match("/xls$/i",$vals['url']) || preg_match("/xlsx$/i",$vals['url'])){   //XLS File
         switch($style_data['highlight_xls']){
          case 'icon': 
            $icon = '<img border="0" src="img/xls.gif" width="16" height="16"> ';
            break;
          case 'text':
            $icon = '[XLS] ';
            break;
          case 'none':
            $icon = '';
            break;
         };
        };

        if(preg_match("/txt$/i",$vals['url'])){   //TXT File
         switch($style_data['highlight_txt']){
          case 'icon': 
            $icon = '<img border="0" src="img/txt.gif" width="16" height="16"> ';
            break;
          case 'text':
            $icon = '[TXT] ';
            break;
          case 'none':
            $icon = '';
            break;
         };
        };


        /** print url or title */
        if ($style_data['result_title'] == "1" && $vals['title']) {
            $title = $icon.'<a class="sp2_title" href="'.$vals['url'].'">'.$vals['title'].'</a>';
        } else {
            $title = $icon.'<a class="sp2_title" href="'.$vals['url'].'">'.wordwrap(urldecode($vals['url']), 100, " ").'</a>';
        }
        
//AP BUG2 FIXs 
//        if (preg_match($pattern_ext, $vals['url'])) {
//            
//            $title .= '<br><a href="send.php?did='.$id.'">'.$i18n['send']['email_document'].'</a>';
//        }

        /** print title top */
        if ($style_data['result_titletop'] == "1") {
            echo $title.'<br />'; //AP
        }
        /** description */
        if ($vals['description']) {
            echo '<span class="sp2_result">'.$vals['description'].'</span>';
        }

        /** bootom details */
        $details = array();
        if ($style_data['result_url'] == "1" || $style_data['result_size'] == "1" || $style_data['result_date'] == "1") {
            if ($style_data['result_url'] == "1")    $details[] = $vals['url_print'];
            if ($style_data['result_size'] == "1")   $details[] = formatsize($vals['size']);
            if ($style_data['result_date'] == "1")   $details[] = $vals['date'];
            
            echo '<br /><span class="sp2_address">'.join(' - ', $details).'</span>';
        }
        /** print title bootom */
        if ($style_data['result_titletop'] == "0") {
            echo  '<br />'.$title;
        }
        echo '</p>'."\n";
        $i++;
    }

    if ($rec['cnt_pages'] > 1) {
       if($config["usebooleanexpression"]){
        echo echo_on_page($rec, $_SERVER['PHP_SELF'].'?q='.urlencode($q_str).'&g='.$_SESSION['ssp_groupid'].'&num='.$result_on_page.'&p=');
       }else{
        echo echo_on_page($rec, $_SERVER['PHP_SELF'].'?q='.urlencode($query_str).'&g='.$_SESSION['ssp_groupid'].'&num='.$result_on_page.'&p=');
       }
    }
}

print "</div>\n";

/** print footer */
echo $footer_tpl;
/** session close */
session_write_close();

?>
