<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: install.php,v2.0 2017/09/30 advocat Exp $ */
error_reporting(E_ALL);

ob_start();
/** define path */
define('SSP_DIR', str_replace('\\','/',dirname(__FILE__)));

/** include fixer */
include_once(SSP_DIR.'/data/fixer.php');

/** session start */
session_start();

if (!isset($_GET['step'])) {
    $_GET['step'] = 1;
}

$installed  = false;
$error_msg  = false;

$sess = session_name().'='.session_id();
$timg = 'step';

/** check installed script */
if (!isset($_SESSION['step'])) {
    if (file_exists(SSP_DIR.'/data/config.php') && file_exists(SSP_DIR.'/data/config.php')) {
        $installed  = true;
        $timg       = 'congratulations';
        clearstatcache();
    }
}

/** include files */
include(SSP_DIR.'/data/i18n.php');
include(SSP_DIR.'/data/system.php');
include(SSP_DIR.'/data/functions.php');
include(SSP_DIR.'/data/encodings.php');

/** title */
if ($_GET['step'] == 1 && !$installed) {
    $title = $system['name'].' :: '.$i18n['install']['title'].' :: '.$i18n['install']['step1'];
} elseif ($_GET['step'] == 2 && !$installed) {
    $title = $system['name'].' :: '.$i18n['install']['title'].' :: '.$i18n['install']['step2'];
} elseif ($_GET['step'] == 3 && !$installed) {
    $title = $system['name'].' :: '.$i18n['install']['title'].' :: '.$i18n['install']['step3'];
} else {
    $title = $system['name'].' :: '.$i18n['install']['title'];
}

$vars_border_style = array("none","dotted","dashed","solid","double","grove","ringe","inset","outset");
$vars_font_family = array("Arial","Tahoma","Verdana","Times New Romans","Courier");
$vars_font_style = array("normal","italic");
$vars_font_weight = array("normal","bold");
$vars_text_decoration = array("none","underline","overline","line-through","blink");


?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head>
<title><?php echo $title; ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="./styles.css" rel="stylesheet" type="text/css">
</head><body>
<table width="778"  border="0" align="center" cellpadding="5" cellspacing="10">
<tr><td style="border:1px solid #C0C0C0; background-color:#FFFFFF;"><table width="100%"  border="0" cellspacing="0" cellpadding="0">
<tr style="background-image:url(img/bg-header.gif);">
<td width="209"><img src="img/i18n/_install.gif" alt="<?php echo $i18n['install']['title']; ?>" width="150" height="30"></td>
<td align="right"><img src="img/cdcover-top.gif" alt="" width="115" height="30"></td></tr>
<tr><td><img src="img/px.gif" alt="" width="209" height="5"></td>
<td align="right"><img src="img/cdcover-back.gif" alt="" width="120" height="5"></td></tr>
<tr style="background-color:#EDEDED;" valign="top">
<td><img src="img/logotype.gif" alt="" width="209" height="77"></td>
<td align="right"><img src="img/cdcover.gif" alt="" width="270" height="105"></td></tr></table></td></tr>
<tr><td style="border:1px solid #C0C0C0; background-color:#FFFFFF;">
<table width="100%"  border="0" cellspacing="0" cellpadding="0">
<tr><td bgcolor="#5D7999"><img src="img/px.gif" alt="" width="100%" height="5"></td></tr>
<tr><td bgcolor="#284465"><img src="img/head_li.gif" alt="" width="29" height="25"><img src="img/i18n/<?php echo $timg; ?>.gif" alt="" width="150" height="25"></td></tr>
<tr><td><!-- content --><?php
if (!$installed) {
    if ($_GET['step'] == 1) {
        $step_complite = false;
        if (isset($_POST['submit'])) {
            $connect_db = @mysqli_connect($_POST['db_host'], $_POST['db_login'], $_POST['db_passwd']);
            $select_db = @mysqli_select_db($connect_db, $_POST['db_name']);
            if (!$connect_db) $error_msg = $i18n['install']['error_db'];
            elseif (!$select_db) $error_msg = $i18n['install']['error_db_select'];

            if (!$error_msg) $step_complite = 1;
        } else {
            $_POST = array("db_host"=>"localhost","db_login"=>"","db_passwd"=>"","db_name"=>"");
        }
        if ($step_complite) {
            $_SESSION['step'] = 1;
            
            umask(0777);

            /** set chmod to folders */
            chmod(SSP_DIR.'/data', 0777);
            chmod(SSP_DIR.'/img',  0777);
            chmod(SSP_DIR.'/img/buttons',  0777);

            $fp = @fopen(SSP_DIR.'/data/db.php',"w+");
            $db_content = '<?php'."\n\$db['host']   = \"{$_POST['db_host']}\";\n\$db['login']  = \"{$_POST['db_login']}\";\n\$db['passwd'] = \"{$_POST['db_passwd']}\";\n\$db['name']   = \"{$_POST['db_name']}\";\n".'?>';
            if ($fp) {
                fwrite($fp, $db_content);
                fclose();
                chmod(SSP_DIR.'/data/db.php', 0777);
                clearstatcache();
            } else {
                $error_msg = $i18n['install']['error_write']." data/db.php";
            }
            if (!$error_msg) {
                header("Location: {$_SERVER['PHP_SELF']}?step=2&{$sess}");
                exit;
            }
    } ?><!-- step1 -->
<form action="<?php echo $_SERVER['PHP_SELF']; ?>?step=1&<?php echo $sess;?>" method="post" name="step1" id="step1">
<table width="100%"  border="0" cellspacing="5" cellpadding="0">
<tr><td width="10%">&nbsp;</td>
<td><table width="100%"  border="0" cellpadding="5" cellspacing="0">
<tr><td width="30%" class="bottomline"><?=$i18n['install']['db_host']?> : </td>
<td class="bottomline"><input class="field" name="db_host" type="text" id="db_host" value="<?= $_POST['db_host'] ?? '' ?>"></td></tr>
<tr><td class="bottomline"><?=$i18n['install']['db_login']?> : </td>
<td class="bottomline"><input class="field" name="db_login" type="text" id="db_login" value="<?= $_POST['db_login'] ?? '' ?>"></td></tr>
<tr><td class="bottomline"><?=$i18n['install']['db_passwd']?> : </td>
<td class="bottomline"><input class="field" name="db_passwd" type="text" id="db_passwd" value="<?= $_POST['db_passwd'] ?? '' ?>"></td></tr>
<tr><td><?=$i18n['install']['db_name']?> : </td>
<td><input class="field" name="db_name" type="text" id="db_name" value="<?= $_POST['db_name'] ?? '' ?>"></td></tr></table></td></tr>
<tr><td class="topline">&nbsp;</td>
<td>&nbsp;</td></tr><?php
    if ($error_msg) {
        ?><tr><td colspan="2" class="commentBox"><span class="required">*</span> <span class="comment"><?php echo $error_msg; ?></span></td></tr><?php
    }
    ?><tr align="center"><td colspan="2"><input name="submit" type="submit" class="button" id="submit" value=" :: <?php echo $i18n['install']['next']; ?> :: "></td></tr></table>
</form><!-- /step1 --><?php
    } if ($_GET['step'] == 2) {
        if (!isset($_SESSION["step"]) || !file_exists("./data/db.php")) {
            header("Location: {$_SERVER['PHP_SELF']}?step=1&{$sess}");
            exit;
        }

        $step_complite = false;

        if (isset($_POST['submit'])) {
            if (!$_POST['username']) $error_msg = $i18n['admins']['error_login'];
            if (!$_POST['password'] || $_POST['password'] != $_POST['retype_passwd']) $error_msg = $i18n['admins']['error_password'];
            if (!$_POST['email']) $error_msg = $i18n['admins']['error_email'];

            if (!$error_msg) {
                /** include db config */
                include (SSP_DIR.'/data/db.php');
                /** connect to db */
                @$db_connect = mysqli_connect($db['host'],$db['login'],$db['passwd']);
                @$db_select = mysqli_select_db($db_connect, $db['name']);
                
                /** admins */
                $tbl_create_admins = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_admins`");
                $tbl_create_admins = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_admins` (`id` int(11) NOT NULL auto_increment, `username` varchar(16) NOT NULL default '', `password` varchar(16) NOT NULL default '', `email` varchar(255) default NULL, `fullname` varchar(255) default NULL, `gender` enum('male','female') default NULL, `tel_home` varchar(255) default NULL, `tel_work` varchar(255) default NULL, `tel_mob` varchar(255) default NULL, `access` varchar(255) default NULL, PRIMARY KEY  (`id`)) ENGINE=MyISAM");
                
                /** groups */
                $tbl_create_groups = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_groups`");
                $tbl_create_groups = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_groups` (`id` int(11) NOT NULL auto_increment, `name` varchar(128) NOT NULL default '', `start_urls` text NOT NULL, `allow_urls` text NOT NULL, `style_id` int(11) NOT NULL default '0', `tpl_id` int(11) NOT NULL default '0', `enable` smallint(1) default '1', PRIMARY KEY  (`id`)) ENGINE=MyISAM");
                
                /** imgbtns */
                $tbl_create_imgbtns = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_imgbtns`");
                $tbl_create_imgbtns = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_imgbtns` (`id` int(11) NOT NULL auto_increment, `name` char(255) default '', `image` char(16) default '', `image_tag` char(32) default '', PRIMARY KEY (`id`)) ENGINE=MyISAM");
                
                /** logs */
                $tbl_create_logs = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_logs`");
                $tbl_create_logs = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_logs` (`id` int(11) NOT NULL auto_increment, `admin_id` int(11) NOT NULL default '0', `module` char(255) default NULL, `act` char(255) default NULL, `detail` char(255) default NULL, `date` datetime default NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM");
                
                /** rules */
                $tbl_create_rules = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_rules`");
                $tbl_create_rules = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_rules` (`id` int(11) NOT NULL auto_increment, `term` char(128) default '', `url` char(255) default '', `enable` smallint(1) default '1', PRIMARY KEY (`id`)) ENGINE=MyISAM");
                
                /** schedule */
                $tbl_create_schedule = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_schedule`");
                $tbl_create_schedule = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_schedule` (`id` int(11) NOT NULL auto_increment, `groups` char(255) default '0', `days` smallint(2) default '0', `hours` smallint(2) default '0', `minutes` smallint(2) default '0', `date` datetime default NULL, `enable` smallint(1) default '1', PRIMARY KEY (`id`)) ENGINE=MyISAM");
                                
                /** search db */
                $tbl_create_search_db = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_search_db`");
                $tbl_create_search_db = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_search_db` (`id` int(11) NOT NULL auto_increment, `url` varchar(255) default NULL, `groups` varchar(255) default '', `title` varchar(255) default NULL, `description` tinytext, `size` bigint(20) default NULL, `date` date default NULL, `text` longtext, `ignore` smallint(1) default '0', PRIMARY KEY (`id`), FULLTEXT KEY `text` (`text`), FULLTEXT KEY `description` (`description`)) ENGINE=MyISAM");
                
                /** search query */
                $tbl_create_search_query = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_search_query`");
                $tbl_create_search_query = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_search_query` (`id` int(11) NOT NULL auto_increment, `search_string` char(255) default NULL, `search_group` int(11) default '0', `results` int(11) default '0', `style_id` int(11) default NULL, `tpl_id` int(11) default NULL, `referer` char(255) default '', `ip_addr` char(128) default NULL, `datetime` datetime default NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM");
                                
                /** search tmp */
                $tbl_create_search_tmp = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_search_tmp`");
                $tbl_create_search_tmp = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_search_tmp` (`id` int(11) NOT NULL auto_increment, `url` varchar(255) default '', `groups` varchar(255) default '', `title` varchar(255) default '', `description` tinytext, `size` bigint(20), `date` date default NULL, `text` longtext, PRIMARY KEY (`id`)) ENGINE=MyISAM");
                
                /** styles */
                $tbl_create_styles = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_styles`");
                $tbl_create_styles = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_styles` (`id` int(11) NOT NULL auto_increment, `name` varchar(255) default '', `data` longtext, `default` smallint(1) default '0', PRIMARY KEY  (`id`)) ENGINE=MyISAM");
                
                /** templates */
                $tbl_create_templates = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_templates`");
                $tbl_create_templates = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_templates` (`id` int(11) NOT NULL auto_increment, `name` varchar(255) default '', `header` text, `footer` text, `default` smallint(1) default '0', PRIMARY KEY (`id`)) ENGINE=MyISAM");
                
                /** link */
                $tbl_create_links = mysqli_query($db_connect, "DROP TABLE IF EXISTS `{$system['prefix']}_links`");
                $tbl_create_links = mysqli_query($db_connect, "CREATE TABLE `{$system['prefix']}_links` (`id` int(10) unsigned NOT NULL auto_increment, `path` varchar(255) not null default '', `to_visit` tinyint(4) default '0', PRIMARY KEY (`path`), UNIQUE KEY `id` (`id`)) ENGINE=MyISAM");


                /** insert admin */
                $access = 'admins,settings,design,stats';
                $admin_prop = array("username"=>$_POST['username'],"password"=>$_POST['password'],"email"=>$_POST['email'],"fullname"=>$_POST['fullname'],"gender"=>$_POST['gender'],"tel_home"=>$_POST['tel_home'],"tel_work"=>$_POST['tel_work'],"tel_mob"=>$_POST['tel_mob'],"access"=>$access);
                $set = array2sql($admin_prop);
                $tbl_insert_admin = mysqli_query($db_connect, "INSERT INTO `{$system['prefix']}_admins` SET ".$set);
                
                /** insert default style */
                $tbl_insert_style = mysqli_query($db_connect, "INSERT INTO `{$system['prefix']}_styles` VALUES (1, 'Default style', 'a:126:{s:13:\"result_groups\";s:1:\"1\";s:12:\"result_title\";s:1:\"1\";s:15:\"result_titletop\";s:1:\"1\";s:18:\"result_description\";s:1:\"1\";s:16:\"result_show_meta\";s:1:\"0\";s:10:\"result_url\";s:1:\"1\";s:11:\"result_size\";s:1:\"1\";s:11:\"result_date\";s:1:\"1\";s:14:\"print_advanced\";s:1:\"1\";s:14:\"info_msg_align\";s:4:\"left\";s:11:\"q_chr_width\";s:2:\"20\";s:7:\"imgbtns\";s:1:\"0\";s:13:\"highlight_pdf\";s:4:\"icon\";s:13:\"highlight_xls\";s:4:\"icon\";s:13:\"highlight_doc\";s:4:\"icon\";s:13:\"highlight_txt\";s:4:\"icon\";s:17:\"show_search_group\";s:11:\"dropdownbox\";s:25:\"show_dropdown_result_menu\";s:7:\"disable\";s:20:\"search_in_result_box\";s:7:\"disable\";s:16:\"s_form_alignment\";s:6:\"center\";s:18:\"s_result_alignment\";s:4:\"left\";s:20:\"show_s_term_in_s_box\";s:0:\"\";s:14:\"show_page_date\";s:0:\"\";s:17:\"show_num_of_s_res\";s:0:\"\";s:31:\"search_result_header_background\";s:6:\"ecf5fa\";s:37:\"search_result_header_top_border_color\";s:6:\"c3ccd3\";s:16:\"show_suggestions\";s:1:\"1\";s:18:\"field_border_width\";s:1:\"1\";s:18:\"field_border_style\";s:5:\"solid\";s:18:\"field_border_color\";s:6:\"999999\";s:22:\"field_background_color\";s:6:\"ffffff\";s:17:\"field_font_family\";s:5:\"Arial\";s:16:\"field_font_style\";s:6:\"normal\";s:16:\"field_text_color\";s:6:\"000000\";s:15:\"field_font_size\";s:2:\"12\";s:17:\"field_font_weight\";s:6:\"normal\";s:25:\"input_select_border_width\";s:0:\"\";s:25:\"input_select_border_style\";s:5:\"solid\";s:25:\"input_select_border_color\";s:0:\"\";s:29:\"input_select_background_color\";s:6:\"ffffff\";s:24:\"input_select_font_family\";s:5:\"Arial\";s:23:\"input_select_font_style\";s:6:\"normal\";s:23:\"input_select_text_color\";s:6:\"000000\";s:22:\"input_select_font_size\";s:2:\"12\";s:24:\"input_select_font_weight\";s:6:\"normal\";s:19:\"button_border_width\";s:0:\"\";s:19:\"button_border_style\";s:4:\"none\";s:19:\"button_border_color\";s:0:\"\";s:23:\"button_background_color\";s:0:\"\";s:18:\"button_font_family\";s:5:\"Arial\";s:17:\"button_font_style\";s:6:\"normal\";s:17:\"button_text_color\";s:6:\"000000\";s:16:\"button_font_size\";s:2:\"12\";s:18:\"button_font_weight\";s:6:\"normal\";s:20:\"advanced_font_family\";s:5:\"Arial\";s:19:\"advanced_font_style\";s:6:\"normal\";s:24:\"advanced_text_decoration\";s:4:\"none\";s:19:\"advanced_text_color\";s:6:\"7777cc\";s:18:\"advanced_font_size\";s:2:\"11\";s:20:\"advanced_font_weight\";s:6:\"normal\";s:26:\"advanced_hover_font_family\";s:5:\"Arial\";s:25:\"advanced_hover_font_style\";s:6:\"normal\";s:30:\"advanced_hover_text_decoration\";s:9:\"underline\";s:25:\"advanced_hover_text_color\";s:6:\"7777cc\";s:24:\"advanced_hover_font_size\";s:2:\"11\";s:26:\"advanced_hover_font_weight\";s:6:\"normal\";s:20:\"info_msg_font_family\";s:5:\"Arial\";s:19:\"info_msg_font_style\";s:6:\"normal\";s:24:\"info_msg_text_decoration\";s:4:\"none\";s:19:\"info_msg_text_color\";s:6:\"000000\";s:18:\"info_msg_font_size\";s:2:\"13\";s:20:\"info_msg_font_weight\";s:4:\"bold\";s:17:\"title_font_family\";s:5:\"Arial\";s:16:\"title_font_style\";s:6:\"normal\";s:21:\"title_text_decoration\";s:4:\"none\";s:16:\"title_text_color\";s:6:\"7777cc\";s:15:\"title_font_size\";s:2:\"13\";s:17:\"title_font_weight\";s:4:\"bold\";s:23:\"title_hover_font_family\";s:5:\"Arial\";s:22:\"title_hover_font_style\";s:6:\"normal\";s:27:\"title_hover_text_decoration\";s:9:\"underline\";s:22:\"title_hover_text_color\";s:6:\"7777cc\";s:21:\"title_hover_font_size\";s:2:\"13\";s:23:\"title_hover_font_weight\";s:4:\"bold\";s:18:\"result_font_family\";s:5:\"Arial\";s:17:\"result_font_style\";s:6:\"normal\";s:22:\"result_text_decoration\";s:4:\"none\";s:17:\"result_text_color\";s:6:\"000000\";s:16:\"result_font_size\";s:2:\"12\";s:18:\"result_font_weight\";s:6:\"normal\";s:18:\"select_font_family\";s:5:\"Arial\";s:17:\"select_font_style\";s:6:\"normal\";s:22:\"select_text_decoration\";s:4:\"none\";s:17:\"select_text_color\";s:6:\"990000\";s:16:\"select_font_size\";s:2:\"12\";s:18:\"select_font_weight\";s:4:\"bold\";s:19:\"address_font_family\";s:5:\"Arial\";s:18:\"address_font_style\";s:6:\"normal\";s:23:\"address_text_decoration\";s:4:\"none\";s:18:\"address_text_color\";s:6:\"008000\";s:17:\"address_font_size\";s:2:\"12\";s:19:\"address_font_weight\";s:6:\"normal\";s:17:\"pages_font_family\";s:5:\"Arial\";s:16:\"pages_font_style\";s:6:\"normal\";s:21:\"pages_text_decoration\";s:4:\"none\";s:16:\"pages_text_color\";s:6:\"000000\";s:15:\"pages_font_size\";s:2:\"12\";s:17:\"pages_font_weight\";s:6:\"normal\";s:22:\"pages_link_font_family\";s:5:\"Arial\";s:21:\"pages_link_font_style\";s:6:\"normal\";s:26:\"pages_link_text_decoration\";s:9:\"underline\";s:21:\"pages_link_text_color\";s:6:\"000000\";s:20:\"pages_link_font_size\";s:2:\"12\";s:22:\"pages_link_font_weight\";s:6:\"normal\";s:28:\"pages_link_hover_font_family\";s:5:\"Arial\";s:27:\"pages_link_hover_font_style\";s:6:\"normal\";s:32:\"pages_link_hover_text_decoration\";s:9:\"underline\";s:27:\"pages_link_hover_text_color\";s:6:\"000000\";s:26:\"pages_link_hover_font_size\";s:2:\"12\";s:28:\"pages_link_hover_font_weight\";s:6:\"normal\";s:21:\"pages_now_font_family\";s:5:\"Arial\";s:20:\"pages_now_font_style\";s:6:\"normal\";s:25:\"pages_now_text_decoration\";s:4:\"none\";s:20:\"pages_now_text_color\";s:6:\"a90a08\";s:19:\"pages_now_font_size\";s:2:\"12\";s:21:\"pages_now_font_weight\";s:4:\"bold\";}', 1)");
                
                /** insert default template */
                $tbl_insert_template = mysqli_query($db_connect, "INSERT INTO `{$system['prefix']}_templates` VALUES (1, 'Default template', '<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html><head>\r\n<title>SiteSearchPro (tm)</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\r\n<style type=\"text/css\"><!--\r\nBODY {font-family:Tahoma,Verdana,Arial; font-size:11px; color:#000000; background-color:#FFFFFF;}\r\n--></style>\r\n</head><body>', '</body></html>', 1)");
                
                /** insert default group */
                $tbl_insert_group = mysqli_query($db_connect, "INSERT INTO `{$system['prefix']}_groups` VALUES (1, '{$_SERVER['HTTP_HOST']}', '".addslashes(serialize(array('http://'.$_SERVER['HTTP_HOST'].chr(47))))."', '".addslashes(serialize(array('http://'.$_SERVER['HTTP_HOST'].chr(47))))."', 1, 1, 1)");

                if ($tbl_create_admins) $status['admins'] = "<span class=true>true</span>";
                else $status['admins'] = "<span class=false>false</span>";

                if ($tbl_create_groups) $status['groups'] = "<span class=true>true</span>";
                else $status['groups'] = "<span class=false>false</span>";
                
                $status['imgbtns'] = $tbl_create_imgbtns ? "<span class=true>true</span>" : "<span class=false>false</span>";

                if ($tbl_create_logs) $status['logs'] = "<span class=true>true</span>";
                else $status['logs'] = "<span class=false>false</span>";
                
                if ($tbl_create_rules) $status['rules'] = "<span class=true>true</span>";
                else $status['rules'] = "<span class=false>false</span>";

                if ($tbl_create_schedule) $status['schedule'] = "<span class=true>true</span>";
                else $status['schedule'] = "<span class=false>false</span>";

                if ($tbl_create_search_db) $status['search_db'] = "<span class=true>true</span>";
                else $status['search_db'] = "<span class=false>false</span>";

                if ($tbl_create_search_query) $status['search_query'] = "<span class=true>true</span>";
                else $status['search_query'] = "<span class=false>false</span>";

                if ($tbl_create_search_tmp) $status['search_tmp'] = "<span class=true>true</span>";
                else $status['search_tmp'] = "<span class=false>false</span>";

                if ($tbl_create_styles) $status['styles'] = "<span class=true>true</span>";
                else $status['styles'] = "<span class=false>false</span>";

                if ($tbl_create_templates) $status['templates'] = "<span class=true>true</span>";
                else $status['templates'] = "<span class=false>false</span>";

                if ($tbl_create_links) $status['links'] = "<span class=true>true</span>";
                else $status['links'] = "<span class=false>false</span>";


                if ($tbl_insert_admin) $status['insert_admin'] = "<span class=true>true</span>";
                else $status['insert_admin'] = "<span class=false>false</span>";
                
                if ($tbl_insert_style) $status['insert_style'] = "<span class=true>true</span>";
                else $status['insert_style'] = "<span class=false>false</span>";
                
                if ($tbl_insert_template) $status['insert_template'] = "<span class=true>true</span>";
                else $status['insert_template'] = "<span class=false>false</span>"; 
                
                if ($tbl_insert_group) $status['insert_group'] = "<span class=true>true</span>";
                else $status['insert_group'] = "<span class=false>false</span>"; 

                $_SESSION['step'] = 2;
                $step_complite = true;
            } else {
                $prop = array("username"=>$_POST['username'],"password"=>$_POST['password'],"email"=>$_POST['email'],"fullname"=>$_POST['fullname'],"gender"=>$_POST['gender'],"tel_home"=>$_POST['tel_home'],"tel_work"=>$_POST['tel_work'],"tel_mob"=>$_POST['tel_mob'],"access"=>$access);
            }
        } else {
            $prop = array("username"=>"","password"=>"","email"=>"","fullname"=>"","gender"=>"","tel_home"=>"","tel_work"=>"","tel_mob"=>"");
        }
        if (!$step_complite) {
      ?><form action="<?php echo $_SERVER['PHP_SELF']; ?>?step=2&<?php echo $sess;?>" method="post" name="frm_prop" id="frm_prop" onSubmit="return check_form('frm_prop');">
<script language="javascript" type="text/javascript"><!--
function check_form (form_name) {
    form = document.forms[form_name];
    tmp = form.elements['username'];
    if (tmp.value.length == 0 || tmp.value.search (/^\s*$/) != -1) {
        alert ('<?php echo $i18n['admins']['error_login']; ?>');
        tmp.focus();
        return false;
    }
    tmp = form.elements['password'];
    if (tmp.value.length == 0 || tmp.value.search (/^\s*$/) != -1) {
        alert ('<?php echo $i18n['admins']['error_password']; ?>');
        tmp.focus ();
        return false;
    }
    tmp1 = form.elements['retype_passwd'];
    if (tmp1.value.length == 0) {
        alert ('<?php echo $i18n['admins']['error_password']; ?>');
        tmp1.focus ();
        return false;
    }
    if ( tmp1.value != tmp.value ) {
        alert ('<?php echo $i18n['admins']['error_password']; ?>');
        tmp.focus ();
        return false;
    }
    tmp = form.elements['email'];
    if ( (tmp.value.length == 0) || (tmp.value.search(/^[0-9a-z]([-_.]?[0-9a-z])*@[0-9a-z]([-.]?[0-9a-z])*\.[a-z]{2,4}$/) == -1 )){
        alert ('<?php echo $i18n['admins']['error_email']; ?>');
        tmp.focus ();
        return false;
    }
    tmp = form.elements['fullname'];
    if (tmp.value.length == 0) {
        alert ('<?php echo $i18n['admins']['error_fullname']; ?>');
        tmp.focus();
        return false;
    }
    return true;
} //--></script>
<table width="100%" border="0" cellspacing="5" cellpadding="0">
<tr><td width="10%">&nbsp;</td>
<td><table width="100%"  border="0" align="center" cellpadding="4" cellspacing="0" bgcolor="#FFFFFF">
<tr><td width="40%" class="bottomline"><?php echo $i18n['admins']['login']; ?><span class="required">*</span> :</td>
<td class="bottomline"><input class="field" name="username" type="text" id="username" style="width:60%;" value="<?php echo $prop['username']; ?>" maxlength="16"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['admins']['password']; ?><span class="required">*</span> :</td>
<td class="bottomline"><input class="field" name="password" type="password" id="password" style="width:60%;" value="<?php echo $prop['password']; ?>" maxlength="16"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['admins']['retype']; ?><span class="required">*</span> :</td>
<td class="bottomline"><input class="field" name="retype_passwd" type="password" id="retype_passwd" style="width:60%;" value="<?php echo $prop['password']; ?>" maxlength="16"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['admins']['email']; ?><span class="required">*</span> :</td>
<td class="bottomline"><input class="field" name="email" type="text" id="email" style="width:100%;" value="<?php echo $prop['email']; ?>" maxlength="255"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['admins']['fullname']; ?><span class="required">*</span> :</td>
<td class="bottomline"><input class="field" name="fullname" type="text" id="fullname" style="width:100%;" value="<?php echo $prop['fullname']; ?>"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['admins']['gender']; ?><span class="required">*</span> :</td>
<td class="bottomline"><input name="gender" type="radio" value="male" id="gender_male"<?php if($prop['gender']!="female") echo " checked";?>>
<label for="gender_male"><?php echo $i18n['admins']['gender_male']; ?></label>
<input name="gender" type="radio" value="female" id="gender_female"<?php if($prop['gender']=="female") echo " checked";?>>
<label for="gender_female"><?php echo $i18n['admins']['gender_female']; ?></label></td></tr>
<tr><td class="bottomline"><?php echo $i18n['admins']['tel_home']; ?> : </td>
<td class="bottomline"><input class="field" name="tel_home" type="text" id="tel_home" style="width:60%;" value="<?php echo $prop['tel_home']; ?>" maxlength="255"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['admins']['tel_work']; ?> : </td>
<td class="bottomline"><input class="field" name="tel_work" type="text" id="tel_work" style="width:60%;" value="<?php echo $prop['tel_work']; ?>" maxlength="255"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['admins']['tel_mob']; ?> : </td>
<td class="bottomline"><input class="field" name="tel_mob" type="text" id="tel_mob" style="width:60%;" value="<?php echo $prop['tel_mob']; ?>" maxlength="255"></td></tr></table></td></tr>
<tr><td class="topline">&nbsp;</td>
<td>&nbsp;</td></tr>
<tr><td colspan="2" class="commentBox"><span class="required">*</span> <span class="comment"><?php echo $i18n['admins']['comment']; ?></span></td></tr>
<tr align="center"><td colspan="2"><input name="submit" type="submit" class="button" id="submit" value=" :: <?php echo $i18n['install']['next']; ?> :: "></td></tr></table>
</form><?php
        } else {
            ?><table width="100%"  border="0" cellspacing="5" cellpadding="0">
<tr><td><p><?php
            echo $i18n['install']['create_tbl_admins'].' ... '.$status['admins'].'<br>';
            echo $i18n['install']['create_tbl_groups'].' ... '.$status['groups'].'<br>';
            echo $i18n['install']['create_tbl_logs'].' ... '.$status['logs'].'<br>';
            echo $i18n['install']['create_tbl_rules'].' ... '.$status['rules'].'<br>';
            echo $i18n['install']['create_tbl_schedule'].' ... '.$status['schedule'].'<br>';
            echo $i18n['install']['create_tbl_styles'].' ... '.$status['styles'].'<br>';
            echo $i18n['install']['create_tbl_imgbtns'].' ... '.$status['imgbtns'].'<br>';
            echo $i18n['install']['create_tbl_templates'].' ... '.$status['templates'].'<br>';
            echo $i18n['install']['create_tbl_search_db'].' ... '.$status['search_db'].'<br>';
            echo $i18n['install']['create_tbl_search_query'].' ... '.$status['search_query'].'<br>';
            echo $i18n['install']['create_tbl_search_tmp'].' ... '.$status['search_tmp'].'<br>';
            echo $i18n['install']['create_tbl_links'].' ... '.$status['links'].'<br>';

            echo $i18n['install']['insert_tbl_admin'].' ['.$admin_prop['username'].'] ... '.$status['insert_admin'].'<br>';
            echo $i18n['install']['insert_tbl_style'].' ... '.$status['insert_style'].'<br>';
            echo $i18n['install']['insert_tbl_template'].' ... '.$status['insert_template'].'<br>';
            echo $i18n['install']['insert_tbl_group'].' ... '.$status['insert_group'].'<br>';
            ?></p>
<p><a class="strong" href="<?php echo $_SERVER['PHP_SELF']; ?>?step=3&<?php echo $sess;?>"><?php echo $i18n['install']['next']; ?></a></p></td></tr></table><?php
        }
    } elseif ($_GET['step'] == 3) {
        if (isset($_POST['submit'])) {
            if (!isset($_POST['enable_pdf'])) $_POST['enable_pdf'] = '0';
            else $_POST['enable_pdf'] = 1;

            if (!preg_match("/pdftotext$/s", $_POST['path2xpdf']) && $_POST['enable_pdf_int'] == 0) $_POST['enable_pdf'] = '0';

            if (!isset($_POST['enable_rtf'])) $_POST['enable_rtf'] = '0';
            else $_POST['enable_rtf'] = 1;
            if (!isset($_POST['enable_doc'])) $_POST['enable_doc'] = '0';
            else $_POST['enable_doc'] = 1;

            if (!preg_match("/antiword$/s", $_POST['path2antiword']) && $_POST['enable_doc_int'] == 0) $_POST['enable_doc'] = '0';

            if (!isset($_POST['enable_xls'])) $_POST['enable_xls'] = '0';
            else $_POST['enable_xls'] = 1;
            if (!isset($_POST['enable_swf'])) $_POST['enable_swf'] = '0';
            else $_POST['enable_swf'] = 1;

            /** TODO */
            $_POST['enable_swf'] = '0';

            $config_new = array(
            'site_addr'         => $_POST['site_addr'],
            'folder'            => $_POST['folder'],
            'result_on_page'    => slashes($_POST['result_on_page'], 1),
            'concordances'      => slashes($_POST['concordances'], 1),
            'ignorespecialsymbols'  =>slashes($_POST['ignorespecialsymbols'], 1),
            'usebooleanexpression'  =>slashes($_POST['usebooleanexpression'], 1),
            'enable_pdf_int'        => slashes($_POST['enable_pdf_int'], 1),
            'enable_doc_int'        => slashes($_POST['enable_doc_int'], 1),
            'min_chr_word'      => slashes($_POST['min_chr_word'], 1),
            'sortby'            => slashes($_POST['sortby'], 1),
            'boolean_only'      => slashes($_POST['boolean_only'], 1),
            'allow_ext'         => slashes($_POST['allow_ext'], 1),
            'stop_files'        => addslashes(serialize(config_vars2array($_POST['stop_files']))),
            'stop_dirs'         => addslashes(serialize(config_vars2array($_POST['stop_dirs']))),
            'encoding'          => slashes($_POST['encoding'], 1),

            'enable_pdf'        => slashes($_POST['enable_pdf'], 1),
            'enable_rtf'        => slashes($_POST['enable_rtf'], 1),
            'enable_doc'        => slashes($_POST['enable_doc'], 1),
            'enable_xls'        => slashes($_POST['enable_xls'], 1),
            'enable_swf'        => slashes($_POST['enable_swf'], 1),

            'path2xpdf'         => slashes($_POST['path2xpdf'], 1),
            'path2antiword'     => slashes($_POST['path2antiword'], 1),

            'label_button'      => slashes($_POST['label_button'], 1),
            'label_all_groups'  => slashes($_POST['label_all_groups'], 1),
            'label_advanced'    => slashes($_POST['label_advanced'], 1),
            'label_search_res'  => slashes($_POST['label_search_res'], 1),
            'label_error_found' => slashes($_POST['label_error_found'], 1),
            'label_error_min'   => slashes($_POST['label_error_min'], 1),
            'label_boolean'     => slashes($_POST['label_boolean'], 1)
            );

            umask(0777);
            
            $config_write = '<?'.'php'."\n".'$config = array();'."\n";
            reset($config_new);
            foreach ($config_new as $key => $var) {
                $config_write .= "\$config['{$key}'] = \"".trim(addslashes($var))."\";\n";
            }
            $config_write .= '?'.'>';
            if (file_exists(SSP_DIR.'/data/config.php')) @unlink(SSP_DIR.'/data/config.php');
            $fp = @fopen(SSP_DIR.'/data/config.php',"w+");
            if ($fp) {
                fwrite($fp, $config_write);
                fclose($fp);
                chmod(SSP_DIR.'/data/config.php',0777);
                clearstatcache();
            } else {
                $config = $config_new;
                $error_msg = $i18n['install']['error_write']." data/config.php";
            }

            if (!$error_msg) {
                header("Location: {$_SERVER['PHP_SELF']}?step=4&{$sess}");
                exit;
            }
        } else {
            $folder = substr($_SERVER['PHP_SELF'],1,(strlen($_SERVER['PHP_SELF']) - 13));
            $config = array(
            'site_addr'         => 'http://'.$_SERVER['HTTP_HOST'],
            'folder'            => $folder,

            'result_on_page'    => 10,
            'concordances'      => 5,
            'ignorespecialsymbols'  => 1,
            'usebooleanexpression'  => 1,
            'enable_pdf_int'        => 1,
            'enable_doc_int'        => 1,
            'min_chr_word'      => 3,
            'sortby'            => "relevance",
            'boolean_only'      => 1,
            'allow_ext'         => "html,htm,shtml,phtml,php,asp,cgi,pl,txt",
            'stop_files'        => addslashes(serialize(array('robots.txt'))),
            'stop_dirs'         => addslashes(serialize(array($folder,'css','image','images','img','js'))),
            'encoding'          => "UTF-8",
            'enable_pdf'        => 0,
            'enable_rtf'        => 1,
            'enable_doc'        => 0,
            'enable_xls'        => 1,
            'enable_swf'        => 0,
            'path2xpdf'         => "",
            'path2antiword'     => "",
            'label_button'      =>"Search",
            'label_all_groups'  =>"All groups",
            'label_advanced'    =>"Advanced search",
            'label_search_res'  =>"[cnt_result] results found for [query_string]",
            'label_error_found' =>"No pages were found containing [query_string]",
            'label_error_min'   =>"Your search term is less than [min_symbols] symbols",
            'label_boolean'     =>"No pages were found containing [query_string]"
            );
        }
        ?><form action="<?php echo $_SERVER['PHP_SELF']; ?>?step=3&<?php echo $sess;?>" method="post" name="frm_set" id="frm_set">
<table width="100%"  border="0" cellspacing="5" cellpadding="0">
<tr><td width="10%">&nbsp;</td>
<td><table width="100%" border="0" cellpadding="4" cellspacing="0">
<tr><td class="thead" height="30" colspan="2"><?php echo $i18n['settings']['title']; ?> :</td></tr>
<tr><td width="30%" class="bottomline"><?php echo $i18n['settings']['site_addr']; ?> : </td>
<td class="bottomline"><input name="site_addr" type="text" class="field" id="site_addr" value="<?php echo $config['site_addr']; ?>" size="40" maxlength="255"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['folder']; ?> : </td>
<td class="bottomline"><input name="folder" type="text" class="field" id="folder" value="<?php echo $config['folder']; ?>" size="40" maxlength="60"></td></tr>

<tr><td width="40%" class="bottomline"><?php echo $i18n['settings']['result_on_page']; ?> : </td>
<td class="bottomline"><input class="field" name="result_on_page" type="text" id="result_on_page" value="<?php echo $config['result_on_page']; ?>" size="10" maxlength="2"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['concordances']; ?> : </td>
<td class="bottomline"><input class="field" name="concordances" type="text" id="concordances" value="<?php echo $config['concordances']; ?>" size="10" maxlength="2"></td></tr>

<!-- begin AP feature configuration-->
<tr><td class="bottomline"><?php echo $i18n['settings']['ignorespecialsymbols']; ?> : </td>
<td class="bottomline">
<input name="ignorespecialsymbols" type="radio" id="ignorespecialsymbols" value="1"<?php if($config['ignorespecialsymbols']) print ' checked';?>><label for="boolean_only_1"><?php echo $i18n['settings']['boolean_only_1'];?></label>
<input name="ignorespecialsymbols" type="radio" id="ignorespecialsymbols" value="0"<?php if(!$config['ignorespecialsymbols']) print ' checked';?>><label for="boolean_only_0"><?php echo $i18n['settings']['boolean_only_0'];?></label>
</td></tr>

<tr><td class="bottomline"><?php echo $i18n['settings']['usebooleanexpression']; ?> : </td>
<td class="bottomline">
<input name="usebooleanexpression" type="radio" id="usebooleanexpression" value="1"<?php if($config['usebooleanexpression']) print ' checked';?>><label for="boolean_only_1"><?php echo $i18n['settings']['boolean_only_1'];?></label>
<input name="usebooleanexpression" type="radio" id="usebooleanexpression" value="0"<?php if(!$config['usebooleanexpression']) print ' checked';?>><label for="boolean_only_0"><?php echo $i18n['settings']['boolean_only_0'];?></label>
</td></tr>
<!-- end AP feature configuration-->

<tr><td class="bottomline"><?php echo $i18n['settings']['min_chr_word']; ?> : </td>
<td class="bottomline"><input class="field" name="min_chr_word" type="text" id="min_chr_word" value="<?php echo $config['min_chr_word']; ?>" size="10" maxlength="2"> <?php echo $i18n['settings']['symbols']; ?></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['boolean_only']; ?> :<br><i><?php echo $i18n['settings']['boolean_only_desc']; ?></i></td>
<td class="bottomline"><input name="boolean_only" id="boolean_only_1" type="radio" value="1"<?php if($config['boolean_only']) print ' checked';?>> <label for="boolean_only_1"><?php echo $i18n['settings']['boolean_only_1'];?></label>
<input name="boolean_only" id="boolean_only_1" type="radio" value="0"<?php if(!$config['boolean_only']) print ' checked';?>> <label for="boolean_only_0"><?php echo $i18n['settings']['boolean_only_0'];?></label></td></tr>
<tr><tr><td class="bottomline"><?php echo $i18n['settings']['sortby']; ?> :</td>
<td class="bottomline"><select class="field" name="sortby" id="sortby"><?php
    foreach ($i18n['settings']['sortby_vars'] as $value => $item) {
        echo "<option value=\"{$value}\"";
        if ($config['sortby'] == $value) echo " selected";
        echo ">{$item}</option>";
    }
    ?></select></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['allow_ext'].'<br /><em>'.$i18n['settings']['allow_ext_desc'].'</em>'; ?> : </td>
<td class="bottomline"><input class="field" name="allow_ext" type="text" id="allow_ext" value="<?php echo $config['allow_ext']; ?>" size="40" maxlength="60"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['enable_ext']; ?> : </td>

<td class="bottomline">
<input name="enable_pdf" type="checkbox" id="enable_pdf" value="1" <?php if ($config['enable_pdf']) echo 'checked'; ?>> &nbsp; <label for="enable_pdf"><?php echo $i18n['settings']['enable_pdf']; ?></label><br>
&nbsp;&nbsp;&nbsp;&nbsp;<input name="enable_pdf_int" type="radio" id="enable_pdf_int" value="1" <?php if ($config['enable_pdf_int']) echo 'checked'; ?>>&nbsp; <label for="enable_pdf_int"><?php echo $i18n['settings']['enable_pdf_int']; ?></label><br>
&nbsp;&nbsp;&nbsp;&nbsp;<input name="enable_pdf_int" type="radio" id="enable_pdf_int" value="0" <?php if (!$config['enable_pdf_int']) echo 'checked'; ?>>&nbsp; <label for="enable_pdf_ext"><?php echo $i18n['settings']['enable_pdf_ext']; ?></label><br>

<input name="enable_rtf" type="checkbox" id="enable_rtf" value="1" <?php if ($config['enable_rtf']) echo 'checked'; ?>> &nbsp; <label for="enable_rtf"><?php echo $i18n['settings']['enable_rtf']; ?></label><br>
<input name="enable_doc" type="checkbox" id="enable_doc" value="1" <?php if ($config['enable_doc']) echo 'checked'; ?>> &nbsp; <label for="enable_doc"><?php echo $i18n['settings']['enable_doc']; ?></label><br>
&nbsp;&nbsp;&nbsp;&nbsp;<input name="enable_doc_int" type="radio" id="enable_doc_int" value="1" <?php if ($config['enable_doc_int']) echo 'checked'; ?>>&nbsp; <label for="enable_doc_int"><?php echo $i18n['settings']['enable_doc_int']; ?></label><br>
&nbsp;&nbsp;&nbsp;&nbsp;<input name="enable_doc_int" type="radio" id="enable_doc_int" value="0" <?php if (!$config['enable_doc_int']) echo 'checked'; ?>>&nbsp; <label for="enable_doc_ext"><?php echo $i18n['settings']['enable_doc_ext']; ?></label><br>

<input name="enable_xls" type="checkbox" id="enable_xls" value="1" <?php if ($config['enable_xls']) echo 'checked'; ?>> &nbsp; <label for="enable_xls"><?php echo $i18n['settings']['enable_xls']; ?></label><br>
<input name="enable_swf" type="checkbox" id="enable_swf" value="1" <?php if ($config['enable_swf']) echo 'checked'; ?>> &nbsp; <label for="enable_swf"><?php echo $i18n['settings']['enable_swf']; ?></label></td></tr>

<tr><td class="bottomline"><?php echo $i18n['settings']['path2xpdf'].'<br /><em>'.$i18n['settings']['path2xpdf_desc'].'</em>'; ?></td>
<td class="bottomline"><input name="path2xpdf" type="text" class="field" id="path2xpdf" style="width:100%;" value="<?php echo slashes($config['path2xpdf'], 0); ?>"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['path2antiword'].'<br /><em>'.$i18n['settings']['path2antiword_desc'].'</em>'; ?></td>
<td class="bottomline"><input name="path2antiword" type="text" class="field" id="path2antiword" style="width:100%;" value="<?php echo slashes($config['path2antiword'],0); ?>"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['stop_dirs'].'<br /><em>'.$i18n['settings']['stop_dirs_desc'].'</em>'; ?></td>
<td class="bottomline"><textarea name="stop_dirs" rows="5" class="ta" id="stop_dirs" style="width:100%;"><?php echo config_array2vars(unserialize(stripslashes($config['stop_dirs']))); ?></textarea></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['stop_files'].'<br /><em>'.$i18n['settings']['stop_files_desc'].'</em>'; ?></td>
<td class="bottomline"><textarea name="stop_files" rows="5" class="ta" id="stop_files" style="width:100%;"><?php echo config_array2vars(unserialize(stripslashes($config['stop_files']))); ?></textarea></td></tr>
<tr><tr><td class="bottomline"><?php echo $i18n['settings']['encoding']; ?> :</td>
<td class="bottomline"><select class="field" name="encoding" id="encoding"><?php
    foreach ($encodings as $value => $item) {
        echo "<option value=\"{$value}\"";
        if ($config['encoding'] == $value) echo " selected";
        echo ">{$item}</option>";
    }
    ?></select></td></tr>
<td height="30" colspan="2" class="thead"><?php echo $i18n['settings']['label']; ?> :</td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['label_button']; ?> : </td>
<td class="bottomline"><input class="field" name="label_button" type="text" id="label_button" value="<?php echo $config['label_button']; ?>" size="40" maxlength="60"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['label_all_groups']; ?> : </td>
<td class="bottomline"><input class="field" name="label_all_groups" type="text" id="label_all_groups" value="<?php echo $config['label_all_groups']; ?>" size="40" maxlength="60"></td></tr>
<tr><td class="bottomline"><?php echo $i18n['settings']['label_advanced']; ?> : </td>
<td class="bottomline"><input class="field" name="label_advanced" type="text" id="label_advanced" value="<?php echo $config['label_advanced']; ?>" size="40" maxlength="60"></td></tr>
<!--
<tr><td class="bottomline"><?php echo $i18n['settings']['label_search_res'].'<br /><em>'.$i18n['settings']['label_search_res_desc'].'</em>'; ?> :</td>
<td class="bottomline"><input class="field" name="label_search_res" type="text" id="label_search_res" value="<?php echo htmlspecialchars(stripslashes($config['label_search_res'])); ?>" size="40" maxlength="60"></td></tr>
//-->
<tr><td class="bottomline"><?php echo $i18n['settings']['label_error_found'].'<br /><em>'.$i18n['settings']['label_error_found_desc'].'</em>'; ?> :</td>
<td class="bottomline"><input class="field" name="label_error_found" type="text" id="label_error_found" value="<?php echo htmlspecialchars(stripslashes($config['label_error_found'])); ?>" size="40" maxlength="60"></td></tr>
<tr><td><?php echo $i18n['settings']['label_error_min'].'<br /><em>'.$i18n['settings']['label_error_min_desc'].'</em>'; ?> :</td>
<td><input class="field" name="label_error_min" type="text" id="label_error_min" value="<?php echo htmlspecialchars(stripslashes($config['label_error_min'])); ?>" size="40" maxlength="60"></td></tr>
<tr><td><?php echo $i18n['settings']['label_boolean'].'<br /><em>'.$i18n['settings']['label_boolean_desc'].'</em>'; ?> :</td>
<td><input class="field" name="label_boolean" type="text" id="label_boolean" value="<?php echo htmlspecialchars(stripslashes($config['label_boolean'])); ?>" size="40" maxlength="60"></td></tr>
</table></td></tr>
<tr><td class="topline">&nbsp;</td>
<td>&nbsp;</td></tr>
<tr><td colspan="2" class="commentBox"><span class="required">*</span> <span class="comment"><?php echo $i18n['settings']['comment'];?></span><?php
/** iconv */
if (!extension_loaded("iconv")) {
    print '<br /><span class="required">*</span> <span class="comment">'.$i18n['settings']['comment_iconv'].'</span>';
} if (!preg_match("/pdftotext$/s", $config['path2xpdf'])) {
    print '<br /><span class="required">*</span> <span class="comment">'.$i18n['settings']['comment_xpdf'].'</span>';
} if (!preg_match("/antiword$/s", $config['path2antiword'])) {
    print '<br /><span class="required">*</span> <span class="comment">'.$i18n['settings']['comment_antiword'].'</span>';
}
?></td></tr>
<tr align="center"><td colspan="2"><input name="submit" type="submit" class="button" id="submit" value=" :: <?php echo $i18n['button']['save']; ?> :: "></td></tr></table></form><?php
    } elseif ($_GET['step'] == "4") {
        unset($_SESSION['step']);
        $_SESSION = array();
        header("Location: {$_SERVER['PHP_SELF']}?step=5&{$sess}");
        exit;
    }
} else {
    ?><table width="100%"  border="0" cellspacing="5" cellpadding="0">
<tr><td width="10%" class="topline">&nbsp;</td>
<td>&nbsp;</td></tr>
<tr><td colspan="2" class="commentBox"><span class="required">*</span> <span class="comment"><?php echo $i18n['install']['complite']; ?></span><?php
    if ($_GET['step'] == 5) echo "<p align=center><a href=\"./admin/\" class=strong>{$i18n['admin']['zone']}</a>";
    ?></td></tr></table><?php
}
?><!-- /content --></td></tr></table></td></tr></table>
<p align="center">Copyright &copy; 2022 Site Search Pro 2.1 &#8482;</p>
</body></html><?php ob_end_flush(); ?>
