<?php
/**
 * @link http://www.site-search-pro.com
 * @copyright Site Search Pro (tm)

 * @package SearchPro
 * @version 2.0 Gold
**/
/** $Id: schedule.php,v2.0 2017/09/30 advocat Exp $ */

/** include files */
define('SSP_DIR', str_replace('\\','/',dirname(__FILE__)));
define('SSP_SCHEDULE', 1);

if (!file_exists(SSP_DIR.'/data/config.php') || !file_exists(SSP_DIR.'/data/db.php')) {
    header("Location: ./install.php");
    exit;
}

include(SSP_DIR.'/data/config.php');
include(SSP_DIR.'/data/db.php');
include(SSP_DIR.'/data/system.php');
include(SSP_DIR.'/data/functions.php');
include(SSP_DIR.'/data/i18n.php');

/** connect to bd */
$db_connect	= mysqli_connect($db['host'],$db['login'],$db['passwd']);
$db_select	= mysqli_select_db($db_connect, $db['name']);

$exit           = false;

$groups_spider  = array();
$schedule       = array();

if (file_exists(SSP_DIR.'/data/pid.php')) {
	include_once(SSP_DIR.'/data/pid.php');
    $utime = time();
    if (($time + 60*5) < $utime) {
        @unlink(SSP_DIR.'/data/pid.php');
        clearstatcache();
    } else {
    	$exit = true;
    }
}

if (!$exit) {
    $res = mysqli_query($db_connect, "SELECT * FROM `{$system['prefix']}_schedule` WHERE `enable`=1");
    while ($row = mysqli_fetch_assoc($res)) {
        $utime = ($row['days'] * 60 * 60 * 24) + ($row['hours'] * 60 * 60) + ($row['minutes'] * 60);
        if ($utime > 0) {
            if (!$row['date'] || time() > ($utime + strtotime($row['date']))) {
                $groups_spider = array_merge(split(',', $row['groups']), $groups_spider);
                $schedule[$row['id']] = $row['id'];
            }
        }
    }
    if (sizeof($schedule) > 0) {
        if (in_array('0', $groups_spider)) {
            $groups_spider = 0;
        } else {
            $groups_spider = join(',', $groups_spider);
        }
                
        include(SSP_DIR.'/spider.php');
        
        foreach ($schedule as $id) {
        	mysqli_query($db_connect, "UPDATE `{$system['prefix']}_schedule` SET `date`=NOW() WHERE `id`='{$id}'");
        }
    } else {
        exit;
    }
} else {
    exit;
}

?>