<?php 
/** 
 * @link http://www.site-search-pro.com 
 * @copyright Site Search Pro (tm) 

 * @package SearchPro 
 * @version 2.0 
**/ 
/** $Id: spider.php,v2.1 2017/11/14 advocat Exp $ */

/** define path */ 
if (!defined('SSP_DIR')) { 
    define('SSP_DIR', str_replace('\\','/', dirname(__FILE__))); 
} 

/** session */ 
session_start(); 
session_write_close(); 

/** send header information */ 
header ("Expires: Mon, 26 Jul 1999 05:00:00 GMT"); 
header ("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT"); 
header ("Cache-Control: no-cache, must-revalidate"); 
header ("Pragma: no-cache"); 

@set_time_limit(0); 
@ignore_user_abort(true); 
ob_implicit_flush(); 

/** start */ 
$mtime  = microtime(); 
$mtime  = explode(" ", $mtime); 
$tstart = $mtime[1] + $mtime[0]; 

/** check another started spider */ 
$process = false; 
if (file_exists(SSP_DIR.'/data/pid.php')) { 
    if (is_readable(SSP_DIR.'/data/pid.php')) { 
        @include(SSP_DIR.'/data/pid.php'); 
        if (!isset($pid)) { 
            @unlink(SSP_DIR.'/data/pid.php'); 
            $process = false; 
        } else { 
            if (time() > $pid + 60*5) { 
                @unlink(SSP_DIR.'/data/pid.php'); 
                $process = false; 
            } else { 
                $process = true; 
            } 
        } 
    } else { 
        $process = true; 
    } 
    clearstatcache(); 
} 

/** if don't another start spider */ 
if (!$process) { 
    umask(0777); 
    $fp = @fopen(SSP_DIR.'/data/pid.php', "w+"); 
    if ($fp) { 
        fwrite($fp, '<'.'?php $pid = '.time().'; ?'.'>'); 
        fclose($fp); 
        chmod(SSP_DIR.'/data/pid.php', 0777); 
    } 
    clearstatcache(); 
} 

/** define vars */

include_once SSP_DIR . '/data/UrlLoader.php';
$debug          = isset($_GET['debug']) ? true : false; 
$total_size     = 0; 
$total_files    = 0; 

if ($debug) { 
    error_reporting(E_ALL); 
    ini_set("display_errors", 1); 
} 

/** check start from scheduled */ 
if (!defined('SSP_SCHEDULE')) { 
    /** include files */ 
    include_once (SSP_DIR.'/data/db.php'); 
    include_once (SSP_DIR.'/data/config.php'); 
    include_once (SSP_DIR.'/data/system.php'); 
    include_once (SSP_DIR.'/data/functions.php'); 
    include_once (SSP_DIR.'/data/i18n.php'); 
    include_once (SSP_DIR.'/data/convert.php'); 
     
    /** connect to DB */ 
    $db_connect = ($GLOBALS["___mysqli_ston"] = mysqli_connect($db['host'], $db['login'], $db['passwd'])); 
    $db_select  = ((bool)mysqli_query($db_connect, "USE " . $db['name'])); 
} 

// Get Max Memory Limits 
$memory_limit = mem2bytes(ini_get('memory_limit')); 


/** define tbl names */ 
$tbl_name_db    = $system['prefix'].'_search_db'; 
$tbl_name_tmp   = $system['prefix'].'_search_tmp'; 
$tbl_name_link  = $system['prefix'].'_links'; 

/** define spider urls and params */ 
$stop_dirs  = pre_preg(unserialize(stripslashes($config['stop_dirs'])), "", "\/"); 
$stop_files = pre_preg(unserialize(stripslashes($config['stop_files']))); 
$allow_ext  = explode(",", $config['allow_ext']); 
/** indexing **/ 
if ($config['enable_pdf']) { 
    $allow_ext[] = 'pdf'; 
} if ($config['enable_rtf']) { 
    $allow_ext[] = 'rtf'; 
} if ($config['enable_doc']) { 
    $allow_ext[] = 'doc'; 
    $allow_ext[] = 'docx'; 
} if ($config['enable_xls']) { 
    $allow_ext[] = 'xls'; 
}  
$allow_ext  = pre_preg($allow_ext, "\.", "$"); 

if (!isset($groups_spider)) { 
    if (!isset($_GET['groups'])) { 
        $groups_spider = 0; 
    } else { 
        $groups_spider = $_GET['groups']; 
    } 
} 

$groups = $groups_urls = $start_urls = $allow_urls = array(); 
$res = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `{$system['prefix']}_groups`"); 
while ($row = mysqli_fetch_assoc($res)) { 
    if ($groups_spider == 0 || in_array($row['id'], explode(',', $groups_spider))) { 
        $start_urls = array_merge($start_urls, unserialize(stripslashes($row['start_urls']))); 
        $allow_urls = array_merge($allow_urls, unserialize(stripslashes($row['allow_urls']))); 
    } 
     
    $groups[$row['id']] = $row; 
    foreach (unserialize(stripslashes($row['allow_urls'])) as $url) { 
        $groups_urls[] = array('id'=>$row['id'], 'url'=>$url); 
    } 
}

$inoutdb    = array(); 

/** 
 * regular transformation 
 * @param  array  $array  the array 
 * @param  string $start  the start string 
 * @param  string $finish the finish string 
 * @return string 
 */ 
function pre_preg ($array, $start = "", $finish = "") 
{ 
    $ret = $start."("; 
    $count = count($array); $i = 0; 
    foreach ($array as $value) { 
        $i ++; 
        $value = quotemeta($value); 
        $value = str_replace('\*', '.*', $value); 
        if ($count > $i) $ret .= $value."|"; 
        else $ret .= $value; 
    } 
    return $ret.")".$finish; 
} 

/** 
 * @return void 
 * @desc start spidering 
*/ 
 $to_visit = $visited = array(); 

function to_visit($url,$key) 
{ 
 global $tbl_name_link, $mysqli_version; 

  
    $match = explode('.', $mysqli_version); 
    if (!isset($match[0])) { 
        $match[0] = 3; 
    } 
    if (!isset($match[1])) { 
        $match[1] = 23; 
    } 
    if (!isset($match[2])) { 
        $match[2] = 32; 
    } 
    $mysqli_int_version = (int)sprintf('%d%02d%02d', $match[0], $match[1], intval($match[2])); 
    if ($mysqli_int_version >= 40100) { 
      mysqli_query($GLOBALS["___mysqli_ston"], 'INSERT INTO '.$tbl_name_link.' SET path=\''.$url.'\',to_visit='.$key.' ON DUPLICATE KEY UPDATE path=\''.$url.'\',to_visit='.$key); 
    } else { 
      $res = mysqli_query($GLOBALS["___mysqli_ston"], 'SELECT count(*) FROM '.$tbl_name_link.' WHERE path=\''.$url.'\''); 
      $res_mas = mysqli_fetch_row($res); 
      if($res_mas[0] == 0){ 
       mysqli_query($GLOBALS["___mysqli_ston"], 'INSERT INTO '.$tbl_name_link.' SET path=\''.$url.'\',to_visit='.$key);        
      }else{ 
       mysqli_query($GLOBALS["___mysqli_ston"], 'UPDATE '.$tbl_name_link.' SET to_visit='.$key.' WHERE path=\''.$url.'\'');       
      } 
    } 

} 

function visited($url) 
{ 
 global $tbl_name_link; 

 $res = mysqli_query($GLOBALS["___mysqli_ston"], 'SELECT COUNT(*) FROM '.$tbl_name_link.' WHERE path=\''.$url.'\' AND to_visit=0'); 
 $res_mas = mysqli_fetch_row($res); 
 if($res_mas[0]==1){ 
  return 'visited'; 
 }else{ 
  $res = mysqli_query($GLOBALS["___mysqli_ston"], 'SELECT COUNT(*) FROM '.$tbl_name_link.' WHERE path=\''.$url.'\' AND to_visit=1'); 
  $res_mas = mysqli_fetch_row($res); 
  if($res_mas[0]==1){ 
   return 'not visited'; 
  }else{ 
   return 'not present'; 
  } 
 } 
} 

function act_links_count() 
{ 
 global $tbl_name_link; 
  
 $res = mysqli_query($GLOBALS["___mysqli_ston"], 'SELECT COUNT(*) FROM '.$tbl_name_link.' WHERE to_visit=1'); 
 $res_mas = mysqli_fetch_row($res); 
 return $res_mas[0]; 
}                        

function get_next_link() 
{ 
 global $tbl_name_link; 
  
 $res = mysqli_query($GLOBALS["___mysqli_ston"], 'SELECT path FROM '.$tbl_name_link.' WHERE to_visit=1 LIMIT 1'); 
 $res_mas = mysqli_fetch_row($res); 
 return $res_mas[0]; 
} 
                                    


function start_spidering () 
{ 
    global $start_urls, $allow_urls, $debug, $i18n; 
    global $to_visit, $visited; 


    print date("h:i:s")."<br>"; 

    $current_link = 1; 

    foreach ($start_urls as $url) { 
        to_visit($url,1); 
    } 
    $i = 0; 
      while (act_links_count() >0) { 
        $url = get_next_link();

        // Debug
        $loader = new UrlLoader($url);
        to_visit($url,0); 
        if ($loader->getError()) {
            if ($debug) { 
                print '<b>'.$i18n['spider']['error_open_url'].': '.$url.'</b><br>'."\n"; 
            } 
            to_visit($url,0); 
        } else { 
            $location_url   = false; 
            $last_modified  = date("Y-m-d");
            if ($loader->getHeader('location')) {
                $location_url = $loader->getHeader('location');
            }
            if ($loader->getHeader('last-modified')) {
                $last_modified = date("Y-m-d", $loader->getHeader('last-modified'));
            }

            /** if page location */ 
            if ($location_url) { 
                $location_url           = get_absolute_url($url, $location_url); 
                $location_url           = preg_replace("/#.*/", "", $location_url); 
                $location_url_stripped  = preg_replace("/\?.*/", "", $location_url); 
                if (check_url($location_url_stripped)) { 
                    if(visited($location_url)=='not present') { 
                        to_visit($location_url,1); 
                    } 
                }
                to_visit($url,0);
            } else {
                $data = $loader->getContent();
                $base = $url; 
                 
                if (preg_match_all("/<base\\s+href=([\"']?)([^\\s\"'>]+)\\1/is", $data, $matches, PREG_SET_ORDER)) { 
                    $base = $matches[0][2]; 
                } 
                $links = get_links($data); 
                foreach ($links as $k => $v) { 
                    $link           = get_absolute_url($base, $k); 
                    $link           = preg_replace("/#.*/", "", $link); 
                    $link_stripped  = preg_replace("/\?.*/", "", $link); 
                     
                    if (check_url($link_stripped)) { 
                        if(visited($link)=='not present') { 
                            to_visit($link,1); 
                        } 
                    } 
                } 
                 
                 index_file($data, $url, $last_modified, $current_link); 
                 $current_link++; 
                 $i++;
                to_visit($url,0);
            }
        } 
         
    } /** while */ 
    print date("h:i:s")."<br>"; 
} 

/** 
 * Get links 
 * @param  string $text the html body 
 * @return array 
**/ 
function get_links($text) 
{ 
    $links = array(); 
    $count = preg_match_all("'<\s*a\s.*?href\s*=\s*([\"\'])?(?(1) (.*?)\\1 | ([^\s\>]+))'isx", $text, $matches, PREG_SET_ORDER); 
    for($i=0; $i < count($matches); $i++) { 
        $link = !empty($matches[$i][2]) ? $matches[$i][2] : $matches[$i][3]; 
        $link = preg_replace("/(\r\n|\n|\r)+/", "", $link); 
        if (!empty($link)) { 
            $links[$link] = 1; 
        } 
    } 

    $count = preg_match_all("/<frame[^>]+src=([\"']?)([^\\s\"'>]+)\\1/is", $text, $matches, PREG_SET_ORDER); 
    for($i=0; $i < count($matches); $i++) { 
        $links[$matches[$i][2]] = 1; 
    } 

    $count = preg_match_all("/<area[^>]+href=([\"']?)([^\\s\"'>]+)\\1/is", $text, $matches, PREG_SET_ORDER); 
    for($i=0; $i < count($matches); $i++) { 
        $links[$matches[$i][2]] = 1; 
    } 

    return $links; 
} 

/** 
 * Get absolute url 
 * @param  string $base the base url 
 * @param  string $url the url 
 * @return string 
**/ 
function get_absolute_url($base,$url) 
{ 
    /** delete session */ 
    $session_name = session_name(); 
    $url = preg_replace("/".$session_name."\=[a-f0-9]{32}/si", $session_name."=", $url); 
     
    if (!$url) { 
        return ""; 
    } 
     
    $url_arr = @parse_url($url); 
    if (isset($url_arr["scheme"])) { 
        return $url; 
    } 

    if ($base != "http://" && $base != "https://") { 
        $base_arr = parse_url($base); 
    } else { 
        return ""; 
    } 
     
    $base_base = strtolower($base_arr["scheme"])."://"; 
    if (isset($base_arr["user"])) { 
        $base_base .= $base_arr["user"].":".$base_arr["pass"]."@"; 
    } 
     
    $base_base .= strtolower($base_arr["host"]); 
     
    if (isset($base_arr["port"])) { 
        $base_base .= ":".$base_arr["port"]; 
    } 
     
    $base_path = @$base_arr['path']; 
     
    if ($base_path == "") { 
        $base_path = "/"; 
    } 
     
    $base_path = preg_replace("/(.*\/).*/","\\1",$base_path); 

    if (isset($url_arr['path'][0]) && $url_arr['path'][0] == chr(47)) { 
        return $base_base.$url; 
    } 

    if (preg_match("'^\./'",$url)) { 
        $url = preg_replace("'^\./'","",$url); 
        return $base_base.$base_path.$url; 
    } 

    while (preg_match("'^\.\./'", $url)) { 
        $url = preg_replace("'^\.\./'", "", $url); 
        $base_path = preg_replace("/(.*\/).*\//","\\1",$base_path); 
    } 

    return $base_base.$base_path.$url; 
} 

/** 
 * @desc   Check url 
 * @param  string $url the url 
 * @return string 
**/ 
function check_url($url) 
{ 
    global $debug, $allow_urls, $stop_dirs, $stop_files, $allow_ext, $i18n; 
     
    if (!$url) { 
        return false; 
    } 
     
    if ($debug) { 
        print $i18n['debug']['check_url']." : <b>".$url."</b>;<br />"; 
    } 
    /** check contain http:// or https:// */ 
    if (!preg_match("'^http://'",$url) && !preg_match("'^https://'",$url)) { 
        if ($debug) { 
            print "<i>".$i18n['debug']['http']."</i><br />"; 
        } 
        return false; 
    } 
    /** check allowed file ext */ 
    if (!preg_match("'{$allow_ext}'i", $url)) { 
        if (!preg_match("/(\/)$/si", $url)) { 
            if ($debug) { 
                print "<i>".$i18n['debug']['ext']."</i><br/>"; 
            } 
            return false; 
        } 
    } 
    /** check stop dirs */ 
    if ($stop_dirs != "()") { 
        if (preg_match ("'{$stop_dirs}'i", $url)) { 
            if ($debug) { 
                print "<i>".$i18n['debug']['stop_dirs']."</i><br />"; 
            } 
            return false; 
        } 
    } 
    /** check stop files */ 
    if ($stop_files != "()") { 
        if (preg_match ("'{$stop_files}'i", $url)) { 
            if ($debug) { 
                print "<i>".$i18n['debug']['stop_files']."</i><br />"; 
            } 
            return false; 
        } 
    } 
     
    $allow_this_url = false; 
    foreach ($allow_urls as $v) { 
        if (preg_match("'".$v."'i", $url)) { 
            $allow_this_url = true; 
            break; 
        } 
    } 
     
    if (!$allow_this_url) { 
        if ($debug) { 
            print '<i>'.$i18n['debug']['allow'].'</i><br />'; 
        } 
        return false; 
    } 
    return true; 
} 

/** 
 * Index file 
 * @param string $text          the file content 
 * @param string $url           the url 
 * @param string $last_modified the last_modified date 
**/ 
function index_file ($text, $url, $last_modified, $cnt) 
{ 
    global $total_size, $total_files, $inoutdb, $config, $i18n, $to_visit, $visited, $memory_limit; 
    global $tbl_name_link; 
     
    $size = strlen($text); 
    $total_files ++; 
    $total_size += $size; 
     
    $uri_parse = parse_url($url);
    $uri = $uri_parse['scheme'].'://'.$uri_parse['host'].($uri_parse['path'] ?? '/').(isset($uri_parse['query']) ? '?'.$uri_parse['query'] : '');

    $res = mysqli_query($GLOBALS["___mysqli_ston"], 'SELECT COUNT(*) FROM '.$tbl_name_link); 
    $res_mas = mysqli_fetch_row($res); 

    print $i18n['spider']['indexing'].' '.$cnt.' '.$i18n['spider']['of'].' ~'.$res_mas[0].' ... '.$uri.', '.$i18n['spider']['size'].': '.formatsize($size).'<br />'."\n"; 

    $doc_title = false; 
     
    if ($config['enable_pdf'] && preg_match("/\.pdf$/si", $url)) { 
        $text = convert_pdf2text($text, $config['path2xpdf'], $config['enable_pdf_int']); 
    } if ($config['enable_rtf'] && preg_match("/\.rtf$/si", $url)) { 
        $text = convert_rtf2text($text); 
    } if ($config['enable_doc'] && (preg_match("/\.doc$/si", $url) || preg_match("/\.docx$/si", $url))) { 
        preg_match("/(\.\w+)$/siU",$url,$ext); 
        print $ext[1]; 
        $text = convert_doc2text($text, $config['path2antiword'], $config['enable_doc_int'], $ext[1]); 
    } if ($config['enable_xls'] && preg_match("/\.xls$/si", $url)) { 
        $text = convert_xls2text($text); 
    } 
     
    $html_text = $text; 
     
    if (preg_match("/<title>\s*(.*?)\s*<\/title>/s", $html_text, $matches)) { 
        $title = $matches[1]; 
    } else { 
        $urls = explode('/', $url); 
        $title = rawurldecode($urls[(sizeof($urls)-1)]); 
    } 
     
    if (preg_match("/\<meta[^>]\s+name=[\"|\']?description[\"|\']?\s+content=[\"|\']+?(.*)[\"|\']?/siU", $html_text, $matches)) { 
        $description = $matches[1]; 
    } else { 
        $description = ''; 
    } 
     
    $title = preg_replace("/\s+/", " ", $title); 

    $html_text = preg_replace("/<!--.*?-->/s"," ",$html_text); 
    $html_text = preg_replace("/<[Nn][Oo][Ii][Nn][Dd][Ee][Xx].*?<\/[Nn][Oo][Ii][Nn][Dd][Ee][Xx]>/s"," ",$html_text); 
    $html_text = preg_replace("/<[Ss][Cc][Rr][Ii][Pp][Tt].*?<\/[Ss][Cc][Rr][Ii][Pp][Tt]>/s"," ",$html_text); 
    $html_text = preg_replace("/<[Ss][Tt][Yy][Ll][Ee].*?<\/[Ss][Tt][Yy][Ll][Ee]>/s"," ",$html_text); 
    $html_text = preg_replace("/<[^>]*>/s", " ", $html_text); 
    $html_text = preg_replace("/&nbsp;+/s", " ", $html_text); 
    $html_text = preg_replace("/\s+/s", " ", $html_text); 
         
    $html_text = preg_replace("/".html_entity_decode('&#'."49847".';',ENT_NOQUOTES,'UTF-8')."/","", $html_text); 
    $html_text = preg_replace("/".chr(250)."/","", $html_text); 
    $html_text = preg_replace("/\x95/iU","",$html_text); 


    $html_text = strtolower($html_text);
     
    if ((sizeof($inoutdb) > 99) || (memory_get_usage() > ($memory_limit*0.75))) { 
        $inoutdb = write2db($inoutdb); 
        $inoutdb = null; 
        unset($inoutdb); 
    } 
     
    $inoutdb[] = array( 
    'url'           => $uri,
    'title'         => $title, 
    'description'   => $description, 
    'size'          => $size, 
    'date'          => $last_modified ? $last_modified : date("Y-m-d"), 
    'text'          => $html_text 
    );
} 

/** 
 * Write content to tempolary db 
 * @param  array $inoutdb the pages data array 
 * @return array 
 **/ 
function write2db ($inoutdb) 
{ 
    global $tbl_name_tmp, $groups_urls, $debug; 
     
    foreach ($inoutdb as $key => $value) { 
        $groups = array(); 
        foreach ($groups_urls as $url) { 
            if (preg_match("'".$url['url']."'i", $value['url'])) { 
                $groups[] = $url['id']; 
            } 
        } 
        $groups = array_unique($groups); 
        $grp = join(',', $groups); 
         
        mysqli_query($GLOBALS["___mysqli_ston"], "INSERT INTO `{$tbl_name_tmp}` VALUES(null,'".addslashes($value['url'])."','{$grp}','".addslashes(stripslashes($value['title']))."','".addslashes(stripslashes($value['description']))."','{$value['size']}','{$value['date']}','".addslashes(stripslashes($value['text']))."')");
         
        if ($debug && ((is_object($GLOBALS["___mysqli_ston"])) ? mysqli_errno($GLOBALS["___mysqli_ston"]) : (($___mysqli_res = mysqli_connect_errno()) ? $___mysqli_res : false))) { 
            echo ((is_object($GLOBALS["___mysqli_ston"])) ? mysqli_error($GLOBALS["___mysqli_ston"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)).'<br>'; 
        } 
    } 
     
    if (file_exists(SSP_DIR.'/data/stop.php')) { 
        @unlink(SSP_DIR.'/data/stop.php'); 
        exit; 
    } 
     
    return array(); 
} 

/** print header */ 
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"> 
<html><head><title>'.$i18n['spider']['title'].'</title> 
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"> 
<link href="styles.css" rel="stylesheet" type="text/css"> 
<style type="text/css">body {background-color:#FFFFFF;padding:0px;margin:0px;}</style> 
</head><body>'; 

/** if ! another process */ 
if (!$process) { 
    if (file_exists(SSP_DIR.'/data/stop.php')) { 
        @unlink(SSP_DIR.'/data/stop.php'); 
        clearstatcache(); 
    } 

    /** Check MySQL Version */ 
    $mysqli_version = ((is_null($___mysqli_res = mysqli_get_server_info($GLOBALS["___mysqli_ston"]))) ? false : $___mysqli_res); 
    if (!$mysqli_version) { 
        $mysqli_version = '3.23.32'; 
    } 


     
    /** truncate tmp table */ 
    mysqli_query($GLOBALS["___mysqli_ston"], "TRUNCATE TABLE `{$tbl_name_tmp}`"); 
    mysqli_query($GLOBALS["___mysqli_ston"], "TRUNCATE TABLE `{$tbl_name_link}`"); 

    /** start spidering */ 
    start_spidering(); 
     
    write2db($inoutdb); 
     
    if ($groups_spider == 0) { 
        /** truncate db table */ 
        mysqli_query($GLOBALS["___mysqli_ston"], "TRUNCATE TABLE `{$tbl_name_db}`"); 
        mysqli_query($GLOBALS["___mysqli_ston"], "TRUNCATE TABLE `{$tbl_name_link}`"); 
    } else { 
        $groups_vars = explode(',', $groups_spider); 
        $sql_groups = array(); 
        foreach ($groups_vars as $group_id) { 
            $sql_groups[] = '(^'.$group_id.',|^'.$group_id.'$|,'.$group_id.',|,'.$group_id.'$)'; 
        } 
        if (sizeof($sql_groups) == 1) { 
            $sql_regexp = join('|', $sql_groups); 
        } else { 
            $sql_regexp = '('.join('|', $sql_groups).')'; 
        } 
        mysqli_query($GLOBALS["___mysqli_ston"], "DELETE FROM `{$tbl_name_db}` WHERE `groups` REGEXP '{$sql_regexp}'"); 
    } 
     
    $previous_url = ''; 
    $res = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `{$tbl_name_tmp}` ORDER BY `url`"); 
    while ($row = mysqli_fetch_assoc($res)) { 
        if ($previous_url != $row['url'] && $previous_url.'/' != $row['url'] && $previous_url != $row['url'].'/') { 
            unset($row['id']); 
            $row['url']         = addslashes(stripslashes($row['url'])); 
            $row['title']       = addslashes(stripslashes($row['title'])); 
            $row['description'] = addslashes(stripslashes($row['description'])); 
            $row['text']        = addslashes(stripslashes($row['text'])); 
            $row['ignore']      = 0; 
             
            mysqli_query($GLOBALS["___mysqli_ston"], "INSERT INTO `{$tbl_name_db}` SET ".array2sql($row)); 
        } 
        $previous_url = $row['url']; 
    } 
    /** truncate tmp table */ 
    mysqli_query($GLOBALS["___mysqli_ston"], "TRUNCATE TABLE `{$tbl_name_tmp}`"); 
    mysqli_query($GLOBALS["___mysqli_ston"], "TRUNCATE TABLE `{$tbl_name_link}`"); 

    /** optimize db table */ 
    mysqli_query($GLOBALS["___mysqli_ston"], "OPTIMIZE TABLE `{$tbl_name_db}`"); 
         
    $res_cnt = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT COUNT(*) AS `total_files`, SUM(`size`) AS `total_size` FROM `{$tbl_name_db}`"); 
    $row_cnt = mysqli_fetch_assoc($res_cnt); 
    $total_files = (int)$row_cnt['total_files']; 
    $total_size  = (int)$row_cnt['total_size']; 
     
    /** unlink process file */ 
    @unlink(SSP_DIR.'/data/pid.php'); 
} 

/** finish */ 
$mtime  = microtime(); 
$mtime  = explode(" ",$mtime); 
$indexer_time = round((($mtime[1] + $mtime[0]) - $tstart)); 

if (!$process) { 
    /** print result */ 
    print '<p class=\"true\">'.$i18n['spider']['update'].', '.$i18n['spider']['search'].'</p> 
<p><span class="false">'.$i18n['spider']['statistics'].':</span><br /><br /> 
'.$i18n['spider']['size'].': <strong>'.formatsize($total_size).'</strong><br /> 
'.$i18n['spider']['files'].': <strong>'.$total_files.'</strong><br />'; 
    if (isset($_GET['admin']) && $_GET['admin'] == 'true') { 
        print '<script language="javascript">if (top.window != "undefined") top.window.endSpidering();</script>'; 
    } 
} else { 
    print '<p><span class="false">'.$i18n['spider']['isset_pid'].'</span></p>'; 
} 

/** print footer */ 
print $i18n['spider']['time'].': <strong>'.$indexer_time.'</strong> second</p></body></html>'; 

?>